<?php

namespace App\Http\Controllers;

use Illuminate\Hashing\BcryptHasher;
use Illuminate\Support\Facades\Validator;
use Illuminate\Http\Request;
use App\ClBranche;


class ClBrancheController extends Controller
{


public function showAllBranches()
    {
        return response()->json(ClBranche::all());
    }

    public function showOneBranch($id)
    {
        return response()->json(ClBranche::find($id));
    }

    public function create(Request $request)
    {
        //creating a validator
        $validator = Validator::make($request->all(), [
            'branch_name' => 'required|unique:cl_branches,title',
            'branch_code' => 'required|unique:cl_branches',
        ]);

        //if validation fails
        if ($validator->fails()) {
            return array(
                'error' => true,
                'message' => $validator->errors()->all()
            );
        }

        //creating a new branch
        $branch = new ClBranche();
        //return $request->all();
        //adding values to the branch table
        // $request->request->add(['branch_name'=>$request->title]);
        // return $request->all();
        $branch->title = $request->branch_name;
        $branch->branch_code = $request->branch_code;
        $branch->fullname = $request->branch_full_name;
        $branch->status = $request->branch_status;
        //saving the branch to database
        $branch->save();

        //returning the added branch
        return array('error' => false, 'branch' => 'Branch added successfully');
    }

    public function update(Request $request)
    {
         return response()->json(['validate'=>$request->all()]);
         $request->request->add(['title'=>$request->branch_name,'fullname'=>$request->branch_full_name,'status'=>$request->branch_status]);
         $branch = ClBranche::findOrFail($request->branch_id);
         $branch->update($request->all());
         return response()->json(['validate'=>200,'branch' => 'Branch updated successfully']);
    }

    public function delete($id)
    {
        ClBranche::findOrFail($id)->delete();
        return response('Deleted Successfully', 200);
    }

}