<?php

namespace App\Http\Controllers;

use Illuminate\Support\Facades\Validator;
use Illuminate\Http\Request;
use App\Pricegroups; //import pricegroup model 
use Carbon\Carbon;
class PricegroupController extends Controller
{


    public function create(Request $request){
       // return $request;
		$validator = Validator::make($request->all(), [
			'name' => 'required',
			'ounce' => 'required_with:ounce_check|numeric',
			'globule' => 'required_with:globule_check|numeric',
			'powder' => 'required_with:powder_check|numeric',
			'liquid' => 'required_with:liquid_check|numeric'
		]);

        //if validation fails
        if ($validator->fails()) {
            return array(
                'error' => true,
                'message' => $validator->errors()
            );
        }
        
        //creating a new PriceGroup model object
        $pricegroup = new Pricegroups();

        $pricegroup->name = $request->name;
        $pricegroup->ounce = $request->ounce;
		$pricegroup->globule = $request->globule;
		$pricegroup->powder = $request->powder;
        $pricegroup->liquid = $request->liquid;

        //this below condition block is used for update records in datbase 
        if((isset($request->id)) && ($request->id > 0)) {
            //return $request->id;
            $item = $pricegroup->findOrFail($request->id)->where('status','!=',0);
            if($item){
				$modification_date =  Carbon::now();
                $pricegroup->where('id', $request->id)->update(['name'=>$pricegroup->name,'ounce'=>$pricegroup->ounce,'globule'=>$pricegroup->globule,'powder'=>$pricegroup->powder,'liquid'=> $pricegroup->liquid,'modification_date'=>$modification_date]);
               // return $item;
                return array('error' => false, 'pricegroup' => 'Price Group Updated successfully');
            }
        }

        //saving the branch to database
        $pricegroup->save();
        //returning the added branch
        return array('error' => false, 'pricegroup' => 'Price Group added successfully');
        }
    public function getRecords($id='',Request $request){
        //return $request->search;
        $pricegroup = new Pricegroups();
        if($id > 0){
            return $pricegroup->find($id);
        }

       if($request->has('search')){
           return $pricegroup->where('name', 'LIKE', '%' . $request->search . '%')->paginate(10);
        }
        return $pricegroup->where('status','!=',0)->paginate(10);
    }

    public function deleteRecords($id=''){
        // return  $id;
      $pricegroup = new Pricegroups();
      $pricegroup->where('id', $id)->update(['status'=>0]);
      return array('error' => false, 'pricegroup' => 'Price Group Deleted successfully');
      //;
  }
}