<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class Patients extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('patients', function(Blueprint $table)
        {
            $table->char('id', 36)->primary();
            $table->string('Prefix', 10);
            $table->integer('registration_number');
            $table->string('Suffix', 10);
            $table->integer('title');
            $table->binary('first_name');
            $table->binary('middle_name');
            $table->binary('last_name');
            $table->char('gender', 1);
            $table->binary('phone_res', 50);
            $table->binary('mobile_res', 50);
            $table->binary('phone_office', 50);
            $table->binary('mobile_office', 50);
            $table->binary('address_per', 600);
            $table->binary('address_res', 600);
            $table->binary('full_address_per', 600);
            $table->binary('full_address_res', 600);
            $table->integer('city_id_per');
            $table->integer('state_id_per');
            $table->integer('country_id_per');
            $table->integer('city_id_res');
            $table->integer('state_id_res');
            $table->integer('country_id_res');
            $table->string('pincode_per', 10);
            $table->string('pincode_res', 10);
            $table->string('is_registered')->default('1');
            $table->dateTime('OldRegistrationDate');
            $table->string('OldRegNoPrefix', 5);
            $table->string('OldRegNosuffix', 5);
            $table->string('OldRegistrationNo', 20);
            $table->string('mode');
            $table->binary('note', 500);
            $table->string('priority', 50);
            $table->string('category', 50);
			$table->integer('discount_category');
            $table->dateTime('creation_date');
            $table->string('created_by', 10);
            $table->dateTime('modification_date');
            $table->string('modified_by', 10);
            $table->string('status')->default('1');
            $table->string('title_prefix', 10);
            $table->date('date_of_birth')->nullable();
            $table->integer('age_years')->nullable();
            $table->integer('age_months')->nullable();
            $table->integer('age_days')->nullable();
            $table->integer('verified')->default(0);
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::drop('patients');
    }
}
