<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class DiscountCategory extends Migration
{
	/**
	 * Run the migrations.
	 *
	 * @return void
	 */
	public function up()
	{
		Schema::create('discount_categories', function (Blueprint $table) {
			$table->increments('id');
			$table->string('title', 250);
			$table->text('description');
			$table->integer('created_by');
			$table->timestamp('creation_date_on');
			$table->integer('modified_by');
			$table->timestamp('modification_date');
			$table->enum('status', ['0', '1', '2'])->default(1);
		});
	}

	/**
	 * Reverse the migrations.
	 *
	 * @return void
	 */
	public function down()
	{
		Schema::dropIfExists('discount_categories');
	}
}
