<?php
namespace App\Modules\Mixmedicine\Http\Controllers;
use Illuminate\Http\Request;
use App\Http\Requests;
use App\Http\Controllers\Controller;
use Illuminate\Validation\ValidationException;
use Illuminate\Support\Facades\Validator;
use App\Modules\Mixmedicine\Models\Medicinemix;
use App\Modules\Mixmedicine\Models\Medicinemixvariant;
use Carbon\Carbon;
use Illuminate\Support\Facades\DB;

class MedicinemixController extends Controller
{
      // action function is used for medicine and potency name show 
      public function action(Request $request) 
        { 
           $query = $request->get('query');
            if(!empty($query)){
               $medicinesearch_list = DB::table('medicinegrouppotencies as mgp')->select('p.name as potencyname','m.name as medicineName','mgp.potency_id as potenId','mgp.medicine_id as medId')
                        ->LeftJoin('medicines as m', 'm.id', '=', 'mgp.medicine_id')
                        ->LeftJoin('potencies as p', 'p.id', '=', 'mgp.potency_id')
                        ->where('m.name', 'LIKE', '%'.$query.'%')
                        ->where('m.status','=', '1')
                        ->where('p.status','=', '1')
                        ->get();
                        $output ='';
                        $count = count($medicinesearch_list);
                        $output.='<ul class="medicine-list">';
                        if($count>0){
                            foreach ($medicinesearch_list as $data_list)
                            {
                              
                              $output.= '<li class="formdata" data-med="'.$data_list->medId.'" data-poten="'.$data_list->potenId.'">'.$data_list->medicineName.','.' '.$data_list->potencyname.'</li>';
                            
                            }
                         }else{
                              $output.= '<li>No medicine found </li>';
                        }
                        $output.= '</ul>';
                        
              //return Response($output);
              return response()->json($output);

          }
        }

    // formlist function is used for medicine and potency name show 
    public function getFormListDropdown($id='', Request $request){
      if($id>0){
        $formdropdown_list = DB::table('medicinemix as mx')->select('mxv.mixMedicineId as mxId','mxv.mixPotencyId as mpId')
        ->LeftJoin('medicinemixvariant as mxv', 'mxv.medicinemixId', '=', 'mx.id')->where('mx.id', $id)->where('mx.status','=','1')->get();
          foreach($formdropdown_list as $form_details){
            $form_list = DB::table('medicinegrouppotencies as mgp')->select('pg.form_code as fcode','mgpf.group_id as gId','pg.form_name as fname')
            ->LeftJoin('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
            //->join('forms as f', 'f.id', '=', 'mgpf.form_id')
            ->LeftJoin("pricegrouprates as pg",function($join){
              $join->on("pg.pricegroup_id","=","mgpf.group_id")
                  ->on("pg.form_code","=","mgpf.form_code");
              })
            ->where('mgp.potency_id', $form_details->mpId)
            ->where('mgp.medicine_id', $form_details->mxId)
            ->where('pg.status','=','1')
            ->distinct()
            ->get();
            return response()->json($form_list);
          //   echo '<pre>';
          //  print_r($formdropdown_list);
          }
      }
      /* single medicine form */
      if(!empty($request->potency) && !empty($request->medicine)){
        $formdropdown_list = DB::table('medicinegrouppotencies as mgp')->select('pg.form_code as fcode','mgpf.group_id as gId','pg.form_name as fname')
        ->LeftJoin('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
        ->LeftJoin("pricegrouprates as pg",function($join){
          $join->on("pg.pricegroup_id","=","mgpf.group_id")
              ->on("pg.form_code","=","mgpf.form_code");
          })
        ->where('mgp.medicine_id', $request->medicine)
        ->where('mgp.potency_id', $request->potency)
        ->where('pg.status','=','1')
        ->orderBy('pg.form_code', 'asc')
        ->distinct()
        ->get();
        return response()->json($formdropdown_list);
        // echo '<pre>';
        // print_r($formdropdown_list);
      }
      /* Mix medicine form */
       if(empty($request->potency) && !empty($request->medicine)){
        $mix_formdropdown_list= DB::table('medicinemix as mm')->select('mmv.medicineMixFormGroupId as gId','mmv.medicineMixFormCode as fcode','mmv.medicineMixFormName as fname')
        ->LeftJoin('medicinemixvariant as mmv', 'mmv.medicinemixId', '=', 'mm.id')
        ->LeftJoin("pricegrouprates as pg",function($join){
          $join->on("pg.pricegroup_id","=","mmv.medicineMixFormGroupId")
              ->on("pg.form_code","=","mmv.medicineMixFormCode");
          })
        ->where('mm.status', '1')
        ->where('mmv.status', '1')
        ->where('pg.status', '1')
        ->orderBy('pg.rate', 'desc')
        ->where('mm.id', $request->medicine)
        ->distinct()
        ->first();
        return response()->json($mix_formdropdown_list);
        // echo '<pre>';
        // print_r($formdropdown_list);
      }
  }
public function create(Request $request){
      $validator = Validator::make($request->all(), [
        'mix_medicine_name' => 'required',
        'status' => 'required'
      ]);
      //if validation fails
      if ($validator->fails()) {
        return array(
          'error' => true,
          'message' => $validator->errors()
        );
      }
try{
  $medicinemix = new Medicinemix();
  $medicinemixvariant = new Medicinemixvariant();
  $medicinemix->medicineMixName = $request->mix_medicine_name;
  // $medicinemix->pharmacy_instruction = $request->pharmacy_instruction;
  $medicinemix->status = $request->status;
  
  //this below conditional block is used for update records in database 
  $modification_date =  Carbon::now('Asia/Kolkata');
     if((isset($request->id)) && ($request->id > 0) && ($request->medicine_mixture)  && ($request->medicine_mixture_form)){
        try{
          if(!empty($request->medicine_mixture) && count($request->medicine_mixture)>=2 && count($request->medicine_mixture_form)>=2){
            Medicinemixvariant::where('medicinemixId', $request->id)->delete();

                for($i=0; $i<count($request->medicine_mixture); $i++){
                  $list_array = explode('-', $request->medicine_mixture_form[$i]);
                  $group_id = $list_array[0];
                  $form_code = $list_array[1];
                  $form_name = $list_array[2];
                  Medicinemixvariant::create(['medicinemixtureName' => $request->medicine_mixture[$i],'medicineMixFormGroupId'=>$group_id,'medicineMixFormCode'=>$form_code,'medicineMixFormName'=>$form_name,'mixMedicineId'=>$request->mixture_medicine_id[$i], 'mixPotencyId'=>$request->mixture_potency_form_id[$i], 'medicinemixId'=>$request->id]);
                
                }

              //for Mix Medicine data
              $item = $medicinemix->findOrFail($request->id);
                if($item){
                  $medicinemix->where('id', $request->id)->update(['medicineMixName'=>$medicinemix->medicineMixName, 'status'=>$medicinemix->status, 'modification_date'=>$modification_date]);
                  $res['error'] = false;
                  $res['actions'] = 'update';
                  return response($res, 200);
                }

              }else{
                $res['error'] = 'atleasttwomedicine';
                return response($res, 200);
            }
          }catch(\Illuminate\Database\QueryException $ex){
            $res['status'] = false;
            $res['message'] = $ex->getMessage();
            return response($res, 500);
          } 	
        }else{
          
            if(!empty($request->medicine_mixture) && count($request->medicine_mixture)>=2 && count($request->medicine_mixture_form)>=2)
              {
                $medicinemix->save();
                //last inserted id of medicine table row
                 $medicinemix_id =  $medicinemix->id;
                  for($i=0; $i<count($request->medicine_mixture); $i++){
                    $list_array = explode('-', $request->medicine_mixture_form[$i]);
                    $group_id = $list_array[0];
                    $form_code = $list_array[1];
                    $form_name = $list_array[2];
                    Medicinemixvariant::create(['medicinemixtureName' => $request->medicine_mixture[$i], 'medicineMixFormGroupId'=>$group_id, 'medicineMixFormCode'=>$form_code, 'medicineMixFormName'=>$form_name, 'mixMedicineId'=>$request->mixture_medicine_id[$i], 'mixPotencyId'=>$request->mixture_potency_form_id[$i], 'medicinemixId'=>$medicinemix_id]);
                  }
                  $res['error'] = false;
                  $res['actions'] = 'add';
                  return response($res, 200);
              }else{
                  $res['error'] = 'atleasttwomedicine';
                  return response($res, 200);
              }
        }
    
    }catch(\Illuminate\Database\QueryException $ex){
      $res['status'] = false;
      $res['message'] = $ex->getMessage();
      return response($res, 500);
    } 	
 }  
     
 public function getRecords($id='',Request $request){
      /*This below condition is used for distinguish edit form request, In this case we get details of perticular medicine */
      if($id > 0){

          return Medicinemix::find($id);
      }
      return Medicinemix::where('status','!=', '0')->orderBy('id', 'DESC')->get();
    }

     //  Delete Record for particular Medicinemix id
     public function deleteRecords(Request $request)
     {
         $medicinemix = Medicinemix::findOrFail($request->mix_id);
         try{
             if($medicinemix){

                     $medicinemix->where('id', $request->mix_id)->update(['status'=>'0']);
                     $res['error'] = false;
                     return response($res, 200);
             }else{
                     $res['error'] = true;
                     return response($res, 401);
             }
         }catch(\Illuminate\Database\QueryException $ex){
             $res['status'] = false;
             $res['message'] = $ex->getMessage();
             return response($res, 500);
         }
     }

     public function mixmedicinedetails($id='', Request $request){
       if($id>0){
        $pricegroup_list = DB::table('medicinemix as m')->select('mmv.mixMedicineId as mId', 'mmv.mixPotencyId as pId', 'mmv.medicinemixtureName as mixName', 'pg.pricegroup_id as gid', 'pg.form_name as fName')
        ->LeftJoin('medicinemixvariant as mmv', 'mmv.medicinemixId', '=', 'm.id')
        ->LeftJoin("pricegrouprates as pg",function($join){
          $join->on("pg.pricegroup_id","=","mmv.medicineMixFormGroupId")
              ->on("pg.form_code","=","mmv.medicineMixFormCode");
          })
        ->where('m.id', '=', $id)
        ->where('m.status', '=', '1')
        ->where('pg.status', '=', '1')
		->Orwhere('m.status', '=', '2')
        ->get();
          return response()->json($pricegroup_list);
       }else{
          if(!empty($request->medicine_id)){

            $pricegroup_list = DB::table('medicinemix as m')->select('p.name as medicine_group_name','m.medicineMixName as mName', 'm.pharmacy_instruction as piName', 'mmv.medicinemixtureName as mixName', 'pg.form_name as fName','pg.rate as form_rate')
            ->LeftJoin('medicinemixvariant as mmv', 'mmv.medicinemixId', '=', 'm.id')
            ->LeftJoin("pricegrouprates as pg",function($join){
              $join->on("pg.pricegroup_id","=","mmv.medicineMixFormGroupId")
                  ->on("pg.form_code","=","mmv.medicineMixFormCode");
              })
            ->LeftJoin('pricegroups as p', 'p.id', '=', 'mmv.medicineMixFormGroupId')
            ->where('m.id', '=', $request->medicine_id)
            ->where('m.status', '=', '1')
            ->where('pg.status', '=', '1')
			->Orwhere('m.status', '=', '2')
            ->get();
            return response()->json($pricegroup_list);
            // echo '<pre>';
            // print_r($pricegroup_list);
            
        }
   }
  }
}
