<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateClAppointmentsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('cl_appointments', function (Blueprint $table) {
            $table->increments('id');
            $table->char('patient_id', 36);
            $table->enum('is_registered', ['0', '1'])->default('0');
            $table->char('doctor_id', 36);
            $table->integer('branch_id');
            $table->dateTime('dateTime');
            $table->integer('is_rescheduled');
            $table->text('notes');
            $table->integer('onspot')->default('0');
            $table->integer('queue_number')->nullable()->default(NULL);
            $table->integer('shift_id')->default('1');
            $table->integer('medicine_queue_number')->nullable()->default(NULL);
            $table->integer('appointment_queue_number')->nullable()->default(NULL);
            $table->integer('big_screen');
            $table->timestamp('created_at');
            $table->char('big_screen_doctor', 36);
            $table->integer('medicine_complete')->default('0');
            $table->dateTime('checkin_time')->nullable()->default(NULL);
            $table->integer('absent')->default('0');
            $table->date('current_appointment_date')->nullable()->default(NULL);
            $table->string('copyid', 256);
            $table->integer('created_by');
            $table->timestamp('creation_date');
            $table->integer('modified_by');
            $table->timestamp('modification_date');
            $table->index(['patient_id', 'branch_id', 'shift_id','copyid'], 'unique_index');
            $table->index(['patient_id', 'is_registered', 'doctor_id'], 'patient_id');
            $table->index(['doctor_id'], 'doctor_id');
            $table->index(['branch_id'], 'branch_id');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('cl_appointments');
    }
}
