<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateClDoctorRegularScheduleTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('cl_doctor_regular_schedule', function (Blueprint $table) {
            $table->increments('id');
            $table->char('doctor_id', 36);
            $table->integer('DayOfWeek');
            $table->time('StartTime');
            $table->time('EndTime');
            $table->char('shift_id', 1);
            $table->integer('branch_id');
            $table->enum('status', ['0', '1']);
            $table->char('created_by', 36);
            $table->dateTime('creation_date');
            $table->char('modified_by', 36);
            $table->dateTime('modification_date');
            $table->enum('available', ['0','1'])->default('1')->nullable();
            $table->index(['doctor_id'], 'doctor_id');
            $table->index(['DayOfWeek'], 'DayOfWeek');
            $table->index(['shift_id'], 'shift_id');
            $table->index(['branch_id'], 'branch_id');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('cl_doctor_regular_schedule');
    }
}
