<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateClPatientVisitTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('cl_patient_visit', function (Blueprint $table) {
            $table->increments('id');
            $table->char('patient_id', 36);
            $table->enum('is_registered', ['0','1'])->default('0');
            $table->string('visit_id', 10);
            $table->char('assigned_dr_1', 36)->default(NULL)->nulable();
            $table->char('assigned_dr_2', 36)->default(NULL)->nulable();
            $table->enum('visit_complete', ['0','1'])->default('0');
            $table->integer('branch_id')->default(NULL)->nulable();
            $table->integer('appointment_id')->default(NULL)->nulable();
            $table->dateTime('completed_date_time')->default(NULL)->nulable();
            $table->timestamp('assign_time_1')->default(NULL)->nulable();
            $table->timestamp('assign_time_2')->default(NULL)->nulable();
            $table->integer('movebigscreen')->default(NULL)->nulable();
            $table->string('priority', 10);
            $table->index(['assigned_dr_1', 'assigned_dr_2'], 'assigned_dr_1');
            $table->index(['assigned_dr_2'], 'assigned_dr_2');
            $table->index(['patient_id'], 'patient_id');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('cl_patient_visit');
    }
}
