<?php
require_once(CONTROLLER_PATH ."/Rest.inc.php");

class API extends REST {
	
	public $data = "";
	public $verb = "";
	public $className = "";
	public $url_elements = "";

	private $dbRead = NULL;
	private $dbWrite = NULL;

	public function __construct(){
		parent::__construct();// Init parent contructor
		$this->verb = $_SERVER['REQUEST_METHOD'];
		if(isset($_REQUEST['requestUrl'])){
			$this->url_elements = explode('/', $_REQUEST['requestUrl']);
		}
		$this->dbConnect();// Initiate Database connection
	}

	//Database connection
	private function dbConnect(){
		global $config;
		$config = (object) $config;
		require_once(CLASS_PATH . "/database.php");
		$dbConnection = new DbConnect;
		$this->dbRead = $dbConnection->connectDbRead(); // For read data
		$this->dbWrite = $dbConnection->connectDbWrite(); // For write data
	}

	//Public method for access api.
	//This method dynmically call the method based on the query string
	public function processApi(){
		if(isset($_REQUEST['requestUrl'])){
			if(isset($this->url_elements[0]) && trim($this->url_elements[0]) != ''){
				$this->className = $this->url_elements[0];
			}
			
			if(file_exists(CONTROLLER_PATH . '/' . strtolower($this->className) .'Controller.php')){
					require_once(CONTROLLER_PATH . '/' . strtolower($this->className) .'Controller.php');
					$className = $this->className . 'Controller';
					$obj = new $className;
					
					if((int)method_exists($obj,'call') > 0){
						$rs = $obj->call($this->dbRead, $this->verb);
						
						if(is_bool($rs)){
							if($rs === true){
								return $this->response($this->json(array('validate' => 'true')), 200);
							} else{
								return $this->response($this->json(array('validate' => 'false')), 200);
							}
						} else{
							$result = array();
							if(is_array($rs)){
								$result = $rs;
							} else{
								while($row = mysqli_fetch_array($rs)){
									$result[] = $row;
								}
								$result = array('data'=>$result);
							}
						}
						// If success everythig is good send header as "OK" and return list of users in JSON format
						return $this->response($this->json($result), 200);
					} else{
						return $this->response('',404);
					}
			} else{
				return $this->response('',500);
			}
		} else{
			return $this->response('',403);
		}

	// If the method not exist with in this class, response would be "Page not found".
	}

	//Encode array into JSON
	private function json($data){
		if(is_array($data)){
			return json_encode($data);
		}
	}
}
// Initiiate Library
$api = new API;
$api->processApi();
?>