<?php
require_once(CLASS_PATH ."/log.php");
class Patient extends LogDetail{

	public function __construct() {
		date_default_timezone_set("Asia/Calcutta");
	}
	function getPatient($db,$id=null,$page=1,$limit=15,$sort="OldRegistrationNo",$order="DESC",$q=null){
		global $config;
		$config = (object) $config;
		$where = '';
		$start = 0;
		if($page!=1)
		{
			$start = (($page-1)*$limit);
		}
		$cond = '';
		if($id!=null){
			$cond = "(SELECT city_name FROM ". $config->dbprefix ."city WHERE id = city_id_per) as city_name,";
			$cond .= "(SELECT state_name FROM ". $config->dbprefix ."state WHERE id = state_id_per) as state_name,";
			$cond .= "(SELECT country_name FROM ". $config->dbprefix ."country WHERE id = country_id_per) as country_name,";
			
		}
		
		//In this below query we have added the "discount_category" in select values, Rahul Khan
    $sql = "SELECT id, blood_type, prefix,registration_number,Suffix,title ,title_prefix,AES_DECRYPT(middle_name,'".$config->salt."') as middle_name,AES_DECRYPT(first_name,'".$config->salt."') as first_name, AES_DECRYPT(last_name,'".$config->salt."') as last_name, AES_DECRYPT(phone_res,'".$config->salt."') as phone_res,AES_DECRYPT(mobile_res,'".$config->salt."') as mobile_res,AES_DECRYPT(full_address_per,'".$config->salt."') as full_address_per,AES_DECRYPT(full_address_res,'".$config->salt."') as full_address_res, AES_DECRYPT(note,'".$config->salt."') as note, city_id_per,state_id_per,country_id_per,pincode_per, is_registered,OldRegistrationDate,OldRegNoPrefix,OldRegNosuffix,OldRegistrationNo,creation_date,created_by,mode,modification_date,modified_by,status,gender,priority,category,discount_category, date_of_birth,age_years,AES_DECRYPT(email_id,'".$config->salt."') as email_id,age_months, ".$cond." age_days from ". $config->dbprefix ."patients where status = '1' ";
    if($id!=null)
    {
      $sql .= " AND id='$id'";
    }

		if($q!=null)
		{
			
			$q = TRIM(strtolower($q));
			$sql .= " AND (";
			// $sql .= " registration_number LIKE '%$q%'";
			$sql .= " OldRegistrationNo LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(first_name,'".$config->salt."') LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(last_name,'".$config->salt."') LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(middle_name,'".$config->salt."') LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(full_address_per,'".$config->salt."') LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(phone_res,'".$config->salt."') LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(mobile_res,'".$config->salt."') LIKE '%$q%'";
			$sql .= " OR CONCAT(AES_DECRYPT(first_name,'".$config->salt."'),' ', AES_DECRYPT(last_name,'".$config->salt."')) LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(phone_office,'".$config->salt."') LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(mobile_office,'".$config->salt."') LIKE '%$q%'";
			$sql .= " )";
		}
		if($sort=='first_name')
		{
			$sql .= " ORDER BY AES_DECRYPT(first_name,'".$config->salt."') ".$order." LIMIT $start,$limit ";
		}
		else {
			$sql .= " ORDER BY ".$sort." ".$order." LIMIT $start,$limit ";
		}
	//echo $sql;die;
		
		$patient_resource = mysqli_query($db,$sql);
		return $patient_resource;
	}

	function getPatientByAppointmentId($db, $appointment_id){
		global $config;
		$config = (object) $config;
		$sql_appointment_detail = "select * from ". $config->dbprefix ."appointments where id = '". $appointment_id ."'";
		$result_appointment_detail = $db->query($sql_appointment_detail);
		$row_appointment_detail = $result_appointment_detail->fetch_object();

		return $this->getPatient($db, $row_appointment_detail->patient_id);
	}

	function getPatientStats($db,$limit,$q=null){
		global $config;
		$config = (object) $config;
		$sql = 'select COUNT(*) from '. $config->dbprefix ."patients where status = '1' ";
		if($q!=null)
		{
			$sql .= " AND (";
			// $sql .= " registration_number LIKE '%$q%'";
			$sql .= " OldRegistrationNo LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(first_name,'".$config->salt."') LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(last_name,'".$config->salt."') LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(middle_name,'".$config->salt."') LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(full_address_per,'".$config->salt."') LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(phone_res,'".$config->salt."') LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(mobile_res,'".$config->salt."') LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(phone_office,'".$config->salt."') LIKE '%$q%'";
			$sql .= " OR CONCAT(AES_DECRYPT(first_name,'".$config->salt."'),' ', AES_DECRYPT(last_name,'".$config->salt."')) LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(mobile_office,'".$config->salt."') LIKE '%$q%'";
			$sql .= " )";
		}
		$result = $db->query($sql);
		$row = $result->fetch_row();
		$total_pages = ceil((int)$row[0]/$limit);
		return array("total_rows"=>(int)$row[0],"total_pages"=> $total_pages,'limit'=>$limit);

	}

	function searchPatient($db,$q,$onlyRegistrationNumber = false)
	{
		global $config;
		$config = (object) $config;
		$where = '';
		$sql = "select id,prefix,registration_number,Suffix,title ,title_prefix,date_of_birth,AES_DECRYPT(middle_name,'".$config->salt."') as middle_name,AES_DECRYPT(first_name,'".$config->salt."') as first_name, AES_DECRYPT(last_name,'".$config->salt."') as last_name, AES_DECRYPT(phone_res,'".$config->salt."') as phone_res,AES_DECRYPT(mobile_res,'$config->salt') as mobile_res,AES_DECRYPT(full_address_per,'$config->salt') as full_address_per,AES_DECRYPT(full_address_res,'$config->salt') as full_address_res, AES_DECRYPT(note,'$config->salt') as note, city_id_per,state_id_per,country_id_per,pincode_per, is_registered,OldRegistrationDate,OldRegNoPrefix,OldRegNosuffix,OldRegistrationNo,creation_date,created_by,mode,modification_date,modified_by,status,gender,priority,category from ". $config->dbprefix ."patients where status = '1' ";
		if($q!=null && $onlyRegistrationNumber == false)
		{
			$sql .= " AND (";
			// $sql .= " registration_number LIKE '%$q%'";
			$sql .= " OldRegistrationNo LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(first_name,'$config->salt') LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(last_name,'$config->salt') LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(middle_name,'$config->salt') LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(full_address_per,'$config->salt') LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(phone_res,'$config->salt') LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(mobile_res,'$config->salt') LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(phone_office,'$config->salt') LIKE '%$q%'";
			$sql .= " OR CONCAT(AES_DECRYPT(first_name,'".$config->salt."'),' ', AES_DECRYPT(last_name,'".$config->salt."')) LIKE '%$q%'";
			$sql .= " OR AES_DECRYPT(mobile_office,'$config->salt') LIKE '%$q%'";
			$sql .= " )";
		}
		else if($q!=null && $onlyRegistrationNumber == 'true')
		{
			$sql .= " AND ";
			// $sql .= " registration_number = '$q'";
			$sql .= " OldRegistrationNo = '$q'";
			$sql .= " ";
		}

		$patient_resource = mysqli_query($db,$sql);
		return $patient_resource;
	}
	function searchPatientByApptId($db,$appointment_id,$mobile_no)
	{
		global $config;
		$config = (object) $config;
		$where = '';
		$sql = "select u.id,u.prefix,u.registration_number,u.Suffix,u.title ,u.title_prefix,u.date_of_birth,AES_DECRYPT(u.middle_name,'".$config->salt."') as middle_name,AES_DECRYPT(u.first_name,'".$config->salt."') as first_name, AES_DECRYPT(u.last_name,'".$config->salt."') as last_name, AES_DECRYPT(u.phone_res,'".$config->salt."') as phone_res,AES_DECRYPT(u.mobile_res,'$config->salt') as mobile_res,AES_DECRYPT(u.full_address_per,'$config->salt') as full_address_per,AES_DECRYPT(u.full_address_res,'$config->salt') as full_address_res, AES_DECRYPT(u.note,'$config->salt') as note, u.city_id_per,u.state_id_per,u.country_id_per,u.pincode_per, u.is_registered,u.OldRegistrationDate,u.OldRegNoPrefix,u.OldRegNosuffix,u.OldRegistrationNo,u.creation_date,u.created_by,u.mode,u.modification_date,u.modified_by,u.status,u.gender,u.priority,u.category, u.verified from ". $config->dbprefix ."appointments as a LEFT JOIN ". $config->dbprefix ."patients as u on a.patient_id = u.id where u.status = '1' and cast(a.dateTime as date) = cast(now() + INTERVAL 330 minute as date) and a.id=".$appointment_id;
		
		
			$sql .= " AND (";
			$sql .= " AES_DECRYPT(u.phone_res,'$config->salt') = '$mobile_no' ";
			$sql .= " OR AES_DECRYPT(u.mobile_res,'$config->salt') = '$mobile_no' ";
			$sql .= " OR AES_DECRYPT(u.phone_office,'$config->salt') = '$mobile_no' ";
			$sql .= " OR AES_DECRYPT(u.mobile_office,'$config->salt') = '$mobile_no' ";
			$sql .= " )";
			
			$sql ="select * from cl_appointments as a LEFT JOIN cl_patients as u on a.patient_id = u.id where u.status = '1' and a.id='287267' ";
		$patient_resource = mysqli_query($db,$sql);
		return $patient_resource;
	}
	function forgotDetails($db,$first_name,$last_name,$mobile_no)
		{
			$first_name = strtolower($first_name);
			global $config;
			$config = (object) $config;
			$where = '';
			$sql = "select id,prefix,registration_number,Suffix,title ,title_prefix,date_of_birth,AES_DECRYPT(middle_name,'".$config->salt."') as middle_name,AES_DECRYPT(first_name,'".$config->salt."') as first_name, AES_DECRYPT(last_name,'".$config->salt."') as last_name, AES_DECRYPT(phone_res,'".$config->salt."') as phone_res,AES_DECRYPT(mobile_res,'$config->salt') as mobile_res,AES_DECRYPT(full_address_per,'$config->salt') as full_address_per,AES_DECRYPT(full_address_res,'$config->salt') as full_address_res, AES_DECRYPT(note,'$config->salt') as note, city_id_per,state_id_per,country_id_per,pincode_per, is_registered,OldRegistrationDate,OldRegNoPrefix,OldRegNosuffix,OldRegistrationNo,creation_date,created_by,mode,modification_date,modified_by,status,gender,priority,category from ". $config->dbprefix ."patients where status = '1' ";
			$sql .= " AND (";
			if($first_name!="")
			{
				$first_name = strtolower($first_name);
			$sql .= " AES_DECRYPT(first_name,'$config->salt') LIKE '%$first_name%'";
				}
			if($last_name!="")
			{
				if($first_name!="")
				{
					$sql .= " AND " ;
				}
				$last_name = strtolower($last_name);
				$sql .= " AES_DECRYPT(last_name,'$config->salt') LIKE '%$last_name%'";	
			}
			if($mobile_no!="")
			{
				if($first_name!="" || $last_name !="")
				{
					$sql .= " AND " ;
				}
			$sql .= "  (AES_DECRYPT(phone_res,'$config->salt') LIKE '%$mobile_no%' OR AES_DECRYPT(mobile_res,'$config->salt') LIKE '%$mobile_no%' ) " ;
			}
			$sql .= " )";
			
		$patient_resource = mysqli_query($db,$sql);
		return $patient_resource;
	}

	function registerPatient($db,$data, $bookappointment=false, $is_rescheduled=false, $reschedule_note='',$onspot=false,$medicinesOnly = '0')
	{

//return $data;
		global $config;
		$config = (object) $config;
		$where = '';
		//This below condition code is used for Normal On spot appointment
		if($onspot == true && isset($data['patient_id']))
		{
			if(isset($data['doctor_id']) && $data['doctor_id']!='')
			{
					$date_time_doctor = Date("Y-m-d H:i").":00?".$data['doctor_id'];
			}
			else {
				$date_time_doctor = Date("Y-m-d H:i").":00?Null";
			}

			require_once(CLASS_PATH . '/appointment/appointments.php');//Rahul
			$appointmentClass = new Appointment;
			$book_appointment = $appointmentClass->bookAppointment($db, $data, $date_time_doctor, 1, $data['branch_id'], false, null,'',1,$medicinesOnly);
			return $book_appointment;
		}//if patient id is set & on spot

		if($data['category']==''){
			$category = null;
		}else {
			$category = $data['category'];
		}

		if($data['state'] == 'other'){
			$state_id = $this->addState($db,$data['other_state'],$data['country']);
		}else {
			$state_id = $data['state'];
		}
		if($data['city'] == 'other'){
			$city_id = $this->addCity($db,$data['other_city'],$state_id,$data['country']);
		}else {
			$city_id = $data['city'];
		}
		//check if first_name & phone_1 already exist
		$sql_exist_check = 	 'select * from '. $config->dbprefix .'patients where ';
		$sql_exist_check .= "  AES_DECRYPT(first_name,'$config->salt') = '".strtolower($data['first_name'])."'";
		$sql_exist_check .= " AND AES_DECRYPT(last_name,'$config->salt') = '".strtolower($data['last_name'])."'";
		$sql_exist_check .= " AND AES_DECRYPT(phone_res,'$config->salt') = '".strtolower($data['phone_1'])."'";

		$check_resource = $db->query($sql_exist_check);
		if($check_resource->num_rows>0){
			return array('validate'=>false,'message'=>'Patient already exist. This name and phone number are already registered');
		}
		if(isset($data['autogenid']) && $data['autogenid']==true){
			//get new registration number
			$sql_new_id = "SELECT MAX(cast(OldRegistrationNo as UNSIGNED)) + 1 as new_id from cl_patients";
			$res_new_id = $db->query($sql_new_id);
			$row = $res_new_id->fetch_object();
			$new_id = $row->new_id;

		}else{
			$new_id = '';
		}
		// $full_address = $data['address_1']." ".$data['address_2'];
		//In this below query we have added the "discount_category" in select values, Rahul Khan 13_june_2019
		$sql_uuid = "SELECT UUID()";
		$rs_sql_uuid = mysqli_query($db, $sql_uuid);
		$uuid = mysqli_fetch_object($rs_sql_uuid);
	//$sql.=" uuid(),'".$data['mode']."',";
	$sql = "Insert into ". $config->dbprefix ."patients (id,mode,first_name,middle_name,last_name,gender,date_of_birth,age_years,age_months,age_days,blood_type,phone_res,mobile_res,full_address_per,full_address_res,city_id_per,state_id_per,country_id_per,pincode_per,priority,category,discount_category, note,created_by,OldRegistrationNo,email_id,title_prefix) values(";
	$sql.=" uuid(),'".$data['mode']."',";
	$sql.= "AES_ENCRYPT('".strtolower($data['first_name'])."','".$config->salt."'),";
	$sql.= "AES_ENCRYPT('".strtolower($data['middle_name'])."','".$config->salt."'),";
	$sql.= "AES_ENCRYPT('".strtolower($data['last_name'])."','".$config->salt."'),";
	$sql.= "'".$data['gender']."',";
	$sql.= "'".$data['date_of_birth']."',";
	$sql.= "'".$data['age_years']."',";
	$sql.= "'".$data['age_months']."',";
	$sql.= "'".$data['age_days']."',";
	$sql.= "'".$data['blood_type']."',";
	$sql.= "AES_ENCRYPT('".$data['phone_1']."','".$config->salt."'),";
	$sql.= "AES_ENCRYPT('".$data['phone_2']."','".$config->salt."'),";
	$sql.= "AES_ENCRYPT('".strtolower($data['address_1'])."','".$config->salt."'),";
	$sql.= "AES_ENCRYPT('".strtolower($data['address_2'])."','".$config->salt."'),";
	$sql .= "'".$city_id."','".$state_id."','".$data['country']."','".$data['zip']."',";
	$sql .= "'".$data['priority']."','".$category."','".$data['discount_category']."',";
	$sql.= "AES_ENCRYPT('".$data['note']."','".$config->salt."'),";
	$sql.= "'".$data['creator_id']."', ";
	$sql.= "'".$new_id."', ";
	//$sql.= "'".$data['email_id']."', ";
	$sql.= "AES_ENCRYPT('".$data['email_id']."','".$config->salt."'),";
	$sql.= "'".$data['title_prefix']."' )";
		$patient_resource = mysqli_query($db,$sql);
		$registration_number = mysqli_insert_id($db);
		//$registration_number = $uuid;
		//if($bookappointment == true){
		if($bookappointment){
			$sql_patient_id = 'select id from '. $config->dbprefix .'patients where registration_number = "'. $registration_number .'"';
			//echo $sql_patient_id;exit;
			$rs_patient_id = mysqli_query($db, $sql_patient_id);
			$patient_id = mysqli_fetch_object($rs_patient_id);
			require_once(CLASS_PATH . '/appointment/appointments.php');
			$appointmentClass = new Appointment;
			$data['patient_id'] = $patient_id->id;
			$book_appointment = $appointmentClass->bookAppointment($db, $data, $data['date_time_doctor'], 1, $data['branch_id'], $is_rescheduled, $data['appointmentId'],$reschedule_note);
			return $book_appointment;
		//} elseif($onspot == true){
		} elseif($onspot){
			if(isset($data['doctor_id']) && $data['doctor_id']!='')
			{
				$date_time_doctor = Date("Y-m-d H:i").":00?".$data['doctor_id'];
			}
			else {
				$date_time_doctor = Date("Y-m-d H:i").":00?Null";
			}
			// $date_time_doctor = Date("Y-m-d H:i").":00?Null";
 			$sql_patient_id = 'select id from '. $config->dbprefix .'patients where registration_number = "'. $registration_number .'"';
			$rs_patient_id = mysqli_query($db, $sql_patient_id);
			$patient_id = mysqli_fetch_object($rs_patient_id);
			require_once(CLASS_PATH . '/appointment/appointments.php');
			$appointmentClass = new Appointment;
			$data['patient_id'] = $patient_id->id;
			$book_appointment = $appointmentClass->bookAppointment($db, $data, $date_time_doctor, 1, $data['branch_id'], false, null,'',1);
			return $book_appointment;
		} else{
			return $patient_resource;
		}

	}


	function registerPatientKiosk($db,$data,$medicinesOnly = '0')
	{
		
		global $config;
		$config = (object) $config;
		$where = '';
		//check if first_name & phone_1 already exist
		$sql_exist_check = 	 'select * from '. $config->dbprefix .'patients where ';
		$sql_exist_check .= "  AES_DECRYPT(first_name,'$config->salt') = '".strtolower($data['first_name'])."'";
		$sql_exist_check .= " AND AES_DECRYPT(last_name,'$config->salt') = '".strtolower($data['last_name'])."'";
		 $sql_exist_check .= " AND AES_DECRYPT(phone_res,'$config->salt') = '".strtolower($data['phone_1'])."'";
// die;
		$check_resource = $db->query($sql_exist_check);
		if($check_resource->num_rows>0)
		{
			return array('validate'=>false,'message'=>'Patient already exist. This name and phone number are already registered');
		}

		if($data['state'] == 'other')
		{
			$state_id = $this->addState($db,$data['other_state'],$data['country']);
		}
		else {
			$state_id = $data['state'];
		}
		
		if($data['city'] == 'other')
		{
			$city_id = $this->addCity($db,$data['other_city'],$state_id,$data['country']);
		}
		else {
			$city_id = $data['city'];
		}
		
			//get new registration number
			// $sql_new_id = "SELECT MAX(cast(OldRegistrationNo as UNSIGNED)) + 1 as new_id from cl_patients";
			// $res_new_id = $db->query($sql_new_id);
			// $row = $res_new_id->fetch_object();
			// $new_id = $row->new_id;
			$new_id = "";

		$sql = "Insert into ". $config->dbprefix ."patients (id,mode,first_name,middle_name,last_name,gender,date_of_birth,age_years,age_months,age_days,phone_res,mobile_res, full_address_per,full_address_res,city_id_per,state_id_per,country_id_per,pincode_per,priority,category,note,created_by,OldRegistrationNo,title_prefix) values(";
		$sql.=" uuid(),'".$data['mode']."',";
		$sql.= "AES_ENCRYPT('".strtolower($data['first_name'])."','".$config->salt."'),";
		$sql.= "AES_ENCRYPT('".strtolower($data['middle_name'])."','".$config->salt."'),";
		$sql.= "AES_ENCRYPT('".strtolower($data['last_name'])."','".$config->salt."'),";
		$sql.= "'".$data['gender']."',";
		$sql.= "'".$data['date_of_birth']."',";
		$sql.= "'".$data['age_years']."',";
		$sql.= "'".$data['age_months']."',";
		$sql.= "'".$data['age_days']."',";
		$sql.= "AES_ENCRYPT('".$data['phone_1']."','".$config->salt."'),";
		$sql.= "AES_ENCRYPT('".$data['phone_2']."','".$config->salt."'),";
		$sql.= "AES_ENCRYPT('".strtolower($data['address_1'])."','".$config->salt."'),";
		$sql.= "AES_ENCRYPT('".strtolower($data['address_2'])."','".$config->salt."'),";
		$sql .= "'".$city_id."','".$state_id."','".$data['country']."','".$data['zip']."',";
		$sql .= "'".$data['priority']."','".$data['category']."',";
		$sql.= "AES_ENCRYPT('".$data['note']."','".$config->salt."'),";
		$sql.= "'".$data['creator_id']."', ";
		$sql.= "'".$new_id."', ";
		$sql.= "'".$data['title_prefix']."' )";

		$patient_resource = mysqli_query($db,$sql);
		if($patient_resource)
		{
			$registration_number = mysqli_insert_id($db);
			$patient_id_sql = 	 'select id from '. $config->dbprefix .'patients where registration_number = '.$registration_number;
			$patient_query = $db->query($patient_id_sql);
			$patient = $patient_query->fetch_object();
			
			return array("validate"=>true,'patient_id'=>$patient->id);
		}
		else
		{
			return false;
		}
		
		

	}
	function verifyPatientKiosk($db,$data)
	{
		
		global $config;
		$config = (object) $config;
		$where = '';
		
		if($data['state'] == 'other')
		{
			$state_id = $this->addState($db,$data['other_state'],$data['country']);
		}
		else {
			$state_id = $data['state'];
		}
		
		if($data['city'] == 'other')
		{
			$city_id = $this->addCity($db,$data['other_city'],$state_id,$data['country']);
		}
		else {
			$city_id = $data['city'];
		}
		
			//get new registration number
			// $sql_new_id = "SELECT MAX(cast(OldRegistrationNo as UNSIGNED)) + 1 as new_id from cl_patients";
			// $res_new_id = $db->query($sql_new_id);
			// $row = $res_new_id->fetch_object();
			// $new_id = $row->new_id;
			// $new_id = "";

		$sql = "Update  ". $config->dbprefix ."patients SET";
		$sql.=" mode='".$data['mode']."',";
		$sql.= "first_name=AES_ENCRYPT('".strtolower($data['first_name'])."','".$config->salt."'),";
		$sql.= "middle_name=AES_ENCRYPT('".strtolower($data['middle_name'])."','".$config->salt."'),";
		$sql.= "last_name=AES_ENCRYPT('".strtolower($data['last_name'])."','".$config->salt."'),";
		$sql.= "gender='".$data['gender']."',";
		$sql.= "date_of_birth='".$data['date_of_birth']."',";
		$sql.= "age_years='".$data['age_years']."',";
		$sql.= "age_months='".$data['age_months']."',";
		$sql.= "age_days='".$data['age_days']."',";
		$sql.= "phone_res=AES_ENCRYPT('".$data['phone_1']."','".$config->salt."'),";
		$sql.= "mobile_res=AES_ENCRYPT('".$data['phone_2']."','".$config->salt."'),";
		$sql.= "full_address_per=AES_ENCRYPT('".strtolower($data['address_1'])."','".$config->salt."'),";
		$sql.= "full_address_res=AES_ENCRYPT('".strtolower($data['address_2'])."','".$config->salt."'),";
		$sql .= "city_id_per='".$city_id."',state_id_per='".$state_id."',country_id_per='".$data['country']."',pincode_per='".$data['zip']."',";
		$sql .= "priority='".$data['priority']."',category='".$data['category']."',";
		$sql.= "note=AES_ENCRYPT('".$data['note']."','".$config->salt."'),";
		 $sql.= "verified=1 WHERE registration_number = ".$data['registration_number'];
		
		$patient_resource = mysqli_query($db,$sql);
		if($patient_resource)
		{
			$registration_number = mysqli_insert_id($db);
			$patient_id_sql = 	 'select id from '. $config->dbprefix .'patients where registration_number = '.$data['registration_number'];
			$patient_query = $db->query($patient_id_sql);
			$patient = $patient_query->fetch_object();
			
			return array("validate"=>true,'patient_id'=>$patient->id);
		}
		else
		{
			return false;
		}
		
		

	}

	function getCityDetails($db,$name)
	{
		global $config;
		$config = (object) $config;
		$sql = 'select * from '. $config->dbprefix ."city where status = '1' AND city_name LIKE '%$name%'";
		$result = $db->query($sql);
		$row = $result->fetch_object();
		return $row;
	}

	function updatePatient($db,$data,$id,$bookappointment=false,$is_rescheduled=false,$reschedule_note='')
	{
		//return $data;
		$note= mysqli_real_escape_string($db,$data['note']);
		$address_1= mysqli_real_escape_string($db,$data['address_1']);
		$address_2= mysqli_real_escape_string($db,$data['address_2']);
		
		
		if($data['category']=='')
		{
			$category = null;
		}
		else {
			$category = $data['category'];
		}

		if($data['state'] == 'other')
		{
			$state_id = $this->addState($db,$data['other_state'],$data['country']);
		}
		else {
			$state_id = $data['state'];
		}
		if($data['city'] == 'other')
		{
			$city_id = $this->addCity($db,$data['other_city'],$state_id,$data['country']);
		}
		else {
			$city_id = $data['city'];
		}
		//print_r($data['other_state']);exit;
		$date_time_doctor = $data['date_time_doctor'];
		$full_date_doctor = explode('?',$date_time_doctor);
		$date_time = trim($full_date_doctor[0]);
		$doctor_id = trim($full_date_doctor[1]);
		$get_only_date = explode(' ',$date_time);
		$current_date = trim($get_only_date[0]);
		global $config;
		$config = (object) $config;
		if($bookappointment==1 && $is_rescheduled==1){
		$sql = "Select * from ".$config->dbprefix ."appointments where patient_id = '".$id."' AND current_appointment_date = '".$current_date."' and dateTime='".$date_time."' and doctor_id='".$doctor_id."'";
		}else{
		$sql = "Select * from ".$config->dbprefix ."appointments where patient_id = '".$id."' AND current_appointment_date = '".$current_date."'";	
		}
		//echo $sql;
		$result = $db->query($sql);
		$row = $result->fetch_object();
		/* This below condition is added for Booked Patient should not allow again in Booked queue
	    Date 21-02-2018, shubh tiwari
	   */
		if(count($row) > 0){ 
			if((int)$row->queue_number > 0 || (int)$row->medicine_queue_number > 0 || (int)$row->appointment_queue_number > 0 || $row->patient_id){
				return array("validate"=>"already_exist","token_no"=>(int)$row->queue_number,"appointment_no"=>$row->id,"medicine_queue_number"=>(int)$row->medicine_queue_number);
			} 
		}else{
		global $config;
		$config = (object) $config;
		$where = '';
		$sql = "UPDATE ". $config->dbprefix ."patients SET ";
		$sql .= " mode = '".$data['mode']."' ,";
		$sql .= " first_name = AES_ENCRYPT('".strtolower($data['first_name'])."','".$config->salt."') ,";
		$sql .= " middle_name = AES_ENCRYPT('".strtolower($data['middle_name'])."','".$config->salt."') ,";
		$sql .= " last_name = AES_ENCRYPT('".strtolower($data['last_name'])."','".$config->salt."') ,";
		$sql .= " gender = '".$data['gender']."' ,";
		$sql .= " date_of_birth = '".$data['date_of_birth']."' ,";
		$sql .= " age_years = '".$data['age_years']."' ,";
		$sql .= " age_months = '".$data['age_months']."' ,";
		$sql .= " age_days = '".$data['age_days']."' ,";
		$sql .= " phone_res = AES_ENCRYPT('".$data['phone_1']."','".$config->salt."') ,";
		$sql .= " mobile_res = AES_ENCRYPT('".$data['phone_2']."','".$config->salt."') ,";
		$sql .= " full_address_per = AES_ENCRYPT('".strtolower($address_1)."','".$config->salt."') ,";
		$sql .= " full_address_res = AES_ENCRYPT('".strtolower($address_2)."','".$config->salt."') ,";
		$sql .= " city_id_per = '".$city_id."' ,";
		$sql .= " state_id_per = '".$state_id."' ,";
		$sql .= " country_id_per = '".$data['country']."' ,";
		$sql .= " pincode_per = '".$data['zip']."' ,";
		$sql .= " priority = '".$data['priority']."' ,";
		$sql .= " blood_type = '".$data['blood_type']."' ,";
		$sql .= " category = '".$category."' ,";
		$sql .= " discount_category = '".$data['discount_category']."' ,";//This line is added for Discount category, Rahul Khan
		$sql .= " note = AES_ENCRYPT('".strtolower($note)."','".$config->salt."') ,";
		$sql .= " modified_by = '".$data['modified_by']."', ";
		$sql .= " email_id = AES_ENCRYPT('".strtolower($data['email_id'])."','".$config->salt."') ,";
		$sql .= " title_prefix = '".$data['title_prefix']."' ";
		$sql .= " WHERE id='".$id."'";
		$patient_resource = mysqli_query($db,$sql);
		
		if($bookappointment == true){
			require_once(CLASS_PATH . '/appointment/appointments.php');
			$appointmentClass = new Appointment;
			$data['patient_id'] = $id;
			$book_appointment = $appointmentClass->bookAppointment($db, $data, $data['date_time_doctor'], 1, $data['branch_id'], $is_rescheduled, $data['appointmentId'],$reschedule_note);
			return $book_appointment;
		} else{
			return $patient_resource;
		}
		}
			
	}
// In these below function addCity and addState insert query we set the status value with single quote to resolve not listing the other value, Rahul Khan 04 July 2019
	public function addCity($db,$name,$state_id,$country_id)
	{

		global $config;
		$config = (object) $config;
		$sql = "select id from ". $config->dbprefix ."city where city_name='$name' and state_id='$state_id' and status='1'";
		$result = $db->query($sql);
		if($result->num_rows <= 0)
		{
		 	 $sql_insert = "INSERT into ". $config->dbprefix ."city (city_name,state_id,country_id,status) values ('$name',$state_id,$country_id,'1')";
			$result2 = $db->query($sql_insert);
			return $db->insert_id;
		}
		else {
			$row = $result->fetch_object();
			return $row->id;
		}

	}
	public function addState($db,$name,$country_id)
	{
		//print_r($name);exit;
		global $config;
		$config = (object) $config;
	 	$sql = "select id from ". $config->dbprefix ."state where state_name='$name' and country_id='$country_id' and status='1'";
		$result = $db->query($sql);
		if($result->num_rows <= 0)
		{
			 $sql_insert = "INSERT into ". $config->dbprefix ."state (state_name,country_id,status) values ('$name',$country_id,'1')";
			 //print_r($sql_insert);exit;
			$result2 = $db->query($sql_insert);
			return $db->insert_id;
		}
		else {
			$row = $result->fetch_object();
			return $row->id;
		}

	}


}
?>
