<?php
require_once(CONTROLLER_PATH ."/controller.php");
// require_once(LIBRARY_PATH . '/PHPExcel.php');
require_once(LIBRARY_PATH . '/excel_reader2.php');
require_once(LIBRARY_PATH . '/SpreadsheetReader.php');
require_once((CLASS_PATH . '/schedules/schedule.php'));

class scheduleController extends controller{

	private $regular_schedule = "";
	public $data = "";
	public $classPath = "";
	public $verb = "";
	public $className = "";
	public $mobile_no = "";


	public function __construct() {
		date_default_timezone_set("Asia/Calcutta");
	}

	public function call($db, $method){
		$requestUrl = array();
		if(isset($_REQUEST['requestUrl'])){
			$requestUrl = explode('/', $_REQUEST['requestUrl']);
		}
		//Get function name according to request type
		switch($method) {
			case 'PUT':
			  break;

			case 'DELETE':
			  // $this->delete_contact($name);
			  break;

			case 'GET':
				$validate_token = $this->validate_token();
				if($validate_token === false){
					// return $this->response(json_encode(array("status"=>"500", "status_message"=>"invalid token")), 500);
				}
				if(isset($requestUrl[1]) && trim($requestUrl[1]) != ''){
					if(trim($requestUrl[1]) == 'doctor'){
						if(isset($_GET['doctor_id']) && trim($_GET['doctor_id']) != ''){
							$doctor_id = $_GET['doctor_id'];
						}
						else {
								return $this->response(json_encode(array("status"=>"500", "status_message"=>"No doctor id provided ")), 500);
							}

							if(isset($_GET['branch_id']) && trim($_GET['branch_id']) != ''){
								$branch_id = $_GET['branch_id'];
							}
							else {
									return $this->response(json_encode(array("status"=>"500", "status_message"=>"No branch id provided ")), 500);
								}

							if(isset($_GET['date']) && trim($_GET['date']) != ''){
								$date = $_GET['date'];
							}
							else {
									$date = date("Y-m-d");
								}

								return $this->getDoctorsTodaySchedule($db, $doctor_id,$branch_id,$date);
					}
				}
				break;

			case 'POST':
				/* Regular schedule*/
				if(isset($requestUrl[1]) && trim($requestUrl[1]) != ''){
					if(trim($requestUrl[1]) == 'regular'){
						$this->regular_schedule = $_FILES['schedule'];
						if(!isset($_POST['doctor_id']) || $_POST['doctor_id'] == "")
						{
								return $this->response(json_encode(array("Sorry, No doctor id found." => "500")), 500);
						}
						else {
							$doctor_id = $_POST['doctor_id'];
						}
						if(!isset($_POST['user_id']) || $_POST['user_id'] == "")
						{
								return $this->response(json_encode(array("Sorry, No doctor id found." => "500")), 500);
						}
						else {
							$user_id = $_POST['user_id'];
						}
						return $this->regularSchedule($db,$this->regular_schedule,$doctor_id,$user_id);
					}//regular schedule ends
					else if (trim($requestUrl[1]) == 'adjustment')
					{
						$this->adjustment_schedule = $_FILES['schedule'];

						if(!isset($_POST['doctor_id']) || $_POST['doctor_id'] == "")
						{
								return $this->response(json_encode(array("Sorry, No doctor id found." => "500")), 500);
						}
						else {
							$doctor_id = $_POST['doctor_id'];
						}
						if(!isset($_POST['user_id']) || $_POST['user_id'] == "")
						{
								return $this->response(json_encode(array("Sorry, No user id found." => "500")), 500);
						}
						else {
							$user_id = $_POST['user_id'];
						}
						if(!isset($_POST['from_date']) || $_POST['from_date'] == "")
						{
								return $this->response(json_encode(array("Sorry, No from date found." => "500")), 500);
						}
						else {
							$from_date = $_POST['from_date'];
						}
						if(!isset($_POST['to_date']) || $_POST['to_date'] == "")
						{
								return $this->response(json_encode(array("Sorry, No to date found." => "500")), 500);
						}
						else {
							$to_date = $_POST['to_date'];
						}

						return $this->scheduleAdjustment($db,$this->adjustment_schedule,$doctor_id,$user_id,$from_date,$to_date);
					}
				}

					/* if all conditions fail */
					return $this->response(json_encode(array("invalid request" => "404")), 404);
				break;

			default:
			  header('HTTP/1.1 405 Method Not Allowed');
			  header('Allow: GET, PUT, DELETE');
			  break;
		}
	}
	public function regularSchedule($db,$schedule,$doctor_id,$user_id)
	{
		date_default_timezone_set("Asia/Calcutta");
		$scheduleClass = new Schedule();
		$scheduleClass->truncate($db,$doctor_id);
		$target_dir = "data/uploads/";
		$target_file = $target_dir . basename(date('m_d_h_i_s')."_".$schedule["name"]);
		$fileType = pathinfo($target_file,PATHINFO_EXTENSION);
		// Check if file is xlx or xlsx only
		if($fileType != "xls" && $fileType != "xlsx") {
			return $this->response(json_encode(array("Sorry, only XLS & XLSX files are allowed." => "500")), 500);
		}

		// echo $_SERVER['DOCUMENT_ROOT']."/".$target_file;die;
		if (move_uploaded_file($schedule["tmp_name"], $target_file)) {

			chmod( $target_file, 0644);
			$Reader = new SpreadsheetReader($target_file);
			$Sheets = $Reader->Sheets();
		    foreach ($Sheets as $Index => $Name)
		    {
				$Reader->ChangeSheet($Index);
				if($Name == 'OCP Visit'){
					foreach ($Reader as $key => $row)
					{
						if($key>0)
						{
							$before_morning = (trim($row[1]) == 'A') ? '1' : '0';
							$after_morning = (trim($row[2]) == 'A') ? '1' : '0';
							$after_evening = (trim($row[3]) == 'A') ? '1' : '0';
							
							$day_id = $scheduleClass->getWeekDayId($db,$row[0]);
							 $scheduleClass->addOCPRegularSchedule($db, $doctor_id, $day_id, $before_morning, $after_morning, $after_evening,  $user_id);
						}
					}
					
				}else{
					
					$branch_id = $scheduleClass->getBranchId($db,$Name);
					if($branch_id == null)
					{
						return $this->response(json_encode(array("Sorry, Invalid branch name" => "500")), 500);
					}
					foreach ($Reader as $key => $row)
					{
						if($key>0)
						{
							$time_in_1 = new DateTime($row[1]);
							$time_out_1 = new DateTime($row[2]);
							$time_in_2 = new DateTime($row[3]);
							$time_out_2 = new DateTime($row[4]);
							$day_id = $scheduleClass->getWeekDayId($db,$row[0]);
							if($key!=8){
								//Time entry for slot 1
									$scheduleClass->addRegularScedule($db, $doctor_id, $day_id, $time_in_1->format('H:i:s'), $time_out_1->format('H:i:s'), 1 , $branch_id, $user_id);
								//Time entry for slot 2
									$scheduleClass->addRegularScedule($db, $doctor_id, $day_id, $time_in_2->format('H:i:s'), $time_out_2->format('H:i:s'), 2 , $branch_id, $user_id);
							}
						}
					}
					
				}


		    }//Sheets for loop ends
				return $this->response(json_encode(array("status" => "ok")), 200);

    } else {
			return $this->response(json_encode(array("status" => "fail")), 500);
    }

	}

	public function scheduleAdjustment($db,$schedule,$doctor_id,$user_id,$from_date,$to_date)
	{

		date_default_timezone_set("Asia/Calcutta");
		$scheduleClass = new Schedule();
		//$scheduleClass->truncateAdjustment($db,$doctor_id);
		$target_dir = "data/uploads/";
		$target_file = $target_dir . basename(date('m_d_h_i_s')."_".$schedule["name"]);
		$fileType = pathinfo($target_file,PATHINFO_EXTENSION);
		// Check if file is xlx or xlsx only
		if($fileType != "xls" && $fileType != "xlsx") {
			return $this->response(json_encode(array("Sorry, only XLS & XLSX files are allowed." => "500")), 500);
		}

		// echo $_SERVER['DOCUMENT_ROOT']."/".$target_file;die;
		if (move_uploaded_file($schedule["tmp_name"], $target_file)) {
			chmod( $target_file, 0644);
			$Reader = new SpreadsheetReader($target_file);
			$Sheets = $Reader->Sheets();
		    foreach ($Sheets as $Index => $Name)
		    {
				$Reader->ChangeSheet($Index);
				if($Name == 'OCP Visit'){
					foreach ($Reader as $key => $row)
					{
						if($key>0)
						{
							$before_morning = (trim($row[1]) == 'A') ? '1' : '0';
							$after_morning = (trim($row[2]) == 'A') ? '1' : '0';
							$after_evening = (trim($row[3]) == 'A') ? '1' : '0';
							
							$day_id = $scheduleClass->getWeekDayId($db,$row[0]);
							$rest = $scheduleClass->addOCPScheduleAdjustment($db, $from_date, $to_date, $doctor_id, $day_id, $before_morning, $after_morning,$after_evening, 1 , $branch_id, $user_id);
							
							//print_r($rest);
						}
					}
					
				}else{
					$branch_id = $scheduleClass->getBranchId($db,$Name);
					if($branch_id == null)
					{
						return $this->response(json_encode(array("Sorry, Invalid branch name" => "500")), 500);
					}

					//$Reader->ChangeSheet($Index);
					foreach ($Reader as $key => $row)
					{
						if($key>0)
						{
							$time_in_1 = new DateTime($row[1]);
							$time_out_1 = new DateTime($row[2]);
							$time_in_2 = new DateTime($row[3]);
							$time_out_2 = new DateTime($row[4]);
							$day_id = $scheduleClass->getWeekDayId($db,$row[0]);
							if($key!=8){
							 //Time entry for slot 1
								$scheduleClass->addScheduleAdjustment($db, $from_date, $to_date, $doctor_id, $day_id, $time_in_1->format('H:i:s'), $time_out_1->format('H:i:s'), 1 , $branch_id, $user_id);
							//Time entry for slot 2
								$scheduleClass->addScheduleAdjustment($db,$from_date, $to_date, $doctor_id, $day_id, $time_in_2->format('H:i:s'), $time_out_2->format('H:i:s'), 2 , $branch_id, $user_id);
							}
						}
					}
				}

		    }//Sheets for loop ends
			
			//exit;
				// return $this->response(json_encode(array("File uploaded succesfully." => "200")), 200);
				return $this->response(json_encode(array("status" => "ok")), 200);

    } else {
			return $this->response(json_encode(array("Sorry, there was an error uploading your file." => "500")), 500);
    }

	}

	public function getDoctorsTodaySchedule($db, $doctor_id,$branch_id,$date)
	{


		$scheduleClass = new Schedule();
		return $scheduleClass->getDoctorsTodaySchedule($db, $doctor_id,$branch_id,$date);

	}
	public function udpateUsers($db, $data){

	}

	public function deleteUsers($db, $data){

	}


}
?>
