<?php

namespace App\Http\Controllers;

use Illuminate\Hashing\BcryptHasher;
use Illuminate\Support\Facades\Validator;
use Illuminate\Http\Request;
use App\PermissionCategory;
use App\Permissions;
use Carbon\Carbon;


class PermissionCategoryController extends Controller
{

    public function getRecords($id='')
    {
        //return $request->all();
        if($id > 0){

            return PermissionCategory::find($id);
        }
        return PermissionCategory::where('status', '!=', '0')->paginate(10);
    }

    public function getcategory()
    {
        return PermissionCategory::where('status', '!=', '0')->get();
    }
    public function create(Request $request)
    {
        //creating a validator
        $validator = Validator::make($request->all(), [
            'category_name' => 'required'
        ]);

        //if validation fails
        if ($validator->fails()) {
            return array(
                'error' => true,
                'message' => $validator->errors()->all()
            );
        }

        //creating a new permission
        $category = new PermissionCategory();
        //return $request->all();
        //adding values to the permission table
        $category->category_name = $request->category_name;
        //saving the permission to database
         if($request->id > 0){
            $item = $category->findOrFail($request->id);

            if($item){
                $modification_date =  Carbon::now();

                 $category->where('id', $request->id)->update(['category_name'=>$category->category_name,'modification_date'=>$modification_date]);

                return array('error' => false, 'category' => 'Permission category Updated successfully');
            }
        }

        $category->save();

        //returning the added permission
        return array('error' => false, 'category' => 'Permission category added successfully');
    }


    public function categoryWisePermissions(){
                $permission_list = array();
                $categories = array();
                $categories_data =  PermissionCategory::where('status', '1')->get(['id']);
                // clPermissions
                foreach ($categories_data as $category) {
                    // return $category->id;
                     $category_data = PermissionCategory::find($category->id);

                     $permission = $category_data->Permissions;
                     array_push($permission_list, array("$category_data->category_name"=>$permission));
                //      $permission_list[$category_data->id] = $permission;
                //      $categories[$category_data->id] = $category_data->category_name;
                //  $all =    array_merge($permission_list,$categories);
                }
                return $permission_list;
         }


    public function delete(Request $request)
    {
        //return $request->all();
        $permission = PermissionCategory::findOrFail($request->category_id);
        if($permission){
           $permission->where('id', $request->category_id)->update(['status'=>'0']);
            return array('error' => false, 'permission' => 'Permission category deleted successfully');
        }else{
         return array('error' => true, 'permission' => 'Error: Unable to delete permission category Record!');
        }
    }

}