<?php

namespace App\Http\Controllers;

use Illuminate\Support\Facades\Validator;
use Illuminate\Http\Request;
use App\Potencys; //import potency model 
use Carbon\Carbon;
use Illuminate\Support\Facades\DB;
class PotencyController extends Controller
{


    public function create(Request $request){
       // return $request;
		$validator = Validator::make($request->all(), [
			'name' => 'required',
			'dilution_code' => 'required',
			'group_id' => 'required',
		]);

        //if validation fails
        if ($validator->fails()) {
            return array(
                'error' => true,
                'message' => $validator->errors()
            );
        }
        
        //creating a new PriceGroup model object
        $potency = new Potencys();

        $potency->name = $request->name;
        $potency->dilution_code = $request->dilution_code;
		$potency->group_id = $request->group_id;

        //this below condition block is used for update records in datbase 
        if((isset($request->id)) && ($request->id > 0)) {
            //return $request->id;
            $item = $potency->findOrFail($request->id)->where('status','!=',0);
            if($item){
				$modification_date =  Carbon::now();
                $potency->where('id', $request->id)->update(['name'=>$potency->name,'dilution_code'=>$potency->dilution_code,'group_id'=>$potency->group_id,'modification_date'=>$modification_date]);
               // return $item;
                return array('error' => false, 'potency' => 'Price Group Updated successfully');
            }
        }

        //saving the branch to database
        $potency->save();
        //returning the added branch
        return array('error' => false, 'potency' => 'Price Group added successfully');
        }
    public function getRecords($id='',Request $request){
        //return $request->search;
        $potency = new Potencys();
        if($id > 0){
            return $potency->find($id);
        }

		if($request->has('search')){
			 return $potency->leftJoin('dilutions', 'potencys.dilution_code', '=', 'dilutions.id')
				->leftJoin('pricegroups', 'potencys.group_id', '=', 'pricegroups.id')
				->select([
				'potencys.*', //to get ids and timestamps
				'dilutions.name as dilution',
				'pricegroups.name as group']
				)->where('potencys.status','!=',0)->where('potencys.name', 'LIKE', '%' . $request->search . '%')->paginate(10);
		}

		return $potency->leftJoin('dilutions', 'potencys.dilution_code', '=', 'dilutions.id')
			->leftJoin('pricegroups', 'potencys.group_id', '=', 'pricegroups.id')
			->select([
			'potencys.*', //to get ids and timestamps
			'dilutions.name as dilution',
			'pricegroups.name as group']
			)->where('potencys.status','!=',0)->paginate(10);
    }

    public function deleteRecords($id=''){
        // return  $id;
      $potency = new Potencys();
      $potency->where('id', $id)->update(['status'=>0]);
      return array('error' => false, 'potency' => 'Price Group Deleted successfully');
      //;
  }
}