<?php

namespace App\Http\Controllers;

use Illuminate\Hashing\BcryptHasher;
use Illuminate\Support\Facades\Validator;
use Illuminate\Http\Request;
use App\UserTypes;
use Carbon\Carbon;

class UserTypesController extends Controller
{

    public function getRecords($id='')
    {
        //return $request->all();
        if($id > 0){

            return UserTypes::find($id);
        }
        return UserTypes::where('status', '!=', '0')->get();
    }

    public function create(Request $request)
    {
        //creating a validator
        $validator = Validator::make($request->all(), [
            'permission_category' => 'required',
            'permission_name' => 'required',
        ]);

        //if validation fails
        if ($validator->fails()) {
            return array(
                'error' => true,
                'message' => $validator->errors()->all()
            );
        }

        //creating a new permission
        $permission = new UserTypes();
        //return $request->all();
        //adding values to the permission table
        $permission->permissionName = $request->permission_name;
        $permission->category_id = $request->permission_category;
        $permission->description = $request->permission_description;
        //saving the permission to database
         if($request->id > 0){
            $item = $permission->findOrFail($request->id);
            if($item){
                $modification_date =  Carbon::now();

                 $permission->where('id', $request->id)->update(['permissionName'=>$permission->permissionName,'category_id'=>$permission->category_id,'description'=>$permission->description,'modification_date'=>$modification_date]);

                return array('error' => false, 'permission' => 'Permission Updated successfully');
            }
        }

        $permission->save();

        //returning the added permission
        return array('error' => false, 'permission' => 'Permission added successfully');
    }


    public function update(Request $request)
    {
        //return $request->all();
         $modification_date =  Carbon::now();
         $request->request->add(['permissionName'=>$request->permission_name,'parent_id'=>$request->permission_category,'description'=>$request->permission_description,'modification_date'=>$modification_date]);

         $permission = UserTypes::findOrFail($request->id);
         $permission->update($request->all());
         return array('error' => false, 'permission' => 'Permission updated successfully');
          //return response()->json(['validate'=>200,'permission' => 'Permission updated successfully']);
    }

    public function delete(Request $request)
    {
        $permission = UserTypes::findOrFail($request->permission_id);
        if($permission){
           $permission->where('id', $request->permission_id)->update(['status'=>'0']);
            return array('error' => false, 'permission' => 'Permission deleted successfully');
        }else{
         return array('error' => true, 'permission' => 'Error: Unable to delete permission Record!');
        }
    }

}