<?php
namespace App\Http\Middleware;
use Closure;
use Illuminate\Contracts\Auth\Factory as Auth;
class Authenticate
{
    /**
     * The authentication guard factory instance.
     *
     * @var \Illuminate\Contracts\Auth\Factory
     */
    protected $auth;

    /**
     * Create a new middleware instance.
     *
     * @param  \Illuminate\Contracts\Auth\Factory  $auth
     * @return void
     */
    public function __construct(Auth $auth)
    {
        $this->auth = $auth;
    }

    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @param  string|null  $guard
     * @return mixed
     */
    public function handle($request, Closure $next, $guard = null)
    {
        if ($this->auth->guard($guard)->guest()) {
            return response('Unauthorized.', 401);
        }

        return $next($request);
    }
}

// class Authenticate
// {
//     public function handle($request, Closure $next)
//     {
//         if(!$request->hasHeader('Authorization')) {
//           return response()->json('Authorization Header not found', 401);
//         }

//         $token = $request->bearerToken();

//         if($request->header('Authorization') == null || $token == null) {
//           return response()->json('No token provided', 401);
//         }

//         $this->retrieveAndValidateToken($token);

//         return $next($request);
//     }
//     public function retrieveAndValidateToken($token)
//     {
//         try {
//             if (!empty($token)) {
//                 return User::where('remember_token', $token)->first();
//             }
//         }
//         catch(\Illuminate\Database\QueryException $ex) {
//             throw $e;
//         };
//     }
// }

