<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateAuditsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
		Schema::create('audits', function (Blueprint $table){
				 $table->increments('id');
				 $table->string('user_type')->nullable();
				 $table->unsignedInteger('user_id')->nullable();
				 $table->string('event');
				 $table->morphs('auditable');
				 $table->text('old_values')->nullable();
				 $table->text('new_values')->nullable();
				 $table->text('url')->nullable();
				 $table->ipAddress('ip_address')->nullable();
				 $table->string('user_agent')->nullable();
				 $table->string('tags')->nullable();
				 $table->timestamps();
				 $table->index(['user_id', 'user_type']);
			});
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::drop('audits');
    }
}
