<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class Doctorcharges extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
		Schema::create('doctorcharges', function (Blueprint $table) {
			$table->increments('id');
			$table->integer('charge_id')->unsigned();
			$table->integer('doctor_id')->unsigned();
			$table->string('charge_code', 3);
			$table->foreign('charge_id')->references('id')->on('charges');
			$table->foreign('charge_code')->references('charge_code')->on('charges');
			$table->foreign('doctor_id')->references('user_id')->on('users');
			$table->integer('price')->unsigned();
			$table->integer('created_by');
			$table->timestamp('creation_date_on');
			$table->integer('modified_by');
			$table->timestamp('modification_date');
			$table->enum('status', ['0', '1', '2'])->default(1);
		});
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
       Schema::dropIfExists('doctorcharges');
    }
}
