<?php
use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class PaymentMode extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('payment_mode', function(Blueprint $table)
        {
            $table->increments('id');
            $table->string('name');
            $table->text('description');
            $table->integer('created_by');
            $table->timestamp('creation_date')->useCurrent();
            $table->integer('modified_by');
            $table->timestamp('modification_date')->default('0000-00-00 00:00:00')->useCurrent();
            $table->enum('status', ['0', '1', '2'])->default(1);
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::drop('payment_mode');
    }
}
