<?php
namespace App\Modules\Billing\Http\Controllers;
use Illuminate\Http\Request;
use App\Http\Requests;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Validator;
use Illuminate\Validation\ValidationException;
use App\Modules\Billing\Models\Billing;
use App\Modules\Billing\Models\appointments;
use App\Modules\Billing\Models\patients;
use App\Modules\Billing\Models\users;
use App\Modules\Medicine\Models\Medicine;
use App\Modules\Medicine\Models\MedicineGroupPotency;
use App\Modules\Medicine\Models\MedicineGroupPotencyForm;
use App\Modules\Medicine\Models\Medicinegroup;
use App\Modules\Medicine\Models\pricegroup;
use App\Modules\Medicine\Models\potency; //import potency model 
use App\Modules\Medicine\Models\potencygroup; //import potencygroup model 
use App\Modules\Medicine\Models\pricegrouprate;
use App\Modules\Mixmedicine\Models\Medicinemix;
use App\Modules\Mixmedicine\Models\Medicinemixvariant;
use App\Modules\Medicinetemplate\Models\Medicinetemplate;
use App\Modules\Medicinetemplate\Models\Medicinetemplatevariant;
use App\Modules\Billing\Models\Prescribemedicine;
use App\Modules\Billing\Models\Payment;
use App\Modules\Billing\Models\PatientBillingCharge;
use App\Modules\Visit\Models\Visit;
use Carbon\Carbon;
use App\Traits\PricingClass; //import pricing class trait
use App\Traits\CommonFunction; //import common method trait
//This imported library is required for Using database directly in lumen
use Illuminate\Support\Facades\DB;
//This below imported Libarary is used for HTTP request for other server
use GuzzleHttp\Client; 

class BillingController extends Controller
{
	use PricingClass;
	use CommonFunction;
	public function getClinicPatients($id='', Request $request)
	{

		$shift_id = $request->shift_id;
		$branch_id = $request->branch_id;
		$currentDate = Carbon::now();
		$currentDate = $currentDate->toDateString();
//this below code line is used for getting core existing APIs url
		$Core_Api_root = env('CORE_API_ROOT', true);
//In this API Query Parameter We can pass "sort" for on which column we want sort, "order" for order by ASC and DESC,"branch_id" for getting perticular branch Related Data,"shift_id" for getting perticular shift data and "dateTime" for getting data on pertcilular date, 
		$client = new Client();
		

//This below code is used for getting in clinic patients using model but we have commented this because not have all datatable with migrating 
//This code will be used in future when we create first phase with lumen and migrating all the tables, Rahulm Khan 
//return appointments::with(['users','patients'])->whereDate('created_at', '=', Carbon::today()->toDateString())->paginate(10);
		try{
				$res = $client->request('GET', $Core_Api_root.'appointments/completed',[
					'query' => ['branch_id' => $branch_id, 'dateTime'=>$currentDate, 'shift_id'=> $shift_id]
				]);
				if ($res->getStatusCode() == 200) { // 200 OK
					$response_data = $res->getBody()->getContents();
				}
		return $response_data;
		}catch(\Illuminate\Database\QueryException $ex){
						$res['status'] = false;
						$res['message'] = $ex->getMessage();
						return response($res, 500);
		};
	}
	
	public function getMedicineQueuePatients($id='', Request $request)
	{
//This below code line is used for getting core existing APIs url
	   $Core_Api_root = env('CORE_API_ROOT', true);

		$shift_id = $request->shift_id;
		$branch_id = $request->branch_id;
		$currentDate = Carbon::now();
		$currentDate = $currentDate->toDateString();

		$client = new Client();
		try{
				$res = $client->request('GET', $Core_Api_root.'appointments/branch',[
					'query' => ['branch_id' => $branch_id, 'dateTime'=>$currentDate, 'shift_id'=> $shift_id]
				]);
				if ($res->getStatusCode() == 200) { // 200 OK
					$response_data = $res->getBody()->getContents();
				}
				return $response_data;
		}catch(\Illuminate\Database\QueryException $ex){
						$res['status'] = false;
						$res['message'] = $ex->getMessage();
						return response($res, 500);
		};


	}

public function getPrescribe($id='', Request $request)
	{
//This below code line is used for getting core existing APIs url
	   $Core_Api_root = env('CORE_API_ROOT', true);
		$client = new Client();
		try{
				$res = $client->request('GET', $Core_Api_root.'appointments/prescribe',[
					'query' => ['id' => $id]
				]);
				if ($res->getStatusCode() == 200) { // 200 OK
					$response_data = $res->getBody()->getContents();
				}
				return $response_data;
		}catch(\Illuminate\Database\QueryException $ex){
						$res['status'] = false;
						$res['message'] = $ex->getMessage();
						return response($res, 500);
		};


	}

	public function getPrescribeMedicineSearch($id='', Request $request)
	{
		$query = $request->get('query');
        if(!empty($query)){

                    $single = DB::table('medicines as m')->select('p.name as potencyname','p.dilution as dilution','m.name as medicineName', DB::raw("'single' as datatype"), 'mgp.potency_id as potenId','mgp.medicine_id as medId')
                    ->join('medicinegroups as mg', 'mg.medicine_id', '=', 'm.id')
                    ->join('medicinegrouppotencies as mgp', 'mgp.medicinegroup_id', '=', 'mg.id')
                    ->join('potencies as p', 'p.id', '=', 'mgp.potency_id')
                    ->where('m.name', 'LIKE', '%'.$query.'%')->where('m.status','=', '1')
					->get();
					
                    $mix = DB::table('medicinemix as mm')->select('mm.medicineMixName as medicineName', DB::raw("'mix' as datatype"),'mm.id as medId')
                    ->where('mm.medicineMixName', 'LIKE', '%'.$query.'%')->where('mm.status','=', '1')
                    //->groupBy('mmv.medicinemixId')
					->get();
					
					$template = DB::table('medicinetemplate as mt')->select('mt.medicineTempName as medicineName', DB::raw("'template' as datatype"),'mt.id as medId')
                    ->where('mt.medicineTempName', 'LIKE', '%'.$query.'%')->where('mt.status','=', '1')
                    //->groupBy('mtv.medicinetempId')
					->get();

					$medicinesearch_list = $single->merge($mix->merge($template));
					$count = count($medicinesearch_list);
					$output ='';
					$singleDataTemplate = '';
					$mixDataTemplate = '';
					$templateDataTemplate = '';
					$output.='<ul class="medicine-list">';
					if($count>0){
						foreach ($medicinesearch_list as $data_list)
						{

							if($data_list->datatype=='single'){
								$singleDataTemplate.= '<li class="formdata" data-potencyname="'.$data_list->potencyname.'" data-dilution="'.$data_list->dilution.'" data-type="'.$data_list->datatype.'" data-med="'.$data_list->medId.'" data-poten="'.$data_list->potenId.'">'.$data_list->medicineName.','.' '.$data_list->potencyname.'</li>';
							}else if($data_list->datatype=='mix'){
								$mixDataTemplate.= '<li class="formdata" data-type="'.$data_list->datatype.'" data-med="'.$data_list->medId.'">'.$data_list->medicineName.'</li>';
							}else if($data_list->datatype=='template'){
								$templateDataTemplate.= '<li class="formdata" data-type="'.$data_list->datatype.'" data-med="'.$data_list->medId.'">'.$data_list->medicineName.'</li>';
							}
						}
				    }else{
						$output.= '<li>No medicine found </li>';
					}
					if($singleDataTemplate!=''){
						$output.= '<li class="header">Single</li>'.$singleDataTemplate;
					}
					if($mixDataTemplate!=''){
						$output.= '<li class="header">Mix</li>'.$mixDataTemplate;
					}
					if($templateDataTemplate!=''){
						$output.= '<li class="header">Template</li>'.$templateDataTemplate;
					}
		
                    $output.= '</ul>';
                    
          		  return response($output);

      }

	}
// This function is used to get individual medicine form list
	public function getFormListDropdown($id='', Request $request){
		// This Code for get method
		if($id>0){
			$formdropdown_list = DB::table('medicinemix as mx')->select('mxv.mixMedicineId as mxId','mxv.mixPotencyId as mpId')
			->join('medicinemixvariant as mxv', 'mxv.medicinemixId', '=', 'mx.id')->where('mx.id', $id)->distinct()->get();
			foreach($formdropdown_list as $form_details){
				$form_list = DB::table('medicinegrouppotencies as mgp')->select('f.name as fName','f.id as fId')
				->join('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
				->join('forms as f', 'f.id', '=', 'mgpf.form_id')
				->where('mgp.potency_id', $form_details->mpId)
				->where('mgp.medicine_id', $form_details->mxId)
				->distinct()
				->get();
				return response()->json($form_list);
			}

		}
		// This Code for post method
		if(!empty($request->potency) && !empty($request->medicine)){
			$formdropdown_list = DB::table('medicinegrouppotencies as mgp')
			->select('pg.form_name as fName','mgpf.group_id as gId','pg.form_code as fcode')
			->LeftJoin('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
			->LeftJoin("pricegrouprates as pg",function($join){
				$join->on("pg.pricegroup_id","=","mgpf.group_id")
					->on("pg.form_code","=","mgpf.form_code");
				})
			->where('mgp.medicine_id', $request->medicine)
			->where('mgp.potency_id', $request->potency)
			->where('pg.status', '1')
			->distinct()
			->get();
			return response()->json($formdropdown_list);
			}

		} 
// This function is used to get mix medicine data with individual mix id
	public function getMixMedicine(Request $request){
		$main_array = array();
		$medicine_array = array();
		if(!empty($request->mix_medicine_id) && !empty($request->mix_medicine_id)){
			$mix_medicine_list = DB::table('medicinemix as mm')->select('mm.id as mixId','mm.medicineMixName as mName','mmv.mixMedicineId as medId', 'mmv.mixPotencyId as pId', 'mmv.medicinemixtureName as mixMedicineName','p.name as potencyname','p.dilution as dilution','mmv.medicineMixFormName as fName', 'mmv.medicineMixFormCode as fcode','mmv.medicineMixFormGroupId as fId')
			->LeftJoin('medicinemixvariant as mmv', 'mmv.medicinemixId', '=', 'mm.id')
			->LeftJoin('potencies as p', 'p.id', '=', 'mmv.mixPotencyId')
			->where('mm.status', '1')
			->where('p.status', '1')
			->where('mm.id', $request->mix_medicine_id)
			->distinct()
			->get();
			 foreach ($mix_medicine_list as $key => $value){
				$mix_medicine_form_list = DB::table('medicinegrouppotencies as mgp')->select('pg.form_name as fName','mgpf.group_id as gId','pg.form_code as fcode')
				->join('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
				->LeftJoin("pricegrouprates as pg",function($join){
					$join->on("pg.pricegroup_id","=","mgpf.group_id")
						->on("pg.form_code","=","mgpf.form_code");
					})
				->join('forms as f', 'f.id', '=', 'mgpf.form_id')
				->where('pg.status', '1')
				->where('mgp.potency_id', $value->pId)
				->groupBy('mgpf.form_id')
				->distinct()
				->get();
				$main_array['medicine']= $mix_medicine_list[$key];
				$main_array['form']= $mix_medicine_form_list;
				array_push($medicine_array,  $main_array);
			 }
			return response()->json($medicine_array);
		}
	}
	// This function is used to get template medicine data with individual template id
	public function getTemplateMedicine(Request $request){
				$template_array = array();
				$total_array = array();
				$mix_array = array();
				$main_array = array();
				$single_array = array();
				if(!empty($request->template_id) && $request->template_id>0){

			$temp_medicine_list = DB::table('medicinetemplate as mt')
								->select('mtv.medicineTempFormCode as f_code','mtv.medicineTempFormName as f_name','mt.pharmacy_instruction as pIns','mtv.medicine_type as mtype','mtv.templatemixNo as mserialNo','mt.medicineTempName as mName','mtv.mixMedicineId as medId', 'mtv.tempPotencyId as pId', 'mtv.medicineTempMixtureName as mixMedicineName','mtv.instructionId as Iid','mtv.instruction_name as Iname','mtv.instruction_other_value as Oname'
								, DB::raw("(SELECT pt.name FROM cl_potencies as pt WHERE pt.id = pId and pt.status='1') as potency_name"),DB::raw("(SELECT pt.dilution FROM cl_potencies as pt WHERE pt.id = pId and pt.status='1') as dilution_name"), DB::raw("(SELECT medi.name FROM cl_medicines as medi WHERE medi.id = medId and medi.status='1') as medicine_name"))
								->LeftJoin('medicinetemplatevariant as mtv', 'mtv.medicinetempId', '=', 'mt.id')
								->where('mt.status', '1')
								->where('mt.id', $request->template_id)
								->distinct()
								->get();
				foreach ($temp_medicine_list as $key => $value){

						if($value->mtype=='single' && !empty($value->medId)){
						// $single_medicine_list = DB::table('medicinegrouppotencyforms as mgpf')->select('pg.','mgpf.group_id as group_id','mgpf.form_code as form_code')->where('mgpf.medicinegrouppotency_id', DB::raw("(SELECT mgp.id FROM cl_medicinegrouppotencies as mgp
						// 	WHERE mgp.potency_id = $value->pId and mgp.medicine_id= $value->medId )"))
						// 	->LeftJoin("pricegrouprates as pg",function($join){
						// 		$join->on("pg.pricegroup_id","=","mgpf.group_id")
						// 			->on("pg.form_code","=","mgpf.form_code");
						// 		})->get();

								$single_medicine_list = DB::table('medicinegrouppotencies as mgp')->select('pg.form_name as form_name','mgpf.group_id as group_id','pg.form_code as form_code')
								->LeftJoin('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
								->LeftJoin("pricegrouprates as pg",function($join){
									$join->on("pg.pricegroup_id","=","mgpf.group_id")
										->on("pg.form_code","=","mgpf.form_code");
									})
								->where('pg.status', '1')
								->where('mgp.potency_id', $value->pId)
								->where('mgp.medicine_id', $value->medId)
								->groupBy('mgpf.form_code')
								->distinct()
								->get();
							$main_array['single_medicine']= $temp_medicine_list[$key];
							$main_array['forms']= $single_medicine_list;
							array_push($single_array,  $main_array);
						
						}else if($value->mtype=='mix' && !empty($value->medId)){
							$mix_medicine_list = DB::table('medicinemix as mm')->select('mm.id as mixId','mm.medicineMixName as mName','mmv.mixMedicineId as medId', 'mmv.mixPotencyId as pId', 'm.name as mixMedicineName','p.name as potencyname','p.dilution as dilution','mmv.medicineMixFormName as fName', 'mmv.medicineMixFormCode as fcode','mmv.medicineMixFormCode as fId')
							->LeftJoin('medicinemixvariant as mmv', 'mmv.medicinemixId', '=', 'mm.id')
							->LeftJoin('medicines as m', 'm.id', '=', 'mmv.mixMedicineId')
							->LeftJoin('potencies as p', 'p.id', '=', 'mmv.mixPotencyId')
							->where('mm.status', '1')
							->where('p.status', '1')
							->where('mm.id', $value->medId)
							->distinct()
							->get();
							 foreach ($mix_medicine_list as $key => $value1){
								$mix_medicine_form_list = DB::table('medicinegrouppotencies as mgp')->select('pg.form_name as fName','mgpf.group_id as gId','pg.form_code as fcode')
								->LeftJoin('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
								->LeftJoin("pricegrouprates as pg",function($join){
									$join->on("pg.pricegroup_id","=","mgpf.group_id")
										->on("pg.form_code","=","mgpf.form_code");
									})
								->where('pg.status', '1')
								->where('mgp.potency_id', $value1->pId)
								->groupBy('mgpf.form_id')
								->distinct()
								->get();
							
								$template_array[$value->mixMedicineName]['medicine'][$key]= $mix_medicine_list[$key];
								$template_array[$value->mixMedicineName]['serial_no'] = $value->mserialNo;
								$template_array[$value->mixMedicineName]['mix_name'] = $value->mixMedicineName;
								$template_array[$value->mixMedicineName]['instruction_id'] = $value->Iid;
								$template_array[$value->mixMedicineName]['instruction_other'] = $value->Oname;
								$template_array[$value->mixMedicineName]['instruction_name'] = $value->Iname;
								$template_array[$value->mixMedicineName]['form'][$key]= $mix_medicine_form_list;
							 }
				
						}
						
				}
				$total_array['single'] = $single_array;
				$total_array['mix'] = $template_array;

				return response()->json($total_array);
			}
	}
	//This functtion is used for post prescribe medicine data 
	public function createPrescribe(Request $request){
		parse_str($request->formdata, $formdata);//This will convert the string to array
		//creating a validator
		$validator = Validator::make($formdata, $request->all(), [
			'srnoItem' => 'required|array',
			'medicineItem' => 'required|array',
			'potencyItem' => 'required|array',
			'dilutionItem' => 'required|array',
			'formItem' => 'required|array',
			'instructionItem' => 'required|array',
			'precribe_pharmacy_instruction' => 'required'
		]);

		//if validation fails
		if ($validator->fails()){
			return array(
				'error' => true,
				'message' => $validator->errors()->all()
			);
		}
		// echo '<pre>';
		// print_r($formdata);
		$srnoItem_array = $formdata['srnoItem'];
		$medicine_type_array = $formdata['medicine_type'];
		$medicineItem_array = $formdata['medicineItem'];
		$potencyItem_array = $formdata['potencyItem'];
		$dilutionItem_array = $formdata['dilutionItem'];
		$formItem_array = $formdata['formItem'];
		$factorItem_array = $formdata['factorItem'];
		$instructionItem_array = $formdata['instructionItem'];
		$medicine_id_array = $formdata['medicine_id'];
		$potency_id_array = $formdata['potency_id'];
		$appointment_id = $formdata['appointment_id'];
		$billing_id = $formdata['billing_id'];
		// for update medicine
		if(!empty($appointment_id) && !empty($billing_id)){
			return 'shubh';

		}else{
		// for create medicine
		if((!empty($formdata['patient_id']) && !empty($formdata['appointment_id'])) && (!empty($srnoItem_array) && count($srnoItem_array)>0) && (!empty($medicine_type_array) && count($medicine_type_array)>0) && (!empty($medicineItem_array) && count($medicineItem_array)>0) && (!empty($potencyItem_array) && count($potencyItem_array)>0) && (!empty($dilutionItem_array) && count($dilutionItem_array)>0) && (!empty($factorItem_array) && count($factorItem_array)>0) && (!empty($instructionItem_array) && count($instructionItem_array)>0) && (!empty($formItem_array) && count($formItem_array)>0)){
			
				$billing = new Billing();
				$visit = new Visit();
				$billing->patient_id = $formdata['patient_id'];
				$billing->appointment_id = $formdata['appointment_id'];
				$billing->doctor_id = $formdata['doctor_id'];
				$billing->pharmacy_instruction = $formdata['precribe_pharmacy_instruction'];
				$billing->save();
				$last_billing_id =  $billing->id;
				foreach($srnoItem_array as $key=>$value){
					if($medicine_type_array[$key]=='single'){
						$prescribe = new Prescribemedicine();
						$prescribe->patient_id = $formdata['patient_id'];
						$prescribe->appointment_id =  $formdata['appointment_id'];
						$prescribe->billing_id = $last_billing_id;
						$prescribe->medicine_serial_no = $srnoItem_array[$key];
						$prescribe->medicine_name = $medicineItem_array[$key];
						$prescribe->potency_name = $potencyItem_array[$key];
						$prescribe->dilution_name = $dilutionItem_array[$key];
						$list_array = explode('-', $formItem_array[$key]);
						$group_id = $list_array[0];
						$form_code = $list_array[1];
						$form_name = $list_array[2];
						$prescribe->group_id = $group_id;
						$prescribe->form_code = $form_code;
						$prescribe->form_name =$form_name;
						// Get each medicine price from pricing class trait
						$form_rate = $this->getPrice($group_id,$form_code,$form_name);
						$prescribe->form_rate =$form_rate->rate;
						// Calcuate each medicine price
						$factor = $factorItem_array[$key];
						$each_form_rate =$form_rate->rate;
						$each_medicine_amount = $factor * $each_form_rate;
						$prescribe->medicine_amount = number_format($each_medicine_amount,2);
						$prescribe->factor = $factorItem_array[$key];
						//$get_value_list = is_numeric($instructionItem_array[$key]);
						if(is_numeric($instructionItem_array[$key])){
							$prescribe->instruction_id = $instructionItem_array[$key];
							$instruction_id = $instructionItem_array[$key];
							// get instruction name
							$ins_name = $this->getInstructions($instruction_id);
							$prescribe->instruction_name = $ins_name->instruction_name;
						}else{
							// get Other value
							$prescribe->instruction_other_value =$instructionItem_array[$key];
						}
						$prescribe->midicine_type  = $medicine_type_array[$key];
						//$prescribe->medicine_id  = $medicine_id_array[$key];
						//$prescribe->potency_id  = $potency_id_array[$key];
						$prescribe->save();
						
					}elseif($medicine_type_array[$key]=='mix'){
						$mix_prescribe = new Prescribemedicine();
						foreach($srnoItem_array[$key] as $key1=>$value2){
								$mix_prescribe->patient_id = $formdata['patient_id'];
								$mix_prescribe->appointment_id =  $formdata['appointment_id'];
								$mix_prescribe->billing_id = $last_billing_id;
								$mix_name = $key1;
								$mix_prescribe->medicine_serial_no = $srnoItem_array[$key][$key1];
								$mix_prescribe->medicine_name = $mix_name;
								$mix_prescribe->factor = $factorItem_array[$key];
								//$get_value_list = gettype($instructionItem_array[$key]);
								if(is_numeric($instructionItem_array[$key])){
									$mix_prescribe->instruction_id = $instructionItem_array[$key];
									$instruction_id = $instructionItem_array[$key];
									// get instruction name
									$ins_name = $this->getInstructions($instruction_id);
									$mix_prescribe->instruction_name = $ins_name->instruction_name;
								}else{
									// get Other value
									$mix_prescribe->instruction_other_value =$instructionItem_array[$key];
								}
								$mix_prescribe->midicine_type  = $medicine_type_array[$key];
								//$mix_prescribe->medicine_id  = $medicine_id_array[$key][$key1];
								//$mix_prescribe->potency_id  = $potency_id_array[$key][$key1];
								$mix_prescribe->save();
								$last_mix_id =  $mix_prescribe->id;
								foreach($medicineItem_array[$key][$key1] as $mkey=>$mix_medicine_value){
									$mix_variant_prescribe = new Prescribemedicine();
									$mix_variant_prescribe->patient_id = $formdata['patient_id'];
									$mix_variant_prescribe->appointment_id =  $formdata['appointment_id'];
									$mix_variant_prescribe->billing_id = $last_billing_id;
									$mix_variant_prescribe->parent_id = $last_mix_id;
									$mix_variant_prescribe->medicine_name =$medicineItem_array[$key][$key1][$mkey];
									$mix_variant_prescribe->potency_name = $potencyItem_array[$key][$key1][$mkey];
									$mix_variant_prescribe->dilution_name = $dilutionItem_array[$key][$key1][$mkey];
									$list_array = explode('-', $formItem_array[$key][$key1][$mkey]);
									$group_id = $list_array[0];
									$form_code = $list_array[1];
									$form_name = $list_array[2];
									$mix_variant_prescribe->group_id = $group_id;
									$mix_variant_prescribe->form_code = $form_code;
									$mix_variant_prescribe->form_name =$form_name;
									// Get each medicine price from pricing class trait
									$form_rate = $this->getPrice($group_id,$form_code,$form_name);
									$mix_variant_prescribe->form_rate =$form_rate->rate;
									// Calcuate each medicine price
									$factor = $factorItem_array[$key];
									$each_form_rate =$form_rate->rate;
									$each_medicine_amount = $factor * $each_form_rate;
									$mix_variant_prescribe->medicine_amount = number_format($each_medicine_amount,2);
									//$mix_variant_prescribe->form_name = $formItem_array[$key][$key1][$mkey];
									$mix_variant_prescribe->midicine_type  = $medicine_type_array[$key];
									//$mix_variant_prescribe->medicine_id  = $medicine_id_array[$key][$key1][$mkey];
									//$mix_variant_prescribe->potency_id  = $potency_id_array[$key][$key1][$mkey];
									$mix_variant_prescribe->save();
								}

						}

					}elseif($medicine_type_array[$key]=='template'){
						$template_prescribe = new Prescribemedicine();
						foreach($srnoItem_array[$key] as $key2=>$value3){
								$template_prescribe->patient_id = $formdata['patient_id'];
								$template_prescribe->appointment_id =  $formdata['appointment_id'];
								$template_prescribe->billing_id = $last_billing_id;
								$mix_name = $key2;
								$template_prescribe->medicine_serial_no = $srnoItem_array[$key][$key2];
								$template_prescribe->medicine_name = $mix_name;
								$template_prescribe->factor = $factorItem_array[$key];
								//$get_value_list = gettype($instructionItem_array[$key]);
								if(is_numeric($instructionItem_array[$key])){
									$template_prescribe->instruction_id = $instructionItem_array[$key];
									$instruction_id = $instructionItem_array[$key];
									// get instruction name
									$ins_name = $this->getInstructions($instruction_id);
									$template_prescribe->instruction_name = $ins_name->instruction_name;
								}else{
									// get Other value
									$template_prescribe->instruction_other_value =$instructionItem_array[$key];
								}
								$template_prescribe->midicine_type  = $medicine_type_array[$key];
								//$template_prescribe->medicine_id  = $medicine_id_array[$key][$key2];
								//$template_prescribe->potency_id  = $potency_id_array[$key][$key2];
								$template_prescribe->save();
								$last_mix_temp_id =  $template_prescribe->id;

								foreach($medicineItem_array[$key][$key2] as $tkey=>$temp_mix_medicine_value){
									$template_variant_prescribe = new Prescribemedicine();
									$template_variant_prescribe->patient_id = $formdata['patient_id'];
									$template_variant_prescribe->appointment_id =  $formdata['appointment_id'];
									$template_variant_prescribe->billing_id = $last_billing_id;
									$template_variant_prescribe->parent_id = $last_mix_temp_id;
									$template_variant_prescribe->medicine_name =$medicineItem_array[$key][$key2][$tkey];
									$template_variant_prescribe->potency_name = $potencyItem_array[$key][$key2][$tkey];
									$template_variant_prescribe->dilution_name = $dilutionItem_array[$key][$key2][$tkey];
									$list_array = explode('-', $formItem_array[$key][$key2][$tkey]);
									$group_id = $list_array[0];
									$form_code = $list_array[1];
									$form_name = $list_array[2];
									$template_variant_prescribe->group_id = $group_id;
									$template_variant_prescribe->form_code = $form_code;
									$template_variant_prescribe->form_name =$form_name;
									// Get each medicine price from pricing class trait
									$form_rate = $this->getPrice($group_id,$form_code,$form_name);
									$template_variant_prescribe->form_rate =$form_rate->rate;
									// Calcuate each medicine price
									$factor = $factorItem_array[$key];
									$each_form_rate =$form_rate->rate;
									$each_medicine_amount = $factor * $each_form_rate;
									$template_variant_prescribe->medicine_amount = number_format($each_medicine_amount,2);

									$template_variant_prescribe->midicine_type  = $medicine_type_array[$key];
									//$template_variant_prescribe->medicine_id  = $medicine_id_array[$key][$key2][$tkey];
									//$template_variant_prescribe->potency_id  = $potency_id_array[$key][$key2][$tkey];
									$template_variant_prescribe->save();
								}

						}
					}elseif($medicine_type_array[$key]=='ontheflymix'){
						$ontheflymix_prescribe = new Prescribemedicine();
						foreach($srnoItem_array[$key] as $key3=>$value4){
								$ontheflymix_prescribe->patient_id = $formdata['patient_id'];
								$ontheflymix_prescribe->appointment_id =  $formdata['appointment_id'];
								$ontheflymix_prescribe->billing_id = $last_billing_id;
								$mix_name = $key3;
								$ontheflymix_prescribe->medicine_serial_no = $srnoItem_array[$key][$key3];
								$ontheflymix_prescribe->medicine_name = $mix_name;
								$ontheflymix_prescribe->factor = $factorItem_array[$key];
								//$get_value_list = gettype($instructionItem_array[$key]);
								if(is_numeric($instructionItem_array[$key])){
									$ontheflymix_prescribe->instruction_id = $instructionItem_array[$key];
									$instruction_id = $instructionItem_array[$key];
									// get instruction name
									$ins_name = $this->getInstructions($instruction_id);
									$ontheflymix_prescribe->instruction_name = $ins_name->instruction_name;
								}else{
									// get Other value
									$ontheflymix_prescribe->instruction_other_value =$instructionItem_array[$key];
								}
								$ontheflymix_prescribe->midicine_type  = 'ontheflymix';
								//$ontheflymix_prescribe->medicine_id  = $medicine_id_array[$key][$key2];
								$ontheflymix_prescribe->save();
								$last_mix_temp_id =  $ontheflymix_prescribe->id;

								foreach($medicineItem_array[$key][$key3] as $otfkey=>$temp_mix_medicine_value){
									$ontheflymix_variant_prescribe = new Prescribemedicine();
									$ontheflymix_variant_prescribe->patient_id = $formdata['patient_id'];
									$ontheflymix_variant_prescribe->appointment_id =  $formdata['appointment_id'];
									$ontheflymix_variant_prescribe->billing_id = $last_billing_id;
									$ontheflymix_variant_prescribe->parent_id = $last_mix_temp_id;
									$ontheflymix_variant_prescribe->medicine_name =$medicineItem_array[$key][$key3][$otfkey];
									$ontheflymix_variant_prescribe->potency_name = $potencyItem_array[$key][$key3][$otfkey];
									$ontheflymix_variant_prescribe->dilution_name = $dilutionItem_array[$key][$key3][$otfkey];
									$ontheflymix_variant_prescribe->form_name = $formItem_array[$key][$key3][$otfkey];
									$list_array = explode('-', $formItem_array[$key][$key3][$otfkey]);
									$group_id = $list_array[0];
									$form_code = $list_array[1];
									$form_name = $list_array[2];
									$ontheflymix_variant_prescribe->group_id = $group_id;
									$ontheflymix_variant_prescribe->form_code = $form_code;
									$ontheflymix_variant_prescribe->form_name =$form_name;
									// Get each medicine price from pricing class trait
									$form_rate = $this->getPrice($group_id,$form_code,$form_name);
									$ontheflymix_variant_prescribe->form_rate =$form_rate->rate;
									// Calcuate each medicine price
									$factor = $factorItem_array[$key];
									$each_form_rate =$form_rate->rate;
									$each_medicine_amount = $factor * $each_form_rate;
									$ontheflymix_variant_prescribe->medicine_amount = number_format($each_medicine_amount,2);

									$ontheflymix_variant_prescribe->midicine_type  = 'ontheflymix';
									//$template_variant_prescribe->medicine_id  = $medicine_id_array[$key][$key2][$otfkey];
									//$ontheflymix_variant_prescribe->potency_id  = $potency_id_array[$key][$key2][$otfkey];
									$ontheflymix_variant_prescribe->save();
								}

						}
					}

					$visit->patient_id =$formdata['patient_id'];
					$visit->appointment_id =$formdata['appointment_id'];
					$visit->billing_id =$last_billing_id;
					$visit->status =1;
					$visit->save();
				}
				$res['error'] = false;
				$res['appointment_id'] = $formdata['appointment_id'];
				$res['billing_id'] = $last_billing_id;
				$res['actions'] = 'add';
				return response($res, 200);
		}else{
			$res['error'] = true;
			$res['actions'] ='datainsufficient';
			return response($res, 200);
		}
	  }

	}
	public function getPrescribeMedicineDetails($appointment_id='', $billing_id='', Request $request){
		try{
			$main_array = array();
			$medicine_array = array();
			$mix_price = array();
			$medicine_total = array();
            if(!empty($appointment_id) && !empty($billing_id)){
				$total=0;
				$precribe_medicine_list = DB::table('billing as b')->LeftJoin('prescribemedicine as pm', 'pm.billing_id', '=', 'b.id')->where('b.status', '=', '1')->where('pm.parent_id', '=', '0')->where('pm.appointment_id', $appointment_id)->where('pm.billing_id', $billing_id)->get();
				foreach ($precribe_medicine_list as $key => $list){
						$total+=$list->medicine_amount;
						$mix_medicine_list = Prescribemedicine::where('parent_id',$list->id)->get();
						foreach ($mix_medicine_list as $key1 => $value){
							array_push($mix_price, $value->medicine_amount);
						}
						$main_array['data']= $precribe_medicine_list[$key];
						$main_array['mix']= $mix_medicine_list;
						array_push($medicine_array,  $main_array);
				}
					//for template total medicine cost if condition
					if(!empty($total) && count($mix_price)>0){
						$total_c = max($mix_price)+$total;
				   //for mix total medicine cost else if condition
					}else if(empty($total) && count($mix_price)>0){
						$total_c = max($mix_price);
					//for single total medicine cost else condition
					}else{
						$total_c = $total;
					}
				$medicine_total['bill_id'] = $precribe_medicine_list[0]->billing_id;
				$medicine_total['visit_id'] = $precribe_medicine_list[0]->appointment_id;
				$medicine_total['total_amount'] = number_format((float)$total_c, 2, '.', '');
				array_push($medicine_total,$medicine_array);
				return response()->json($medicine_total);
			}
    	}catch(\Illuminate\Database\QueryException $ex){

                    $res['status'] = false;
                    $res['message'] = $ex->getMessage();
                    return response($res, 500);

        }

	}
// Apply on the fly discount on the total medicine cost
	public function discountonthefly(Request $request){
		$billing = new Billing();
		if(!empty($request->medicine_total) && !empty($request->discount)){
			if(is_numeric($request->discount) && $request->discount>100){
				$res['error'] = true;
				$res['message'] ='notgreater';
				return response($res, 200);
			}else if(!is_numeric($request->medicine_total)){
				$res['error'] = true;
				$res['message'] ='datainsufficient';
				return response($res, 200);
			}else{
				$main = $request->medicine_total;
				$bill_id = $request->bill_id;
				$visit_id = $request->visit_id;
				$disc = $request->discount;
				$dec = ($disc/100);
				$discount_val = number_format($dec, 2);
				$mult = $main * $discount_val; // gives the value for subtract from main value
				$discont = $main-$mult;
				$billing->discount_before_med_cost =$main;
				$billing->discount_after_med_cost =$discont;
				$billing->discount_on_med =$disc;
				$item = $billing->findOrFail($request->bill_id);
				if($item){
					$billing->where('id', $request->bill_id)->where('appointment_id', $request->visit_id)->update(['discount_before_med_cost'=>$billing->discount_before_med_cost, 'discount_after_med_cost'=>$billing->discount_after_med_cost,'discount_on_med'=>$billing->discount_on_med]);
				}
				$res['error'] = false;
				$res['discount_value'] = $discont;
				$res['message'] = 'applydiscount';
				return response($res, 200);

			}
		}else{
			$res['error'] = true;
			$res['message'] ='datainsufficient';
			return response($res, 200);
		}
	}
// get Previous pending visit
  public function getPatientPreviousPendingAmount($patient_id='', Request $request){
	try{
			if(!empty($patient_id) && $patient_id>0){
				$pendind_list =  DB::table('payment')->where('patient_id', $patient_id)->orderBy('id', 'DESC')->first();
				$res['error'] = false;
			    $res['data'] =$pendind_list;
			    return response($res, 200);
			}
	}catch(\Illuminate\Database\QueryException $ex){
			$res['status'] = false;
			$res['message'] = $ex->getMessage();
			return response($res, 500);
		}
  }
  // Consultancy Waive Function
  public function consultancyWaive(Request $request){
		$billing = new Billing();
		if(!empty($request->consultancy) && !empty($request->bill_id) && !empty($request->visit_id)){
				$main = $request->consultancy;
				$bill_id = $request->bill_id;
				$visit_id = $request->visit_id;
				$billing->wave_consultancy_fees =$main;
				$item = $billing->findOrFail($request->bill_id);
				if($item){
					$billing->where('id', $request->bill_id)->where('appointment_id', $request->visit_id)->update(['waive_consultancy_fees'=>$billing->wave_consultancy_fees]);
				}
				$res['error'] = false;
				$res['message'] = 'consultancywaved';
				return response($res, 200);
		}else{
			$res['error'] = true;
			$res['message'] ='datainsufficient';
			return response($res, 200);
		}
	}
	 // Consultancy Waive Function
	 public function pendingWaive(Request $request){
		$payment = new Payment();
		if(!empty($request->pending) && !empty($request->bill_id) && !empty($request->visit_id)){
				$main = $request->pending;
				$bill_id = $request->bill_id;
				$visit_id = $request->visit_id;
				$payment->waive_pending_amount =$main;
				$item = $payment->findOrFail('billing_id', $request->bill_id);
				if($item){
					$payment->where('billing_id', $request->bill_id)->where('appointment_id', $request->visit_id)->update(['waive_pending_amount'=>$payment->waive_pending_amount]);
				}
				$res['error'] = false;
				$res['message'] = 'consultancywaived';
				return response($res, 200);
		}else{
			$res['error'] = true;
			$res['message'] ='datainsufficient';
			return response($res, 200);
		}
	}
 // Patient Payment Function
 public function patientPayment(Request $request){
	$payment = new Payment();
	$dt =  Carbon::now('Asia/Kolkata');
	if(!empty($request->visit_due) && !empty($request->previous_due) && !empty($request->total_due)  && !empty($request->recieved_amount) && !empty($request->billing_id) && !empty($request->visiting_id) && !empty($request->patient_id) && !empty($request->charge_data) && count($request->charge_data)>0){
			$visit = new Visit();
			$PatientBillingCharge = new PatientBillingCharge();
		// insert charge name and price in billing_patient_charge
			foreach ($request->charge_data as $key => $value){
				$PatientBillingCharge->billing_id = $request->billing_id;
				$PatientBillingCharge->appointment_id = $request->visiting_id;
				$PatientBillingCharge->patient_id = $request->patient_id;
				$PatientBillingCharge->charge_amount = $request->charge_data[$key]['price'];
				$PatientBillingCharge->charge_name = $request->charge_data[$key]['name'];
				$PatientBillingCharge->save();
			}
			$payment->visit_due_amount = $request->visit_due;
			$payment->previous_due_amount = $request->previous_due;
			$payment->total_due_amount = $request->total_due;
			$payment->recieved_amount = $request->recieved_amount;
			$payment->remark = $request->note;
			$payment->billing_id = $request->billing_id;
			$payment->appointment_id = $request->visiting_id;
			$payment->patient_id = $request->patient_id;
			$payment->transaction_mode = 'Cash';
			$payment->transaction_time = $dt;
			$payment->save();

		// insert visit status record in visit_status
			$visit->patient_id =$request->patient_id;
			$visit->appointment_id =$request->visiting_id;
			$visit->billing_id =$request->billing_id;
			$visit->status =2;
			$visit->save();

			$res['error'] = false;
			$res['actions'] = 'add';
			return response($res, 200);

		}else if(!empty($request->visit_due) && !empty($request->previous_due) && !empty($request->total_due)  && !empty($request->recieved_amount) && !empty($request->billing_id) && !empty($request->visiting_id) && !empty($request->patient_id)){
		
			$visit = new Visit();
			$PatientBillingCharge = new PatientBillingCharge();
			// insert payment record in payment 
			$payment->visit_due_amount = $request->visit_due;
			$payment->previous_due_amount = $request->previous_due;
			$payment->total_due_amount = $request->total_due;
			$payment->recieved_amount = $request->recieved_amount;
			$payment->remark = $request->note;
			$payment->billing_id = $request->billing_id;
			$payment->appointment_id = $request->visiting_id;
			$payment->patient_id = $request->patient_id;
			$payment->transaction_mode = 'Cash';
			$payment->transaction_time = $dt;
			$payment->save();

		// insert visit status record in visit_status
			$visit->patient_id =$request->patient_id;
			$visit->appointment_id =$request->visiting_id;
			$visit->billing_id =$request->billing_id;
			$visit->status =2;
			$visit->save();

			$res['error'] = false;
			$res['actions'] = 'add';
			return response($res, 200);
		}else{
			$res['error'] = true;
			$res['message'] ='datainsufficient';
			return response($res, 200);
		}
	}
}
