<?php
namespace App\Modules\Billing\Http\Controllers;
use Illuminate\Http\Request;
use App\Http\Requests;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Validator;
use Illuminate\Validation\ValidationException;
use App\Modules\Billing\Models\Billing;
use App\Modules\Billing\Models\appointments;
use App\Modules\Billing\Models\patients;
use App\Modules\Billing\Models\users;
use App\Modules\Medicine\Models\Medicine;
use App\Modules\Medicine\Models\MedicineGroupPotency;
use App\Modules\Medicine\Models\MedicineGroupPotencyForm;
use App\Modules\Medicine\Models\Medicinegroup;
use App\Modules\Medicine\Models\pricegroup;
use App\Modules\Medicine\Models\potency; //import potency model 
use App\Modules\Medicine\Models\potencygroup; //import potencygroup model 
use App\Modules\Medicine\Models\pricegrouprate;
use App\Modules\Mixmedicine\Models\Medicinemix;
use App\Modules\Mixmedicine\Models\Medicinemixvariant;
use App\Modules\Medicinetemplate\Models\Medicinetemplate;
use App\Modules\Medicinetemplate\Models\Medicinetemplatevariant;
use App\Modules\Billing\Models\Prescribemedicine;
use App\Modules\Billing\Models\Payment;
use App\Modules\Billing\Models\PatientBillingCharge;
use App\Modules\Billing\Models\visitPaymentModes;
use App\Modules\Billing\Models\billingPatientCharge;//This model is used for getting all the patient visit changes which applied, Rahul Khan, 12 July 2019
//use App\Modules\Billing\Models\patient_discount;//This  model is used for patient discount
use App\Modules\Visit\Models\Visit;
use App\Modules\Discount\Models\discount;
use Carbon\Carbon;
use App\Traits\PricingClass; //import pricing class trait
use App\Traits\CommonFunction; //import common method trait
//This imported library is required for Using database directly in lumen
use Illuminate\Support\Facades\DB;
//This below imported Libarary is used for HTTP request for other server
use GuzzleHttp\Client; 
use App\Modules\User\Models\DoctorCharges;//This model for doctor charges
class BillingController extends Controller
{
	use PricingClass;
	use CommonFunction;
	public function getClinicPatients($id='', Request $request)
	{
		//return $request;
		
		$shift_id = $request->shift_id;
		$branch_id = $request->branch_id;
		$stage = $request->stage;
		$date = $request->date;
		$currentDate = Carbon::now();
		if($request->date!=''){
			$currentDate = $request->date;
		}else{
			$currentDate = $currentDate->toDateString();
		}
		//return $request;
//this below code line is used for getting core existing APIs url
		$Core_Api_root = env('CORE_API_ROOT', true);
//In this API Query Parameter We can pass "sort" for on which column we want sort, "order" for order by ASC and DESC,"branch_id" for getting perticular branch Related Data,"shift_id" for getting perticular shift data and "dateTime" for getting data on pertcilular date, 
		$client = new Client();
		

//This below code is used for getting in clinic patients using model but we have commented this because not have all datatable with migrating 
//This code will be used in future when we create first phase with lumen and migrating all the tables, Rahulm Khan 
//return appointments::with(['users','patients'])->whereDate('created_at', '=', Carbon::today()->toDateString())->paginate(10);
		try{//This is url segment for calling old apis "appointments/completed"
				$res = $client->request('GET', $Core_Api_root.'appointments/billclinic',[
					'query' => ['branch_id' => $branch_id, 'dateTime'=>$currentDate, 'shift_id'=> $shift_id, 'stage'=> $stage, 'date'=> $date]
				]);
				if ($res->getStatusCode() == 200) { // 200 OK
					$response_data = $res->getBody()->getContents();
				}
		return $response_data;
		}catch(\Illuminate\Database\QueryException $ex){
						$res['status'] = false;
						$res['message'] = $ex->getMessage();
						return response($res, 500);
		};
	}
	
	public function getPatientDublicateData(Request $request){
	    $Core_Api_root = env('CORE_API_ROOT', true);
		$client = new Client();//dublicatedata
		try{//This is url segment for calling old apis "appointments/branch"
				$res = $client->request('GET', $Core_Api_root.'appointments/dublicatedata');
				if ($res->getStatusCode() == 200) { // 200 OK
					$response_data = $res->getBody()->getContents();
				}
				return $response_data;
		}catch(\Illuminate\Database\QueryException $ex){
						$res['status'] = false;
						$res['message'] = $ex->getMessage();
						return response($res, 500);
		};
	}
	public function getMedicineQueuePatients($id='', Request $request)
	{
//This below code line is used for getting core existing APIs url
	   $Core_Api_root = env('CORE_API_ROOT', true);

		$shift_id = $request->shift_id;
		$branch_id = $request->branch_id;
		$stage = $request->stage;
		$date = $request->date;
		$currentDate = Carbon::now();
		//$currentDate = $currentDate->toDateString();

		if($request->date!=''){
			$currentDate = $request->date;
		}else{
			$currentDate = $currentDate->toDateString();
		}

		$client = new Client();//medqueue
		try{//This is url segment for calling old apis "appointments/branch"
				$res = $client->request('GET', $Core_Api_root.'appointments/medqueue',[
					'query' => ['branch_id' => $branch_id, 'dateTime'=>$currentDate, 'shift_id'=> $shift_id, 'stage'=> $stage, 'date'=> $date]
				]);
				if ($res->getStatusCode() == 200) { // 200 OK
					$response_data = $res->getBody()->getContents();
				}
				return $response_data;
		}catch(\Illuminate\Database\QueryException $ex){
						$res['status'] = false;
						$res['message'] = $ex->getMessage();
						return response($res, 500);
		};


	}
//This below function is used for getting the Patient Details 
	public function getPatientDetails(Request $request){
		
		$Core_Api_root = env('CORE_API_ROOT', true);
		$patient_id = $request->patient_id;
		
		$client = new Client();//medqueue
		try{
			$res = $client->request('GET', $Core_Api_root.'patients/'.$patient_id);
			if ($res->getStatusCode() == 200) { // 200 OK
				$response_data = $res->getBody()->getContents();
			}
			return $response_data;
		}catch(\Illuminate\Database\QueryException $ex){
					$res['status'] = false;
					$res['message'] = $ex->getMessage();
					return response($res, 500);
		};
		
	}

public function getPrescribe($id='', Request $request)
	{
//This below code line is used for getting core existing APIs url
	   $Core_Api_root = env('CORE_API_ROOT', true);
		$client = new Client();
		try{
				$res = $client->request('GET', $Core_Api_root.'appointments/prescribe',[
					'query' => ['id' => $id]
				]);
				if ($res->getStatusCode() == 200) { // 200 OK
					$response_data = $res->getBody()->getContents();
				}
				return $response_data;
		}catch(\Illuminate\Database\QueryException $ex){
						$res['status'] = false;
						$res['message'] = $ex->getMessage();
						return response($res, 500);
		};


	}
//This below function is responsivable to suggesction box
	public function getPrescribeMedicineSearch($id='', Request $request)
	{
		$query = $request->get('query');
		$queryArray = explode(" ",$query);
		$searchString = implode("%", $queryArray);
        if(!empty($query)){
                    $single = DB::table('medicines as m')->select(DB::raw("CAST(cl_p.name AS UNSIGNED) as numeric_potency"), 'p.name as potencyname','p.dilution as dilution','m.name as medicineName',
					DB::raw("'single' as datatype"), 'mgp.potency_id as potenId','mgp.medicine_id as medId')
                    ->join('medicinegroups as mg', 'mg.medicine_id', '=', 'm.id')
                    ->leftjoin('medicinegrouppotencies as mgp', 'mgp.medicinegroup_id', '=', 'mg.id')
					->join('potencies as p', 'p.id', '=', 'mgp.potency_id')
					->where('m.status','=', '1')
					->where('p.status','=', '1')
					->where(DB::raw("CONCAT(cl_m.name,' ', cl_p.name, ' ', cl_p.dilution)"), 'LIKE', $searchString.'%')
					->orderBy('medicineName', 'ASC')
					->orderByRaw('numeric_potency', 'ASC')
					->orderBy('potencyname', 'ASC')
					->orderBy('dilution', 'ASC')
					
					->get();

/*
$queryString = $request->get('query');
		$queryArray = explode(" ",$queryString);
		$firstString = array_shift($queryArray);
		//return $firstString;
		//return $query;
        if(!empty($query)){

                    $single = DB::table('medicines as m')->select('p.name as potencyname','p.dilution as dilution','m.name as medicineName', DB::raw("'single' as datatype"), 'mgp.potency_id as potenId','mgp.medicine_id as medId')
                    ->join('medicinegroups as mg', 'mg.medicine_id', '=', 'm.id')
                    ->join('medicinegrouppotencies as mgp', 'mgp.medicinegroup_id', '=', 'mg.id')
					->join('potencies as p', 'p.id', '=', 'mgp.potency_id')
					->where('m.status','=', '1')
					->where('p.status','=', '1')
					->where('m.name', 'LIKE', $queryString.'%')
					->orWhere(function($query) use ($queryArray){
						for($i=0;$i<count($queryArray);$i++){
							$query->orWhere('p.name', 'LIKE', '%'.$queryArray[$i].'%')
									->orWhere('p.dilution', 'LIKE', '%'.$queryArray[$i].'%')
									->orWhere('m.name', 'LIKE', '%'.$queryArray[$i].'%');
						}
					})
					->get();



					/*$single = DB::table('medicines as m')->select('p.name as potencyname','p.dilution as dilution','m.name as medicineName', DB::raw("'single' as datatype"), 'mgp.potency_id as potenId','mgp.medicine_id as medId')
                    ->join('medicinegroups as mg', 'mg.medicine_id', '=', 'm.id')
                    ->join('medicinegrouppotencies as mgp', 'mgp.medicinegroup_id', '=', 'mg.id')
                    ->join('potencies as p', 'p.id', '=', 'mgp.potency_id')
					->where('m.name', 'LIKE', '%'.$query.'%')
					->where('m.status','=', '1')
					->where('p.status','=', '1')
					->get();*/

                    $mix = DB::table('medicinemix as mm')->select('mm.medicineMixName as medicineName', DB::raw("'mix' as datatype"),'mm.id as medId')
					->where('mm.status','=', '1')
                    ->where('mm.medicineMixName', 'LIKE', '%'.$searchString.'%')
					->orderBy('medicineName', 'ASC')
					->get();
					
					$template = DB::table('medicinetemplate as mt')->select('mt.medicineTempName as medicineName', DB::raw("'template' as datatype"),'mt.id as medId')
					->where('mt.status','=', '1')
                    ->where('mt.medicineTempName', 'LIKE', '%'.$searchString.'%')
					->where('mt.status','=', '1')
					->orderBy('medicineName', 'ASC')
					->get();
					$medicinesearch_list = $single->merge($mix->merge($template));
					$count = count($medicinesearch_list);
					
					$output ='';
					$singleDataTemplate = '';
					$mixDataTemplate = '';
					$templateDataTemplate = '';
					$output.='<ul class="medicine-list">';
					$i = 1;
					if($count>0){
						foreach ($medicinesearch_list as $data_list)
						{
/*

This code is used in previous version of suggestion box
if($data_list->datatype=='single'){
	//In This below line of code we have added the dilution span for displaying in suggestion list, Rahul Khan, 16 Aug 2019
	$singleDataTemplate.= '<li class="formdata text-capitalize" data-potencyname="'.$data_list->potencyname.'" data-dilution="'.$data_list->dilution.'" data-type="'.$data_list->datatype.'" data-med="'.$data_list->medId.'" data-poten="'.$data_list->potenId.'">'.$data_list->medicineName.','.' '.$data_list->potencyname.' ('.$data_list->dilution.') </li>';
}else if($data_list->datatype=='mix'){
	$mixDataTemplate.= '<li class="formdata" data-type="'.$data_list->datatype.'" data-med="'.$data_list->medId.'">'.$data_list->medicineName.'</li>';
}else if($data_list->datatype=='template'){
	$templateDataTemplate.= '<li class="formdata" data-type="'.$data_list->datatype.'" data-med="'.$data_list->medId.'">'.$data_list->medicineName.'</li>';
}
*/

							if($data_list->datatype=='single'){
								//In This below line of code we have added the dilution span for displaying in suggestion list, Rahul Khan, 16 Aug 2019
								$singleDataTemplate.= '<li> <button class="formdata text-capitalize btn-default" data-order="cw_'.$i.'" data-potencyname="'.$data_list->potencyname.'" data-dilution="'.$data_list->dilution.'" data-type="'.$data_list->datatype.'" data-med="'.$data_list->medId.'" data-poten="'.$data_list->potenId.'">'.$data_list->medicineName.','.' '.$data_list->potencyname.' ('.$data_list->dilution.') </button> </li>';
							}else if($data_list->datatype=='mix'){
								$mixDataTemplate.= '<li > <button class="formdata btn-default" data-order="cw_'.$i.'" data-type="'.$data_list->datatype.'" data-med="'.$data_list->medId.'">'.$data_list->medicineName.' </button></li>';
							}else if($data_list->datatype=='template'){
								$templateDataTemplate.= '<li ><button class="formdata btn-default"  data-order="cw_'.$i.'" data-type="'.$data_list->datatype.'" data-med="'.$data_list->medId.'">'.$data_list->medicineName.'</button> </li>';
							}
							
							$i++;
						}
				    }else{
						$output.= '<li>No medicine found </li>';
					}
					if($singleDataTemplate!=''){
						$output.= '<li class="header">Single</li>'.$singleDataTemplate;
					}
					if($mixDataTemplate!=''){
						$output.= '<li class="header">Mix</li>'.$mixDataTemplate;
					}
					if($templateDataTemplate!=''){
						$output.= '<li class="header">Template</li>'.$templateDataTemplate;
					}
                    $output.= '</ul>';
                    
          		  return response($output);

      }

	}
// This function is used to get individual medicine form list
	public function getFormListDropdown($id='', Request $request){
		// This Code for get method
		if($id>0){
			$formdropdown_list = DB::table('medicinemix as mx')->select('mxv.mixMedicineId as mxId','mxv.mixPotencyId as mpId')
			->join('medicinemixvariant as mxv', 'mxv.medicinemixId', '=', 'mx.id')->where('mx.id', $id)->distinct()->get();
			foreach($formdropdown_list as $form_details){
				$form_list = DB::table('medicinegrouppotencies as mgp')->select('f.name as fName','f.id as fId')
				->join('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
				->join('forms as f', 'f.id', '=', 'mgpf.form_id')
				->where('mgp.potency_id', $form_details->mpId)
				->where('mgp.medicine_id', $form_details->mxId)
				->distinct()
				->get();
				return response()->json($form_list);
			}

		}
		// This Code for post method
		if(!empty($request->potency) && !empty($request->medicine)){
			$formdropdown_list = DB::table('medicinegrouppotencies as mgp')
			->select('pg.form_name as fName','mgpf.group_id as gId','pg.form_code as fcode')
			->LeftJoin('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
			->LeftJoin("pricegrouprates as pg",function($join){
				$join->on("pg.pricegroup_id","=","mgpf.group_id")
					->on("pg.form_code","=","mgpf.form_code");
				})
			->where('mgp.medicine_id', $request->medicine)
			->where('mgp.potency_id', $request->potency)
			->orderBy('pg.form_code', 'asc')
			->where('pg.status', '1')
			->distinct()
			->orderBy('fName', 'asc')
			->get();
			return response()->json($formdropdown_list);
			}

		} 
// This function is used to get mix medicine data with individual mix id
	public function getMixMedicine(Request $request){
		$main_array = array();
		$medicine_array = array();
		if(!empty($request->mix_medicine_id)){
			$mix_medicine_list = DB::table('medicinemix as mm')->select('mm.id as mixId','mm.medicineMixName as mName','mmv.mixMedicineId as medId', 'mmv.mixPotencyId as pId', 'mmv.medicinemixtureName as mixMedicineName','p.name as potencyname','p.dilution as dilution','mmv.medicineMixFormName as fName', 'mmv.medicineMixFormCode as fcode','mmv.medicineMixFormGroupId as fId')
			->LeftJoin('medicinemixvariant as mmv', 'mmv.medicinemixId', '=', 'mm.id')
			->LeftJoin('potencies as p', 'p.id', '=', 'mmv.mixPotencyId')
			->where('mm.status', '1')
			->where('p.status', '1')
			->where('mm.id', $request->mix_medicine_id)
			->get();
			 foreach ($mix_medicine_list as $key => $value){
				$mix_medicine_form_list = DB::table('medicinegrouppotencies as mgp')->select('pg.form_name as fName','mgpf.group_id as gId','pg.form_code as fcode')
				->join('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
				->LeftJoin("pricegrouprates as pg",function($join){
					$join->on("pg.pricegroup_id","=","mgpf.group_id")
						->on("pg.form_code","=","mgpf.form_code");
					})
				/* comment query as on 8 Aug By Shubh Tiwari for mix medicine form */	
				//->join('forms as f', 'f.id', '=', 'mgpf.form_id')
				->where('pg.status', '1')
				->where('mgp.potency_id', $value->pId)
				->where('mgp.medicine_id', $value->medId)
				->groupBy('mgpf.form_id')
				->get();
				$main_array['medicine']= $mix_medicine_list[$key];
				$main_array['form']= $mix_medicine_form_list;
				array_push($medicine_array,  $main_array);
			 }
			return response()->json($medicine_array);
		}
	}
	// This function is used to get template medicine data with individual template id
	public function getTemplateMedicine(Request $request){
				$single_array = [];
				if(!empty($request->template_id) && $request->template_id>0){

					$temp_medicine_list = DB::table('medicinetemplate as mt')
										->select('mtv.medicineTempFormCode as f_code','mtv.medicineTempFormName as f_name','mt.pharmacy_instruction as pIns','mtv.medicine_type as mtype','mtv.templatemixNo as mserialNo','mt.medicineTempName as mName','mt.id as tempId','mtv.mixMedicineId as medId', 'mtv.tempPotencyId as pId', 'mtv.medicineTempMixtureName as mixMedicineName','mtv.instructionId as Iid','mtv.instruction_name as Iname','mtv.instruction_other_value as Oname'
										, DB::raw("(SELECT pt.name FROM cl_potencies as pt WHERE pt.id = pId and pt.status='1') as potency_name"),DB::raw("(SELECT pt.dilution FROM cl_potencies as pt WHERE pt.id = pId and pt.status='1') as dilution_name"), DB::raw("(SELECT medi.name FROM cl_medicines as medi WHERE medi.id = medId and medi.status='1') as medicine_name"))
										->LeftJoin('medicinetemplatevariant as mtv', 'mtv.medicinetempId', '=', 'mt.id')
										->where('mt.status', '1')
										->where('mt.id', $request->template_id)
										->orderBy('mt.id', 'asc')
										->distinct()
										->get();
				foreach ($temp_medicine_list as $key => $value){
						        $mix_array = [];
								$single_medicine_list = DB::table('medicinegrouppotencies as mgp')->select('pg.form_name as form_name','mgpf.group_id as group_id','pg.form_code as form_code')
								->LeftJoin('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
								->LeftJoin("pricegrouprates as pg",function($join){
									$join->on("pg.pricegroup_id","=","mgpf.group_id")
										->on("pg.form_code","=","mgpf.form_code");
									})
								->where('pg.status', '1')
								->where('mgp.potency_id', $value->pId)
								->where('mgp.medicine_id', $value->medId)
								->groupBy('mgpf.form_code')
								->distinct()
								->get();
							 $mix_array = $temp_medicine_list[$key];
							if($value->mtype=='single'){
									$mix_array->form = $single_medicine_list;
									$mix_array->mix = [];
							}
							$mix_medicine_list = DB::table('medicinemix as mm')->select('mm.id as mixId','mm.medicineMixName as mName','mmv.mixMedicineId as medId', 'mmv.mixPotencyId as pId', 'm.name as mixMedicineName','p.name as potencyname','p.dilution as dilution','mmv.medicineMixFormName as fName', 'mmv.medicineMixFormCode as fcode','mmv.medicineMixFormCode as fId')
							->LeftJoin('medicinemixvariant as mmv', 'mmv.medicinemixId', '=', 'mm.id')
							->LeftJoin('medicines as m', 'm.id', '=', 'mmv.mixMedicineId')
							->LeftJoin('potencies as p', 'p.id', '=', 'mmv.mixPotencyId')
							->where('mm.status', '1')
							->where('p.status', '1')
							->where('mm.id', $value->medId)
							->distinct()
							->get();
							 foreach ($mix_medicine_list as $key => $value1){
								$mix_array->mix = $mix_medicine_list;
								$mix_medicine_form_list = DB::table('medicinegrouppotencies as mgp')->select('pg.form_name as form_name','mgpf.group_id as group_id','pg.form_code as form_code')
								->LeftJoin('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
								->LeftJoin("pricegrouprates as pg",function($join){
									$join->on("pg.pricegroup_id","=","mgpf.group_id")
										->on("pg.form_code","=","mgpf.form_code");
									})
								->where('pg.status', '1')
								->where('mgp.potency_id', $value1->pId)
								->where('mgp.medicine_id', $value1->medId)
								->groupBy('mgpf.form_id')
								->distinct()
								->get();
								$mix_array->form =$mix_medicine_form_list;
								/* $template_array[$value->mixMedicineName]['medicine'][$key]= $mix_medicine_list[$key];
								$template_array[$value->mixMedicineName]['serial_no'] = $value->mserialNo;
								$template_array[$value->mixMedicineName]['mix_name'] = $value->mixMedicineName;
								$template_array[$value->mixMedicineName]['mix_id'] = $value->medId;
								$template_array[$value->mixMedicineName]['form_code'] = $value->f_code;
								$template_array[$value->mixMedicineName]['instruction_id'] = $value->Iid;
								$template_array[$value->mixMedicineName]['instruction_other'] = $value->Oname;
								$template_array[$value->mixMedicineName]['instruction_name'] = $value->Iname;
								$template_array[$value->mixMedicineName]['form'][$key]= $mix_medicine_form_list; */
							 }
						 array_push($single_array,  $mix_array);
				}
				return response()->json($single_array);
			}
	}
	//This functtion is used for post prescribe medicine data 
	public function createPrescribe(Request $request){
		parse_str($request->formdata, $formdata);//This will convert the string to array
		//return
		//creating a validator
		$validator = Validator::make($formdata, $request->all(), [
			'srnoItem' => 'required|array',
			'medicineItem' => 'required|array',
			'potencyItem' => 'required|array',
			'dilutionItem' => 'required|array',
			'formItem' => 'required|array',
			'instructionItem' => 'required|array',
			'precribe_pharmacy_instruction' => 'required'
		]);

		//if validation fails
		if ($validator->fails()){
			return array(
				'error' => true,
				'message' => $validator->errors()->all()
			);
		}
		
		// echo '<pre>';
		// print_r($formdata);
		//dd($formdata);
		$srnoItem_array = $formdata['srnoItem'];
		$medicine_type_array = $formdata['medicine_type'];
		$medicineItem_array = $formdata['medicineItem'];
		$potencyItem_array = $formdata['potencyItem'];
		$dilutionItem_array = $formdata['dilutionItem'];
		$formItem_array = $formdata['formItem'];
		$factorItem_array = $formdata['factorItem'];
		$medicineVial_array = $formdata['medicineVial'];
		$instructionItem_array = $formdata['instructionItem'];
		$instruction_array = $formdata['instruction'];
		$medicine_id_array = $formdata['medicine_id'];
		$potency_id_array = $formdata['potency_id'];
		$appointment_id = $formdata['appointment_id'];
	//This condition is used to check the billing_id exist in requesting parameter or not, Rahul Khan, 26 Sept 2019
		if(array_key_exists("billing_id",$formdata) ){
			$billing_id = $formdata['billing_id'];
		}
		
		$page = $formdata['page'];

		// for update medicine data
		if((!empty($billing_id) && !empty($page) && $page="prescribeedit") && (!empty($formdata['patient_id']) && !empty($formdata['appointment_id'])) && (!empty($srnoItem_array) && count($srnoItem_array)>0) && (!empty($medicine_type_array) && count($medicine_type_array)>0) && (!empty($medicineItem_array) && count($medicineItem_array)>0) && (!empty($potencyItem_array) && count($potencyItem_array)>0) && (!empty($dilutionItem_array) && count($dilutionItem_array)>0) && (!empty($factorItem_array) && count($factorItem_array)>0) && (!empty($instructionItem_array) && count($instructionItem_array)>0) && (!empty($formItem_array) && count($formItem_array)>0)){
			//Billing::where('id', $billing_id)->delete();
			//Visit::where('billing_id', $billing_id)->delete();
			//Prescribemedicine::where('billing_id', $billing_id)->delete();
			$billing = new Billing();
			$visit = new Visit();
			$billing->patient_id = $formdata['patient_id'];
			$billing->appointment_id = $formdata['appointment_id'];
			$billing->doctor_id = $formdata['doctor_id'];
			$billing->pharmacy_instruction = $formdata['precribe_pharmacy_instruction'];
			$billing->edit_reason =$request->edit_reason;
			$billing->importvisitid =$formdata['importvisitid'];
			$billing->created_by = $request->user_id;
			$billing->save();
			$last_billing_id =  $billing->id;
			foreach($srnoItem_array as $key=>$value){
				if($medicine_type_array[$key]=='single'){
					$prescribe = new Prescribemedicine();
					$prescribe->patient_id = $formdata['patient_id'];
					$prescribe->appointment_id =  $formdata['appointment_id'];
					$prescribe->created_by =   $request->user_id;
					$prescribe->billing_id = $last_billing_id;
					$prescribe->medicine_serial_no = $srnoItem_array[$key];
					$prescribe->medicine_name = $medicineItem_array[$key];
					$prescribe->potency_name = $potencyItem_array[$key];
					$prescribe->dilution_name = $dilutionItem_array[$key];
					$list_array = explode('-', $formItem_array[$key]);
					$group_id = $list_array[0];
					$form_code = $list_array[1];
					$form_name = $list_array[2];
					$prescribe->group_id = $group_id;
					$prescribe->form_code = $form_code;
					$prescribe->form_name =$form_name;
					// Get each medicine price from pricing class trait
					$form_rate = $this->getPrice($group_id,$form_code,$form_name);
					$prescribe->form_rate =$form_rate->rate;
					// Calcuate each medicine price
					$factor = $factorItem_array[$key];
					$each_form_rate =$form_rate->rate;
					$each_medicine_amount = $factor * $each_form_rate;
					$prescribe->medicine_amount = number_format((float)$each_medicine_amount, 2, '.', '');
					$prescribe->factor = $factorItem_array[$key];
					$prescribe->vial = $medicineVial_array[$key];
					
					$prescribe->instruction_name  = $instruction_array[$key];
					/* if(is_numeric($instructionItem_array[$key])){
						$prescribe->instruction_id = $instructionItem_array[$key];
						$instruction_id = $instructionItem_array[$key];
						// get instruction name
						$ins_name = $this->getInstructions($instruction_id);
						$prescribe->instruction_name = $ins_name->instruction_name;
					}else{
						// get Other value
						$prescribe->instruction_other_value =$instructionItem_array[$key];
					} */
					$prescribe->midicine_type  = $medicine_type_array[$key];
					$prescribe->medicine_id  = $medicine_id_array[$key];
					$prescribe->potency_id  = $potency_id_array[$key];
					$prescribe->save();
					
				}elseif($medicine_type_array[$key]=='mix'){
					$mix_prescribe = new Prescribemedicine();
					foreach($srnoItem_array[$key] as $key1=>$value2){
							$mix_prescribe->patient_id = $formdata['patient_id'];
							$mix_prescribe->appointment_id =  $formdata['appointment_id'];
							$mix_prescribe->created_by =  $request->user_id;
							$mix_prescribe->billing_id = $last_billing_id;
							$mix_name = $key1;
							$mix_prescribe->medicine_serial_no = $srnoItem_array[$key][$key1];
							$mix_prescribe->medicine_name = $mix_name;
							$mix_prescribe->factor = $factorItem_array[$key];
							$mix_prescribe->vial = $medicineVial_array[$key];
							//$get_value_list = gettype($instructionItem_array[$key]);
							
							$mix_prescribe->instruction_name = $instruction_array[$key];
							/* if(is_numeric($instructionItem_array[$key])){
								$mix_prescribe->instruction_id = $instructionItem_array[$key];
								$instruction_id = $instructionItem_array[$key];
								// get instruction name
								$ins_name = $this->getInstructions($instruction_id);
								$mix_prescribe->instruction_name = $ins_name->instruction_name;
							}else{
								// get Other value
								$mix_prescribe->instruction_other_value =$instructionItem_array[$key];
							} */
							$mix_prescribe->midicine_type  = $medicine_type_array[$key];
							$mix_prescribe->medicine_id  = $medicine_id_array[$key][$key1][$medicine_type_array[$key]];
							
							//return $formItem_array[$key];
								//This code is copied from the below loop beacause now we are using form as single medicine, 06 sept 2019 Rahul Khan
									$list_array = explode('-', $formItem_array[$key]);//This line is change for new version as single medicine
									$group_id = $list_array[0];
									$form_code = $list_array[1];
									$form_name = $list_array[2];
									$mix_prescribe->group_id = $group_id;
									$mix_prescribe->form_code = $form_code;
									$mix_prescribe->form_name =$form_name;
									/*end code here */
							//This code  is used for geting the Rate of prescribe mix
									$form_rate = $this->getPrice($group_id,$form_code,$form_name);
								//	returnform_rate;
									$mix_prescribe->form_rate =$form_rate;

									$mix_prescribe->save();
									$last_mix_id =  $mix_prescribe->id;
							foreach($medicineItem_array[$key][$key1] as $mkey=>$mix_medicine_value){
								$mix_variant_prescribe = new Prescribemedicine();
								$mix_variant_prescribe->patient_id = $formdata['patient_id'];
								$mix_variant_prescribe->appointment_id =  $formdata['appointment_id'];
								$mix_variant_prescribe->created_by =  $request->user_id;
								$mix_variant_prescribe->billing_id = $last_billing_id;
								$mix_variant_prescribe->parent_id = $last_mix_id;
								$mix_variant_prescribe->medicine_name =$medicineItem_array[$key][$key1][$mkey];
								$mix_variant_prescribe->potency_name = $potencyItem_array[$key][$key1][$mkey];
								$mix_variant_prescribe->dilution_name = $dilutionItem_array[$key][$key1][$mkey];
								//$list_array = explode('-', $formItem_array[$key][$key1][$mkey]);
								//$list_array = explode('-', $formItem_array[$key]);//This line is change for new version as single medicine
								//$group_id = $list_array[0];
								//$form_code = $list_array[1];
								//$form_name = $list_array[2];
								//$mix_variant_prescribe->group_id = $group_id;
								//$mix_variant_prescribe->form_code = $form_code;
								//$mix_variant_prescribe->form_name =$form_name;
								// Get each medicine price from pricing class trait
								$form_rate = $this->getPrice($group_id,$form_code,$form_name);
								$mix_variant_prescribe->form_rate =$form_rate->rate;
								// Calcuate each medicine price
								$factor = $factorItem_array[$key];
								$each_form_rate =$form_rate->rate;
								$each_medicine_amount = $factor * $each_form_rate;
								$mix_variant_prescribe->medicine_amount = number_format((float)$each_medicine_amount, 2, '.', '');
								//$mix_variant_prescribe->form_name = $formItem_array[$key][$key1][$mkey];
								$mix_variant_prescribe->midicine_type  = $medicine_type_array[$key];
								$mix_variant_prescribe->medicine_id  = $medicine_id_array[$key][$key1][$mkey];
								$mix_variant_prescribe->potency_id  = $potency_id_array[$key][$key1][$mkey];
								$mix_variant_prescribe->save();
							}

					}
				}elseif($medicine_type_array[$key]=='template'){
					$template_prescribe = new Prescribemedicine();
					foreach($srnoItem_array[$key] as $key2=>$value3){
							$template_prescribe->patient_id = $formdata['patient_id'];
							$template_prescribe->appointment_id =  $formdata['appointment_id'];
							$template_prescribe->created_by =  $request->user_id;
							$template_prescribe->billing_id = $last_billing_id;
							$mix_name = $key2;
							$template_prescribe->medicine_serial_no = $srnoItem_array[$key][$key2];
							$template_prescribe->medicine_name = $mix_name;
							$template_prescribe->factor = $factorItem_array[$key];
							$template_prescribe->vial = $medicineVial_array[$key];
							//$get_value_list = gettype($instructionItem_array[$key]);
							$template_prescribe->instruction_name = $instruction_array[$key];
							/* if(is_numeric($instructionItem_array[$key])){
								$template_prescribe->instruction_id = $instructionItem_array[$key];
								$instruction_id = $instructionItem_array[$key];
								// get instruction name
								$ins_name = $this->getInstructions($instruction_id);
								$template_prescribe->instruction_name = $ins_name->instruction_name;
							}else{
								// get Other value
								$template_prescribe->instruction_other_value =$instructionItem_array[$key];
							} */
							$template_prescribe->midicine_type  = $medicine_type_array[$key];
							//$template_prescribe->medicine_id  = $medicine_id_array[$key][$key2];
							//$template_prescribe->potency_id  = $potency_id_array[$key][$key2];
							$template_prescribe->save();
							$last_mix_temp_id =  $template_prescribe->id;

							foreach($medicineItem_array[$key][$key2] as $tkey=>$temp_mix_medicine_value){
								$template_variant_prescribe = new Prescribemedicine();
								$template_variant_prescribe->patient_id = $formdata['patient_id'];
								$template_variant_prescribe->appointment_id =  $formdata['appointment_id'];
								$template_variant_prescribe->created_by =  $request->user_id;
								$template_variant_prescribe->billing_id = $last_billing_id;
								$template_variant_prescribe->parent_id = $last_mix_temp_id;
								$template_variant_prescribe->medicine_name =$medicineItem_array[$key][$key2][$tkey];
								$template_variant_prescribe->potency_name = $potencyItem_array[$key][$key2][$tkey];
								$template_variant_prescribe->dilution_name = $dilutionItem_array[$key][$key2][$tkey];
								$list_array = explode('-', $formItem_array[$key][$key2][$tkey]);
								$group_id = $list_array[0];
								$form_code = $list_array[1];
								$form_name = $list_array[2];
								$template_variant_prescribe->group_id = $group_id;
								$template_variant_prescribe->form_code = $form_code;
								$template_variant_prescribe->form_name =$form_name;
								// Get each medicine price from pricing class trait
								$form_rate = $this->getPrice($group_id,$form_code,$form_name);
								$template_variant_prescribe->form_rate =$form_rate->rate;
								// Calcuate each medicine price
								$factor = $factorItem_array[$key];
								$each_form_rate =$form_rate->rate;
								$each_medicine_amount = $factor * $each_form_rate;
								$template_variant_prescribe->medicine_amount = number_format((float)$each_medicine_amount, 2, '.', '');

								$template_variant_prescribe->midicine_type  = $medicine_type_array[$key];
								//$template_variant_prescribe->medicine_id  = $medicine_id_array[$key][$key2][$tkey];
								//$template_variant_prescribe->potency_id  = $potency_id_array[$key][$key2][$tkey];
								$template_variant_prescribe->save();
							}
					}
				}elseif($medicine_type_array[$key]=='ontheflymix'){
					$ontheflymix_prescribe = new Prescribemedicine();
					foreach($srnoItem_array[$key] as $key3=>$value4){
							$ontheflymix_prescribe->patient_id = $formdata['patient_id'];
							$ontheflymix_prescribe->appointment_id =  $formdata['appointment_id'];
							$ontheflymix_prescribe->created_by =  $request->user_id;
							$ontheflymix_prescribe->billing_id = $last_billing_id;
							$mix_name = $key3;
							$ontheflymix_prescribe->medicine_serial_no = $srnoItem_array[$key][$key3];
							$ontheflymix_prescribe->medicine_name = $mix_name;
							$ontheflymix_prescribe->factor = $factorItem_array[$key];
							$ontheflymix_prescribe->vial = $medicineVial_array[$key];
							//$get_value_list = gettype($instructionItem_array[$key]);
							$ontheflymix_prescribe->instruction_name = $instruction_array[$key];
							/* if(is_numeric($instructionItem_array[$key])){
								$ontheflymix_prescribe->instruction_id = $instructionItem_array[$key];
								$instruction_id = $instructionItem_array[$key];
								// get instruction name
								$ins_name = $this->getInstructions($instruction_id);
								$ontheflymix_prescribe->instruction_name = $ins_name->instruction_name;
							}else{
								// get Other value
								$ontheflymix_prescribe->instruction_other_value =$instructionItem_array[$key];
							} */
							$ontheflymix_prescribe->midicine_type  = 'ontheflymix';
							//$ontheflymix_prescribe->medicine_id  = $medicine_id_array[$key][$key2];
							//return $formItem_array[$key];
								//This code is copied from the below loop beacause now we are using form as single medicine, 06 sept 2019 Rahul Khan
								$list_array = explode('-', $formItem_array[$key]);//This line is change for new version as single medicine
								$group_id = $list_array[0];
								$form_code = $list_array[1];
								$form_name = $list_array[2];
								$ontheflymix_prescribe->group_id = $group_id;
								$ontheflymix_prescribe->form_code = $form_code;
								$ontheflymix_prescribe->form_name =$form_name;
								/*end code here */
						//This code  is used for geting the Rate of prescribe mix
								$form_rate = $this->getPrice($group_id,$form_code,$form_name);
							//	returnform_rate;
								$ontheflymix_prescribe->form_rate =$form_rate;

								$ontheflymix_prescribe->save();
								$last_mix_temp_id =  $ontheflymix_prescribe->id;

							foreach($medicineItem_array[$key][$key3] as $otfkey=>$temp_mix_medicine_value){
								$ontheflymix_variant_prescribe = new Prescribemedicine();
								$ontheflymix_variant_prescribe->patient_id = $formdata['patient_id'];
								$ontheflymix_variant_prescribe->appointment_id =  $formdata['appointment_id'];
								$ontheflymix_variant_prescribe->created_by =  $request->user_id;
								$ontheflymix_variant_prescribe->billing_id = $last_billing_id;
								$ontheflymix_variant_prescribe->parent_id = $last_mix_temp_id;
								$ontheflymix_variant_prescribe->medicine_name =$medicineItem_array[$key][$key3][$otfkey];
								$ontheflymix_variant_prescribe->potency_name = $potencyItem_array[$key][$key3][$otfkey];
								$ontheflymix_variant_prescribe->dilution_name = $dilutionItem_array[$key][$key3][$otfkey];
								//$ontheflymix_variant_prescribe->form_name = $formItem_array[$key][$key3][$otfkey];
								/*This line is commented for settting on the fly mix as single medicine
								$list_array = explode('-', $formItem_array[$key][$key3][$otfkey]);
								$group_id = $list_array[0];
								$form_code = $list_array[1];
								$form_name = $list_array[2];
								$ontheflymix_variant_prescribe->group_id = $group_id;
								$ontheflymix_variant_prescribe->form_code = $form_code;
								$ontheflymix_variant_prescribe->form_name =$form_name;*/
								// Get each medicine price from pricing class trait
								$form_rate = $this->getPrice($group_id,$form_code,$form_name);
								$ontheflymix_variant_prescribe->form_rate =$form_rate->rate;
								// Calcuate each medicine price
								$factor = $factorItem_array[$key];
								$each_form_rate =$form_rate->rate;
								$each_medicine_amount = $factor * $each_form_rate;
								$ontheflymix_variant_prescribe->medicine_amount = number_format((float)$each_medicine_amount, 2, '.', '');
								$ontheflymix_variant_prescribe->midicine_type  = 'ontheflymix';
								$ontheflymix_variant_prescribe->medicine_id  = $medicine_id_array[$key][$key3][$otfkey];
								$ontheflymix_variant_prescribe->potency_id  = $potency_id_array[$key][$key3][$otfkey];
								$ontheflymix_variant_prescribe->save();
							}

					}
				}
				$visit->patient_id =$formdata['patient_id'];
				$visit->appointment_id =$formdata['appointment_id'];
				$visit->billing_id =$last_billing_id;
				$visit->visit_status =1;
				$visit->created_by =  $request->user_id;
				$visit->save();
			}
			$res['error'] = false;
			$res['patient_id'] = $formdata['patient_id'];
			$res['appointment_id'] = $formdata['appointment_id'];
			$res['importvisitid'] = $formdata['importvisitid'];
			$res['billing_id'] = $last_billing_id;
			$res['actions'] = 'add';
			return response($res, 200);
		}else if((!empty($page) && $page="prescribeadd") &&(!empty($formdata['patient_id']) && !empty($formdata['appointment_id'])) && (!empty($srnoItem_array) && count($srnoItem_array)>0) && (!empty($medicine_type_array) && count($medicine_type_array)>0) && (!empty($medicineItem_array) && count($medicineItem_array)>0) && (!empty($potencyItem_array) && count($potencyItem_array)>0) && (!empty($dilutionItem_array) && count($dilutionItem_array)>0) && (!empty($factorItem_array) && count($factorItem_array)>0) && (!empty($instructionItem_array) && count($instructionItem_array)>0) && (!empty($formItem_array) && count($formItem_array)>0)){
				$billing = new Billing();
				$visit = new Visit();
				$billing->patient_id = $formdata['patient_id'];
				$billing->appointment_id = $formdata['appointment_id'];
				$billing->doctor_id = $formdata['doctor_id'];
				$billing->pharmacy_instruction = $formdata['precribe_pharmacy_instruction'];
				$billing->created_by = $request->user_id;
				$billing->edit_reason =$request->edit_reason;
				$billing->importvisitid =$formdata['importvisitid'];
				$billing->save();
				$last_billing_id = $billing->id;
				foreach($srnoItem_array as $key=>$value){
					if($medicine_type_array[$key]=='single'){
						$prescribe = new Prescribemedicine();
						$prescribe->patient_id = $formdata['patient_id'];
						$prescribe->appointment_id =  $formdata['appointment_id'];
						$prescribe->created_by =  $request->user_id;
						$prescribe->billing_id = $last_billing_id;
						$prescribe->medicine_serial_no = $srnoItem_array[$key];
						$prescribe->medicine_name = $medicineItem_array[$key];
						$prescribe->potency_name = $potencyItem_array[$key];
						$prescribe->dilution_name = $dilutionItem_array[$key];
						$list_array = explode('-', $formItem_array[$key]);
						$group_id = $list_array[0];
						$form_code = $list_array[1];
						$form_name = $list_array[2];
						$prescribe->group_id = $group_id;
						$prescribe->form_code = $form_code;
						$prescribe->form_name =$form_name;
						// Get each medicine price from pricing class trait
						$form_rate = $this->getPrice($group_id,$form_code,$form_name);
						$prescribe->form_rate =$form_rate->rate;
						// Calcuate each medicine price
						$factor = $factorItem_array[$key];
						$each_form_rate =$form_rate->rate;
						$each_medicine_amount = $factor * $each_form_rate;
						$prescribe->medicine_amount = number_format((float)$each_medicine_amount, 2, '.', '');
						$prescribe->factor = $factorItem_array[$key];
						$prescribe->vial = $medicineVial_array[$key];
						//$get_value_list = is_numeric($instructionItem_array[$key]);
						$prescribe->instruction_name = $instruction_array[$key];
						/* if(is_numeric($instructionItem_array[$key])){
							$prescribe->instruction_id = $instructionItem_array[$key];
							$instruction_id = $instructionItem_array[$key];
							// get instruction name
							$ins_name = $this->getInstructions($instruction_id);
							$prescribe->instruction_name = $ins_name->instruction_name;
						}else{
							// get Other value
							$prescribe->instruction_other_value =$instructionItem_array[$key];
						} */
						$prescribe->midicine_type  = $medicine_type_array[$key];
						$prescribe->medicine_id  = $medicine_id_array[$key];
						$prescribe->potency_id  = $potency_id_array[$key];
						$prescribe->save();
						
					}elseif($medicine_type_array[$key]=='mix'){
						$mix_prescribe = new Prescribemedicine();
						foreach($srnoItem_array[$key] as $key1=>$value2){
								$mix_prescribe->patient_id = $formdata['patient_id'];
								$mix_prescribe->appointment_id =  $formdata['appointment_id'];
								$mix_prescribe->created_by =  $request->user_id;
								$mix_prescribe->billing_id = $last_billing_id;
								$mix_name = $key1;
								$mix_prescribe->medicine_serial_no = $srnoItem_array[$key][$key1];
								$mix_prescribe->medicine_name = $mix_name;
								$mix_prescribe->factor = $factorItem_array[$key];
								$mix_prescribe->vial = $medicineVial_array[$key];
								//$get_value_list = gettype($instructionItem_array[$key]);
								$mix_prescribe->instruction_name = $instruction_array[$key];
								/* if(is_numeric($instructionItem_array[$key])){
									$mix_prescribe->instruction_id = $instructionItem_array[$key];
									$instruction_id = $instructionItem_array[$key];
									// get instruction name
									$ins_name = $this->getInstructions($instruction_id);
									$mix_prescribe->instruction_name = $ins_name->instruction_name;
								}else{
									// get Other value
									$mix_prescribe->instruction_other_value =$instructionItem_array[$key];
								} */
								$mix_prescribe->midicine_type  = $medicine_type_array[$key];
								$mix_prescribe->medicine_id  = $medicine_id_array[$key][$key1][$medicine_type_array[$key]];
								
								//return $formItem_array[$key];
								//This code is copied from the below loop beacause now we are using form as single medicine, 06 sept 2019 Rahul Khan
								$list_array = explode('-', $formItem_array[$key]);//This line is change for new version as single medicine
									$group_id = $list_array[0];
									$form_code = $list_array[1];
									$form_name = $list_array[2];
									$mix_prescribe->group_id = $group_id;
									$mix_prescribe->form_code = $form_code;
									$mix_prescribe->form_name =$form_name;
									/*end code here */
							//This code  is used for geting the Rate of prescribe mix
									$form_rate = $this->getPrice($group_id,$form_code,$form_name);
									//return $form_rate;
									$mix_prescribe->form_rate =$form_rate;
									$mix_prescribe->save();
									$last_mix_id =  $mix_prescribe->id;

									
								foreach($medicineItem_array[$key][$key1] as $mkey=>$mix_medicine_value){
									$mix_variant_prescribe = new Prescribemedicine();
									$mix_variant_prescribe->patient_id = $formdata['patient_id'];
									$mix_variant_prescribe->appointment_id =  $formdata['appointment_id'];
									$mix_variant_prescribe->created_by =  $request->user_id;
									$mix_variant_prescribe->billing_id = $last_billing_id;
									$mix_variant_prescribe->parent_id = $last_mix_id;
									$mix_variant_prescribe->medicine_name =$medicineItem_array[$key][$key1][$mkey];
									$mix_variant_prescribe->potency_name = $potencyItem_array[$key][$key1][$mkey];
									$mix_variant_prescribe->dilution_name = $dilutionItem_array[$key][$key1][$mkey];
								//	$list_array = explode('-', $formItem_array[$key][$key1][$mkey]);//This line is used for prevoiuos version
									//$list_array = explode('-', $formItem_array[$key]);//This line is change for new version as single medicine
									//$group_id = $list_array[0];
									//$form_code = $list_array[1];
									//$form_name = $list_array[2];
									//$mix_variant_prescribe->group_id = $group_id;
									//$mix_variant_prescribe->form_code = $form_code;
									//$mix_variant_prescribe->form_name =$form_name;
									// Get each medicine price from pricing class trait
									
									$form_rate = $this->getPrice($group_id,$form_code,$form_name);
									$mix_variant_prescribe->form_rate =$form_rate->rate;
									// Calcuate each medicine price
									$factor = $factorItem_array[$key];
									$each_form_rate =$form_rate->rate;
									$each_medicine_amount = $factor * $each_form_rate;
									$mix_variant_prescribe->medicine_amount = number_format((float)$each_medicine_amount, 2, '.', '');
									//$mix_variant_prescribe->form_name = $formItem_array[$key][$key1][$mkey];
									$mix_variant_prescribe->midicine_type  = $medicine_type_array[$key];
									$mix_variant_prescribe->medicine_id  = $medicine_id_array[$key][$key1][$mkey];
									$mix_variant_prescribe->potency_id  = $potency_id_array[$key][$key1][$mkey];
									$mix_variant_prescribe->save();
								}

						}
					}elseif($medicine_type_array[$key]=='template'){
						$template_prescribe = new Prescribemedicine();
						foreach($srnoItem_array[$key] as $key2=>$value3){
								$template_prescribe->patient_id = $formdata['patient_id'];
								$template_prescribe->appointment_id =  $formdata['appointment_id'];
								$template_prescribe->created_by =  $request->user_id;
								$template_prescribe->billing_id = $last_billing_id;
								$mix_name = $key2;
								$template_prescribe->medicine_serial_no = $srnoItem_array[$key][$key2];
								$template_prescribe->medicine_name = $mix_name;
								$template_prescribe->factor = $factorItem_array[$key];
								$template_prescribe->vial = $medicineVial_array[$key];
								//$get_value_list = gettype($instructionItem_array[$key]);
								$template_prescribe->instruction_name = $instruction_array[$key];
								/* if(is_numeric($instructionItem_array[$key])){
									$template_prescribe->instruction_id = $instructionItem_array[$key];
									$instruction_id = $instructionItem_array[$key];
									// get instruction name
									$ins_name = $this->getInstructions($instruction_id);
									$template_prescribe->instruction_name = $ins_name->instruction_name;
								}else{
									// get Other value
									$template_prescribe->instruction_other_value =$instructionItem_array[$key];
								} */
								$template_prescribe->midicine_type  = $medicine_type_array[$key];
								//$template_prescribe->medicine_id  = $medicine_id_array[$key][$key2];
								//$template_prescribe->potency_id  = $potency_id_array[$key][$key2];
								$template_prescribe->save();
								$last_mix_temp_id =  $template_prescribe->id;

								foreach($medicineItem_array[$key][$key2] as $tkey=>$temp_mix_medicine_value){
									$template_variant_prescribe = new Prescribemedicine();
									$template_variant_prescribe->patient_id = $formdata['patient_id'];
									$template_variant_prescribe->appointment_id =  $formdata['appointment_id'];
									$template_variant_prescribe->created_by =  $request->user_id;
									$template_variant_prescribe->billing_id = $last_billing_id;
									$template_variant_prescribe->parent_id = $last_mix_temp_id;
									$template_variant_prescribe->medicine_name =$medicineItem_array[$key][$key2][$tkey];
									$template_variant_prescribe->potency_name = $potencyItem_array[$key][$key2][$tkey];
									$template_variant_prescribe->dilution_name = $dilutionItem_array[$key][$key2][$tkey];
									$list_array = explode('-', $formItem_array[$key][$key2][$tkey]);
									$group_id = $list_array[0];
									$form_code = $list_array[1];
									$form_name = $list_array[2];
									$template_variant_prescribe->group_id = $group_id;
									$template_variant_prescribe->form_code = $form_code;
									$template_variant_prescribe->form_name =$form_name;
									// Get each medicine price from pricing class trait
									$form_rate = $this->getPrice($group_id,$form_code,$form_name);
									$template_variant_prescribe->form_rate =$form_rate->rate;
									// Calcuate each medicine price
									$factor = $factorItem_array[$key];
									$each_form_rate =$form_rate->rate;
									$each_medicine_amount = $factor * $each_form_rate;
									$template_variant_prescribe->medicine_amount = number_format((float)$each_medicine_amount, 2, '.', '');

									$template_variant_prescribe->midicine_type  = $medicine_type_array[$key];
									//$template_variant_prescribe->medicine_id  = $medicine_id_array[$key][$key2][$tkey];
									//$template_variant_prescribe->potency_id  = $potency_id_array[$key][$key2][$tkey];
									$template_variant_prescribe->save();
								}
						}
					}elseif($medicine_type_array[$key]=='ontheflymix'){
						$ontheflymix_prescribe = new Prescribemedicine();
						foreach($srnoItem_array[$key] as $key3=>$value4){
								$ontheflymix_prescribe->patient_id = $formdata['patient_id'];
								$ontheflymix_prescribe->appointment_id =  $formdata['appointment_id'];
								$ontheflymix_prescribe->created_by =  $request->user_id;
								$ontheflymix_prescribe->billing_id = $last_billing_id;
								$mix_name = $key3;
								$ontheflymix_prescribe->medicine_serial_no = $srnoItem_array[$key][$key3];
								$ontheflymix_prescribe->medicine_name = $mix_name;
								$ontheflymix_prescribe->factor = $factorItem_array[$key];
								$ontheflymix_prescribe->vial = $medicineVial_array[$key];
								//$get_value_list = gettype($instructionItem_array[$key]);
								$ontheflymix_prescribe->instruction_name = $instruction_array[$key];
								/* if(is_numeric($instructionItem_array[$key])){
									$ontheflymix_prescribe->instruction_id = $instructionItem_array[$key];
									$instruction_id = $instructionItem_array[$key];
									// get instruction name
									$ins_name = $this->getInstructions($instruction_id);
									$ontheflymix_prescribe->instruction_name = $ins_name->instruction_name;
								}else{
									// get Other value
									$ontheflymix_prescribe->instruction_other_value =$instructionItem_array[$key];
								} */
								$ontheflymix_prescribe->midicine_type  = 'ontheflymix';
								//$ontheflymix_prescribe->medicine_id  = $medicine_id_array[$key][$key2];
							//	$ontheflymix_prescribe->save();
								//$last_mix_temp_id =  $ontheflymix_prescribe->id;
								//This code is copied from the below loop beacause now we are using form as single medicine, 06 sept 2019 Rahul Khan
								//return $formItem_array[$key];
								$list_array = explode('-', $formItem_array[$key]);//This line is change for new version as single medicine
								$group_id = $list_array[0];
								$form_code = $list_array[1];
								$form_name = $list_array[2];
								$ontheflymix_prescribe->group_id = $group_id;
								$ontheflymix_prescribe->form_code = $form_code;
								$ontheflymix_prescribe->form_name =$form_name;
								/*end code here */
						//This code  is used for geting the Rate of prescribe mix
								$form_rate = $this->getPrice($group_id,$form_code,$form_name);
							//	returnform_rate;
								$ontheflymix_prescribe->form_rate =$form_rate;

								$ontheflymix_prescribe->save();
								$last_mix_temp_id =  $ontheflymix_prescribe->id;

								foreach($medicineItem_array[$key][$key3] as $otfkey=>$temp_mix_medicine_value){
									$ontheflymix_variant_prescribe = new Prescribemedicine();
									$ontheflymix_variant_prescribe->patient_id = $formdata['patient_id'];
									$ontheflymix_variant_prescribe->appointment_id =  $formdata['appointment_id'];
									$ontheflymix_variant_prescribe->created_by =  $request->user_id;
									$ontheflymix_variant_prescribe->billing_id = $last_billing_id;
									$ontheflymix_variant_prescribe->parent_id = $last_mix_temp_id;
									$ontheflymix_variant_prescribe->medicine_name =$medicineItem_array[$key][$key3][$otfkey];
									$ontheflymix_variant_prescribe->potency_name = $potencyItem_array[$key][$key3][$otfkey];
									$ontheflymix_variant_prescribe->dilution_name = $dilutionItem_array[$key][$key3][$otfkey];
									//return $formItem_array;
									//$ontheflymix_variant_prescribe->form_name = $formItem_array[$key][$key3][$otfkey];
								/*This code is commented for set on the fly Mix as single medicine
									$list_array = explode('-', $formItem_array[$key][$key3][$otfkey]);
									$group_id = $list_array[0];
									$form_code = $list_array[1];
									$form_name = $list_array[2];
									$ontheflymix_variant_prescribe->group_id = $group_id;
									$ontheflymix_variant_prescribe->form_code = $form_code;
									$ontheflymix_variant_prescribe->form_name =$form_name; */
									// Get each medicine price from pricing class trait
									$form_rate = $this->getPrice($group_id,$form_code,$form_name);
									$ontheflymix_variant_prescribe->form_rate =$form_rate->rate;
									// Calcuate each medicine price
									$factor = $factorItem_array[$key];
									$each_form_rate =$form_rate->rate;
									$each_medicine_amount = $factor * $each_form_rate;
									$ontheflymix_variant_prescribe->medicine_amount = number_format((float)$each_medicine_amount, 2, '.', '');

									$ontheflymix_variant_prescribe->midicine_type  = 'ontheflymix';
									$ontheflymix_variant_prescribe->medicine_id  = $medicine_id_array[$key][$key3][$otfkey];
									$ontheflymix_variant_prescribe->potency_id  = $potency_id_array[$key][$key3][$otfkey];
									$ontheflymix_variant_prescribe->save();
								}

						}
					}
					
					$visit->patient_id =$formdata['patient_id'];
					$visit->appointment_id =$formdata['appointment_id'];
					$visit->billing_id =$last_billing_id;
					$visit->created_by =  $request->user_id;
					$visit->visit_status =1;
					$visit->save();
				}
				$res['error'] = false;
				$res['patient_id'] = $formdata['patient_id'];
				$res['appointment_id'] = $formdata['appointment_id'];
				$res['importvisitid'] = $formdata['importvisitid'];
				$res['billing_id'] = $last_billing_id;
				$res['actions'] = 'add';
				return response($res, 200);
		}else{
			$res['error'] = true;
			$res['actions'] ='datainsufficient';
			return response($res, 200);
		}
	}
	//This is used for getting the total amount of payment gateback at billing and details page, Rahul Khan, 31 July 2019
	public function getPrescribeMedicineDetails($appointment_id='', $billing_id='', Request $request){
		try{
			$main_array = array();
			$medicine_array = array();
			//$mix_price = array();
			$medicine_total = array();
            if(!empty($appointment_id) && !empty($billing_id)){
				$total=0;
				$precribe_medicine_list = DB::table('billing as b')->LeftJoin('prescribemedicine as pm', 'pm.billing_id', '=', 'b.id')->where('b.status', '=', '1')->where('pm.parent_id', '=', '0')->where('pm.appointment_id', $appointment_id)->where('pm.billing_id', $billing_id)->get();
							foreach($precribe_medicine_list as $key => $list){
							$mix_medicine_list = Prescribemedicine::where('parent_id',$list->id)->get();
							$mix_medicine_test = Prescribemedicine::where('parent_id',$list->id)->get()->max('medicine_amount');
							if($mix_medicine_test > 0){
								$total+=$mix_medicine_test;
							}else{
								$total+=$list->medicine_amount;
							}
						//$total+=$list->medicine_amount;
						//$mix_price = Prescribemedicine::where('parent_id', $list->id)->where('factor', '!=', '0')->where('status', '=', '1')->max('medicine_amount');
						//return $mix_medicine_list;
					//	$mix_price = array();
						//foreach ($mix_medicine_list as $key1 => $value){
						//		array_push($mix_price, $value->medicine_amount);
						//}
						///if(count($mix_price) > 0){
						//	$total+= max($mix_price);
						//}
						$main_array['data']= $precribe_medicine_list[$key];
//This below function is used for getting the mix form
						$main_array['mix']= $mix_medicine_list;
						$main_array['bill_id']= $precribe_medicine_list[0]->billing_id;
						$main_array['visit_id']= $precribe_medicine_list[0]->appointment_id;
						$main_array['pharmacy_instruction']= $precribe_medicine_list[0]->pharmacy_instruction;
						$main_array['reason']= $precribe_medicine_list[0]->edit_reason;
						array_push($medicine_array,  $main_array);
					//	$main_array['rahul']= $mix_price;
				}
				
				$total_c = $total;
				// $medicine_total['bill_id'] = $precribe_medicine_list[0]->billing_id;
				// $medicine_total['visit_id'] = $precribe_medicine_list[0]->appointment_id;
				$medicine_total['total_amount'] = number_format((float)$total_c, 2, '.', '');
				//$medicine_total['total_amount'] = number_format((float)$total_c, 2, '.', '');
				array_push($medicine_total,$medicine_array);
				return response()->json($medicine_total);
			}
    	}catch(\Illuminate\Database\QueryException $ex){

                    $res['status'] = false;
                    $res['message'] = $ex->getMessage();
                    return response($res, 500);

        }

	}
// Apply on the fly discount on the total medicine cost
	public function discountonthefly(Request $request){
		$p_discounts = new discount();
		if(!empty($request->medicine_total) && !empty($request->discount)){
			if(is_numeric($request->discount) && $request->discount>100){
				$res['error'] = true;
				$res['message'] ='notgreater';
				return response($res, 200);
			}else if(!is_numeric($request->medicine_total)){
				$res['error'] = true;
				$res['message'] ='datainsufficient';
				return response($res, 200);
			}else{
				$main = $request->medicine_total;
				$bill_id = $request->bill_id;
				$visit_id = $request->visit_id;
				$reason = $request->reason;
				$user_id = $request->user_id;
				$disc = $request->discount;
				$dec = ($disc/100);
				$discount_val = number_format((float)$dec, 2, '.', '');
				$mult = $main * $discount_val; // gives the value for subtract from main value
				$discont = $main-$mult;
				$p_discounts->billing_id =$bill_id;
				$p_discounts->appointment_id =$visit_id;
				$p_discounts->discount_reason =$reason;
				$p_discounts->created_by =$user_id;
				$p_discounts->discount_before_med_cost =$main;
				$p_discounts->discount_after_med_cost =number_format((float)$discont, 2, '.', '');
				$p_discounts->discount_on_med =$disc;
				$p_discounts->save();
				$last_dicount_id =  $p_discounts->id;
				// $item = $billing->findOrFail($request->bill_id);
				// if($item){
				// 	$billing->where('id', $request->bill_id)->where('appointment_id', $request->visit_id)->update(['discount_before_med_cost'=>$billing->discount_before_med_cost, 'discount_after_med_cost'=>$billing->discount_after_med_cost,'discount_on_med'=>$billing->discount_on_med]);
				// }
				$res['error'] = false;
				$res['discount_value'] = number_format((float)$discont, 2, '.', '');
				$res['discount_percentage'] = $disc;
				$res['discount'] = $last_dicount_id;
				$res['message'] = 'applydiscount';
				return response($res, 200);

			}
		}else{
			$res['error'] = true;
			$res['message'] ='datainsufficient';
			return response($res, 200);
		}
	}
// get Previous pending visit
  public function getPatientPreviousPendingAmount($patient_id='', Request $request){
	try{
			$pending_array =[];
			$dt =  Carbon::now('Asia/Kolkata');
			if(isset($patient_id)){
				$pendind_list =  DB::table('payment')->select('debit_amount','credit_amount','remark','transaction_time','due_amount','transaction_status')->where('patient_id', $patient_id)->where('status', '1')->orderBy('id', 'DESC')->first();
				if(!empty($pendind_list)){
					$balance = ($pendind_list->debit_amount-$pendind_list->credit_amount);
					$pending_array['comment'] =$pendind_list->remark;
					$pending_array['time'] =$pendind_list->transaction_time;
					$pending_array['due_amount'] =number_format((float)$balance, 2, '.', '');
					$pending_array['transaction_status'] =$pendind_list->transaction_status;
					$res['error'] = false;
					$res['data'] =$pending_array;
					return response($res, 200);
				}else{
					$res['error'] = false;
					$res['data'] =null;
					return response($res, 200);
				}
			}else{
				$res['error'] = false;
				$res['data'] =null;
				return response($res, 200);
			}
	}catch(\Illuminate\Database\QueryException $ex){
			$res['status'] = false;
			$res['message'] = $ex->getMessage();
			return response($res, 500);
		}
  }
  // Consultancy Waive Function
  public function consultancyWaive(Request $request){
		$billing = new Billing();
		if(!empty($request->consultancy) && !empty($request->bill_id) && !empty($request->visit_id)){
				$consultancy = $request->consultancy;
				$bill_id = $request->bill_id;
				$visit_id = $request->visit_id;
				$consultancy_waived_reason = $request->reason;
				$consultancy_waived_by = $request->user_id;
				//$billing->wave_consultancy_fees =$main;
				$item = $billing->findOrFail($request->bill_id);
				if($item){
					$billing->where('id', $request->bill_id)->where('appointment_id', $request->visit_id)->update(['waive_consultancy_fees'=>$consultancy,'waive_type'=>'Waived','waive_percentage'=>0.00, 'consultancy_waived_reason'=>$consultancy_waived_reason, 'consultancy_waived_by'=>$consultancy_waived_by]);
				}
				$res['error'] = false;
				$res['message'] = 'consultancywaved';
				return response($res, 200);
		}else{
			$res['error'] = true;
			$res['message'] ='datainsufficient';
			return response($res, 200);
		}
	}
	 // Patient Pending Detail Function
	 public function pendingDetails(Request $request){
		if(!empty($request->patient_id)){
				$patient_id = $request->patient_id;
				$item = Payment::where('patient_id', $patient_id)->where('status', '1')->orderBy('creation_date','desc')->get();
				$res['error'] = false;
				$res['data'] = $item;
				return response($res, 200);
		}else{
			$res['error'] = true;
			$res['message'] ='datainsufficient';
			return response($res, 200);
		}
	}
 // Patient Payment Function
 //This function is used for submitting the payment data, Rahul Khan, 31 july 2019
 public function patientPayment(Request $request){
	 
	$payment = new Payment();
	$billing = new Billing();
	$visit = new Visit();
	$discount = new discount();
	//return property_exists($request, 'consultancy_status');
	//This code is used for set consultacy status, 21 Aug 2019, Rahul Khan
	if(!(isset($request->consultancy_status))) {
	//if((!(property_exists($request, 'consultancy_status')) ) || ($request->consultancy_status =='') ){
		$request->consultancy_status ="Repeat Medicine";
	}
	//return $request->consultancy_status;
	$dt =  Carbon::now('Asia/Kolkata');
	$currentDate = $dt->toDateString();
	
	
	if(!empty($request->visit_due) && !empty($request->previous_due) && !empty($request->total_due)  && !empty($request->recieved_amount) && !empty($request->billing_id) && !empty($request->visiting_id) && !empty($request->patient_id) && !empty($request->charge_data) && count($request->charge_data)>0){
		// insert charge name and price in billing_patient_charge 3 July Shubh Tiwari
		   PatientBillingCharge::where('billing_id', $request->billing_id)->delete();
		   discount::where('billing_id', $request->billing_id)->delete();
			foreach ($request->charge_data as $key => $value){
				$PatientBillingCharge = new PatientBillingCharge();
				$PatientBillingCharge->billing_id = $request->billing_id;
				$PatientBillingCharge->appointment_id = $request->visiting_id;
				$PatientBillingCharge->patient_id = $request->patient_id;
				$PatientBillingCharge->created_by =  $request->user_id;
				$PatientBillingCharge->charge_amount = $request->charge_data[$key]['price'];
				$PatientBillingCharge->charge_name = $request->charge_data[$key]['name'];
				$PatientBillingCharge->charge_code = $request->charge_data[$key]['charge_code'];
				$PatientBillingCharge->save();
			}
			// update factor with prescribemedicine table id 19 July Shubh Tiwari
			foreach ($request->factor_data as $key => $value){
				$PrescribeMedicineFactor = new Prescribemedicine();
				$each_form_rate = $request->factor_data[$key]['formrate'];
				$each_vial = $request->vial_data[$key]['medicine_vial'];
				$factor = $request->factor_data[$key]['factor'];
				$each_medicine_amount = $factor * $each_form_rate;
 				$med_amount = number_format((float)$each_medicine_amount, 2, '.', '');
				$item = $PrescribeMedicineFactor->findOrFail($request->factor_data[$key]['medid']);
				
				if($item){
					$PrescribeMedicineFactor->where('id', $request->factor_data[$key]['medid'])->update(['factor'=>$request->factor_data[$key]['factor'],'vial'=>$each_vial, 'medicine_amount'=>$med_amount,'modification_date'=>$currentDate]);
				}
				//Update single medicine amount of mix medicine as on 28 Feb 2020 by shubh Tiwari
				$mix_medicine_test = Prescribemedicine::where('parent_id', $request->factor_data[$key]['medid'])->get();
				
				if(count($mix_medicine_test) >0){
					foreach($mix_medicine_test as $key=>$mix_value){
						Prescribemedicine::where('id', $mix_value->id)->update(['medicine_amount'=>$each_medicine_amount]);
					}
					
				}
			}
			/* consultancy data update*/
			//'waive_consultancy_fees'=>$request->consultancy, //This line is removed from the below update query, Because it create causes wiaved statement, Rahul khan, 24 oct 2019
				$billing_record = $billing->findOrFail($request->billing_id);
				if($billing_record){
					$billing->where('id', $request->billing_id)->update(['consultancy_waived_by'=>$request->user_id, 'consultancy_waived_reason'=>$request->consultancy_reason, 'waive_consultancy_fees'=>$request->consultancy, 'waive_type'=>$request->consultancy_status,'waive_percentage'=>$request->consultancy_percentage, 'consultancy_fees'=>$request->consutancy_fee]);
				}

			// Patient Credit/Debit Amount Calculation Shubh Tiwari
			$total_due = $request->total_due;
			$recieved_amount = $request->recieved_amount;
			$payment->total_due_amount = $request->total_due;
			$payment->recieved_amount = $request->recieved_amount;
			if($request->recieved_amount==$request->total_due){
				$due_amount = ($total_due-$recieved_amount);
				$payment->credit_amount = $due_amount;
				$payment->transaction_status = 'Credit';
			}else if($request->recieved_amount>$request->total_due){
				$due_amount = ($recieved_amount-$total_due);
				$payment->credit_amount = $due_amount;
				$payment->transaction_status = 'Credit';
			}else if($request->recieved_amount<$request->total_due){
				$due_amount = ($total_due-$recieved_amount);
				$payment->debit_amount = $due_amount;
				$payment->transaction_status = 'Debit';
			}
			$payment->visit_due_amount = $request->visit_due;
			$payment->previous_due_amount = $request->previous_due;
			$payment->remark = $request->note;
			$payment->billing_id = $request->billing_id;
			$payment->appointment_id = $request->visiting_id;
			$payment->patient_id = $request->patient_id;
			$payment->created_by =  $request->user_id;
			$payment->previous_bill_paid_amount =  $request->previous_bill_paid_amount;
			$payment->refund_flag = $request->refund;
			$payment->transaction_time = $dt;
			$payment->save();
			$last_payment_id =  $payment->id;
			// Insert visit payment mode data in visit_payment_modes Dec 30 Shubh Tiwari
			if(!empty($last_payment_id) ){
				foreach ($request->payment_mode_data as $key => $value){
							$visitPaymentModes = new visitPaymentModes();
							$visitPaymentModes->payment_id = $last_payment_id;
							$visitPaymentModes->mode_price = $request->payment_mode_data[$key]['mode_price'];
							$visitPaymentModes->mode_id = $request->payment_mode_data[$key]['payment_mode_id'];
							$visitPaymentModes->created_by =  $request->user_id;
							$visitPaymentModes->save();
							$last_visit_mode_id =  $visitPaymentModes->id;
							$visitPaymentModes->where('id', $last_visit_mode_id)->update(['reference_no'=>$request->reference_no_data[$key]['reference_no']]);
					}
			 }
			 
			// insert visit status record in visit_status Shubh Tiwari
			// Changes in Query by shubh tiwari as on 2 nov 2020
			$second_time_payment = Visit::where('billing_id', '=', $request->billing_id)->where('visit_status', '=', '2')->first();
			if ($second_time_payment === null){
				$visit->patient_id =$request->patient_id;
				$visit->appointment_id =$request->visiting_id;
				$visit->billing_id =$request->billing_id;
				$visit->created_by =  $request->user_id;
				$visit->visit_status =2;
				$visit->save();
			}
			// clear medicine list data
			if($request->prescribing_doc_id==null){
				$affected = DB::table('appointments')->where('id', $request->visiting_id)->update(['medicine_complete' => 1]);
			}
			// insert patient dicount record in patient_dicount july 19 Shubh Tiwari
			$discount->appointment_id =$request->visiting_id;
			$discount->billing_id =$request->billing_id;
			$discount->discount_before_med_cost =$request->factor_med_total;
			$discount->discount_after_med_cost =$request->med_after_discount;
			$discount->discount_on_med =$request->factor_perce_value;
			$discount->discount_reason =$request->medicine_descount_reason;
			$discount->created_by =  $request->user_id;
			$discount->save();

			$res['error'] = false;
			$res['actions'] = 'add';
			return response($res, 200);

		}else if(!empty($request->visit_due) && !empty($request->previous_due) && !empty($request->total_due)  && !empty($request->recieved_amount) && !empty($request->billing_id) && !empty($request->visiting_id) && !empty($request->patient_id)){
			 discount::where('billing_id', $request->billing_id)->delete();
			// insert payment record in payment 
			// Patient Credit/Debit Amount Calculation Shubh Tiwari consultancy: 20

			$total_due = $request->total_due;
			$recieved_amount = $request->recieved_amount;
			$payment->total_due_amount = $request->total_due;
			$payment->recieved_amount = $request->recieved_amount;
			if($request->recieved_amount==$request->total_due){
				$due_amount = ($total_due-$recieved_amount);
				$payment->credit_amount = $due_amount;
				$payment->transaction_status = 'Credit';
			}else if($request->recieved_amount>$request->total_due){
				$due_amount = ($recieved_amount-$total_due);
				$payment->credit_amount = $due_amount;
				$payment->transaction_status = 'Credit';
			}else if($request->recieved_amount<$request->total_due){
				$due_amount = ($total_due-$recieved_amount);
				$payment->debit_amount = $due_amount;
				$payment->transaction_status = 'Debit';
			}
			$payment->visit_due_amount = $request->visit_due;
			$payment->previous_due_amount = $request->previous_due;
			$payment->remark = $request->note;
			$payment->billing_id = $request->billing_id;
			$payment->appointment_id = $request->visiting_id;
			$payment->patient_id = $request->patient_id;
			$payment->created_by =  $request->user_id;
			$payment->previous_bill_paid_amount =  $request->previous_bill_paid_amount;
			$payment->refund_flag = $request->refund;
			$payment->transaction_time = $dt;
			$payment->save();
			$last_payment_id =  $payment->id;
			// Insert visit payment mode data in visit_payment_modes Dec 30 Shubh Tiwari
			if(!empty($last_payment_id) ){
			foreach ($request->payment_mode_data as $key => $value){
						$visitPaymentModes = new visitPaymentModes();
						$visitPaymentModes->payment_id = $last_payment_id;
						$visitPaymentModes->mode_price = $request->payment_mode_data[$key]['mode_price'];
						$visitPaymentModes->mode_id = $request->payment_mode_data[$key]['payment_mode_id'];
						$visitPaymentModes->created_by =  $request->user_id;
						$visitPaymentModes->save();
						$last_visit_mode_id =  $visitPaymentModes->id;
						$visitPaymentModes->where('id', $last_visit_mode_id)->update(['reference_no'=>$request->reference_no_data[$key]['reference_no']]);
				}
			}
		// insert visit status record in visit_status Shubh Tiwari
		// Changes in Query by shubh tiwari as on 2 nov 2020
			$second_time_payment = Visit::where('billing_id', '=', $request->billing_id)->where('visit_status', '=', '2')->first();
			if($second_time_payment === null) {
				$visit->patient_id =$request->patient_id;
				$visit->appointment_id =$request->visiting_id;
				$visit->billing_id =$request->billing_id;
				$visit->created_by = $request->user_id;
			    $visit->visit_status =2;
			    $visit->save();
			 }
			 
			// insert patient dicount record in patient_dicount july 19 Shubh Tiwari
			$discount->appointment_id =$request->visiting_id;
			$discount->billing_id =$request->billing_id;
			$discount->created_by = $request->user_id;
			$discount->discount_before_med_cost =$request->factor_med_total;
			$discount->discount_after_med_cost =$request->med_after_discount;
			$discount->discount_reason =$request->medicine_descount_reason;
			$discount->discount_on_med =$request->factor_perce_value;
			$discount->save();
			// update factor with prescribemedicine table id 19 July Shubh Tiwari
			foreach ($request->factor_data as $key => $value){
				$PrescribeMedicineFactor = new Prescribemedicine();
				$each_form_rate = $request->factor_data[$key]['formrate'];
				$factor = $request->factor_data[$key]['factor'];
				$each_vial = $request->vial_data[$key]['medicine_vial'];
				$each_medicine_amount = $factor * $each_form_rate;
 				$med_amount = number_format((float)$each_medicine_amount, 2, '.', '');
				$item = $PrescribeMedicineFactor->findOrFail($request->factor_data[$key]['medid']);
				if($item){
					$PrescribeMedicineFactor->where('id', $request->factor_data[$key]['medid'])->update(['factor'=>$request->factor_data[$key]['factor'], 'vial'=>$each_vial, 'medicine_amount'=>$med_amount,'modification_date'=>$currentDate]);
				}
				
				//Update single medicine amount of mix medicine as on 28 Feb 2020 by shubh Tiwari
				$mix_medicine_test = Prescribemedicine::where('parent_id', $request->factor_data[$key]['medid'])->get();
				if(count($mix_medicine_test) >0){
					
					foreach($mix_medicine_test as $key=>$mix_value){
						Prescribemedicine::where('id', $mix_value->id)->update(['medicine_amount'=>$each_medicine_amount]);
					}
					
				}
			}
			
			// clear medicine list data
			if($request->prescribing_doc_id==null){
				$affected = DB::table('appointments')->where('id', $request->visiting_id)->update(['medicine_complete' => 1]);
			}
			
			/* consultancy data update*/
			//'waive_consultancy_fees'=>$request->consultancy, //This line is removed from the below update query, Because it create causes wiaved statement, Rahul khan, 24 oct 2019
			$billing_record = $billing->findOrFail($request->billing_id);
			if($billing_record){
				$billing->where('id', $request->billing_id)->update(['consultancy_waived_by'=>$request->user_id, 'consultancy_waived_reason'=>$request->consultancy_reason, 'waive_type'=>$request->consultancy_status, 'waive_consultancy_fees'=>$request->consultancy,'waive_percentage'=>$request->consultancy_percentage,'consultancy_fees'=>$request->consutancy_fee]);
			}
			$res['error'] = false;
			$res['actions'] = 'add';
			return response($res, 200);
		}else{
			$res['error'] = true;
			$res['message'] ='datainsufficient';
			return response($res, 200);
		}
	}

/* This function chnage by shubh tiwari as on 26 Feb 2020 for showing visit data order by latest date*/	
 public function patientHistory($patient_id='', Request $request){
		$dt =  Carbon::now('Asia/Kolkata');
		$main_array=[];
		$sub_array=[];
		$total_array=[];
		$medicine_array=[];
		if(isset($patient_id)){
			$offset = $request->has('page') ? $request->get('page') : 1;
            $limit = $request->has('limit') ? $request->get('limit') : 5;
		    $prescribe_visit_list = DB::table('billing as b')->select('vs.billing_id', 'vs.appointment_id','b.doctor_id','vs.creation_date')
			                                  ->LeftJoin("visit_status as vs", function($join){
									                  $join->on("vs.appointment_id", "=", "b.appointment_id");
													  $join->on("vs.billing_id", "=", "b.id");
									          })->where('vs.patient_id' , $patient_id)
											  ->where('vs.visit_status' , '2')
											  ->orderBy('vs.appointment_id','DESC')
											  ->groupBy('vs.appointment_id')
											  ->distinct()
											  ->take($limit)
											  ->get();
			    $list = DB::table('billing as b')->select('vs.billing_id', 'vs.appointment_id','b.doctor_id','vs.creation_date')
			                                  ->LeftJoin("visit_status as vs", function($join){
									                  $join->on("vs.appointment_id", "=", "b.appointment_id");
													  $join->on("vs.billing_id", "=", "b.id");
									          })->where('vs.patient_id' , $patient_id)
											  ->where('vs.visit_status' , '2')
											  ->orderBy('vs.appointment_id','DESC')
											  ->groupBy('vs.appointment_id')
											  ->distinct()
											  ->get();
				foreach($prescribe_visit_list as $key => $value){
									$prescribe_medicine_list = DB::table('prescribemedicine as pm')
									->where('pm.billing_id', $value->billing_id)
									->where('pm.appointment_id', $value->appointment_id)
									->where('pm.status', '1')
									->where('pm.parent_id', '0')
									->orderBy('pm.id','ASC')
									->groupBy('pm.medicine_name','pm.potency_name','pm.form_name','pm.appointment_id')
									->distinct()
									->get();
								 foreach ($prescribe_medicine_list as $key1 => $value2){
										$medicine_array[$key1] =$value2;
										$total_array[$value->creation_date][$key1] =$prescribe_medicine_list[$key1];
										$total_array[$value->creation_date]['date'] =$value->creation_date;
										$total_array[$value->creation_date]['billing'] =$value->billing_id;
										$total_array[$value->creation_date]['appointment'] =$value->appointment_id;
										$total_array[$value->creation_date]['doctor_name'] =users::select('label')->where('user_id', $value->doctor_id)->first();
								} 
							
						} 
					     $res['error'] = false;
						 $main_array['total'] = $list->count();
						 $main_array['count'] = $prescribe_visit_list->count();
						 $main_array['patient_id'] = $patient_id;
						   array_push($main_array,$total_array); 
						return response($main_array, 200);
			}else{
				$res['error'] = true;
				$res['message'] ='datainsufficient';
				return response($res, 200);
			}
   }
/* 	public function patientHistory($patient_id='', Request $request){
		$dt =  Carbon::now('Asia/Kolkata');
		$main_array=[];
		$total_array=[];
		$medicine_array=[];
		if(isset($patient_id)){
			$offset = $request->has('page') ? $request->get('page') : 1;
            $limit = $request->has('limit') ? $request->get('limit') : 5;
			$prescribe_medicine_list = DB::table('prescribemedicine as pm')
								->LeftJoin('billing as b', 'b.id', '=', 'pm.billing_id')
								->LeftJoin('visit_status as vs', 'vs.billing_id', '=', 'pm.billing_id')
								->where('pm.status', '1')
								->where('b.status', '1')
								->where('vs.visit_status', '2')
								->where('pm.patient_id', $patient_id)
								->where('pm.parent_id', '0')
								->orderBy('pm.medicine_serial_no','ASC')
								->orderBy('vs.id', 'asc')
								->groupBy('pm.medicine_name','pm.potency_name','pm.form_name','pm.appointment_id')
								->distinct()
								//->offset($offset)
								//->take($limit)
								->get();
								//->limit($limit)
								//->offset(($page -1) * $limit)
								//->get();
			$list = DB::table('prescribemedicine as pm')
								->LeftJoin('billing as b', 'b.id', '=', 'pm.billing_id')
								->LeftJoin('visit_status as vs', 'vs.billing_id', '=', 'pm.billing_id')
								->where('pm.status', '1')
								->where('b.status', '1')
								->where('vs.visit_status', '2')
								->where('pm.patient_id', $patient_id)
								->where('pm.parent_id', '0')
								//->orderBy('pm.medicine_serial_no','ASC')
								->orderBy('pm.appointment_id','DESC')
								->groupBy('pm.appointment_id')
								->distinct()
								->get();
			foreach ($prescribe_medicine_list as $key => $value){
				$medicine_array[$key] =$value;
				$total_array[$value->appointment_id][$key] =$prescribe_medicine_list[$key];
				$total_array[$value->appointment_id]['date'] =$value->creation_date;
				$total_array[$value->appointment_id]['billing'] =$value->billing_id;
				$total_array[$value->appointment_id]['appointment'] =$value->appointment_id;
				$total_array[$value->appointment_id]['doctor_name'] =users::select('label')->where('user_id', $value->doctor_id)->first();
			}
			$res['error'] = false;
			    $wordCount = $prescribe_medicine_list->count();
				//$main_array['limit'] = $limit;
				$main_array['total'] = $list->count();
				$main_array['count'] = $wordCount;
				//$main_array['page'] = $offset;
				$main_array['patient_id'] = $patient_id;
				array_push($main_array,$total_array);
			return response($main_array, 200);
		}else{
			$res['error'] = true;
			$res['message'] ='datainsufficient';
			return response($res, 200);
		}
	} */
	
/* This function chnage by shubh tiwari as on 03 March 2020 for showing visit data order by latest date*/
public function importPatientHistory(Request $request){
		$single_array = [];
		if((!empty($request->appointment_id) && count($request->appointment_id)>0) && (!empty($request->med_id) && count($request->med_id)>0)){
		 /* This below query $prescribe_medicine_list variable get the total medicine by billing id, appointment_id, and prescribemedicine table id */
			$prescribe_medicine_list = DB::table('prescribemedicine as pm')
			->where('pm.status', '1')
			->whereIn('pm.appointment_id', $request->appointment_id)
			->whereIn('pm.billing_id', $request->billing_id)
			->whereIn('pm.id', $request->med_id)
			->distinct()
			->get();
			foreach ($prescribe_medicine_list as $key => $value){
				$mix_array = [];
				 /* This below query $single_medicine_list variable get single medicine all form using potency id and medicine id*/
				$single_medicine_list = DB::table('medicinegrouppotencies as mgp')->select('pg.form_name as form_name','mgpf.group_id as group_id','pg.form_code as form_code')
				->LeftJoin('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
				->LeftJoin("pricegrouprates as pg",function($join){
					$join->on("pg.pricegroup_id","=","mgpf.group_id")
						->on("pg.form_code","=","mgpf.form_code");
					})
				->where('pg.status', '1')
				->where('mgp.potency_id', $value->potency_id)
				->where('mgp.medicine_id', $value->medicine_id)
				->groupBy('mgpf.form_code')
				->distinct()
				->get();
				
				 /* Assign iteration value to $max_array array  */
				$mix_array = $value;
				
				/* This variable $mix_medicine_list geting the child medicine of mix medicine*/
				$mix_medicine_list = Prescribemedicine::where('parent_id', $value->id)->get();
				
				/* This variable $mix_medicine_form geting mix medicine form*/
/* 				$mix_medicine_form = DB::table('mixmedicineform as mf')->select('pg.form_name as form_name','pg.form_code as form_code')->LeftJoin("pricegrouprates as pg",function($join){
											$join->on("pg.form_code","=","mf.form_code");
											})->where('mf.mixid', $value->medicine_id)
											->where('pg.status', '1')
											->groupBy('mf.form_code')
										    ->distinct()
											->get(); */
											
											
				$mix_medicine_form = DB::table('medicinemixvariant as mmv')->select('mg.group_id','pg.form_name as form_name','pg.form_code as form_code')
											->LeftJoin('medicinegrouppotencies as mgp', 'mgp.potency_id', '=', 'mmv.mixPotencyId')
											->LeftJoin('mixmedicineform as mf', 'mf.mixid', '=', 'mmv.medicinemixId')
											->LeftJoin("pricegrouprates as pg",function($join){
											$join->on("pg.form_code","=","mf.form_code");
											})
											//->LeftJoin('medicinegrouppotencies as mgp', 'mgp.medicine_id', '=', 'mmv.mixMedicineId')
											->LeftJoin("medicinegroups as mg",function($join){
											$join->on("mg.id","=","mgp.medicinegroup_id");
											})->where('mmv.medicinemixId', $value->medicine_id)
											->where('mmv.status', '1')
											->where('mgp.status', '1')
											->where('mg.status', '1')
											->where('pg.status', '1')
											->where('mf.status', '1')
										    ->distinct()
											->get();
											
											
				if($value->midicine_type=='single'){
			            $mix_array->form = $single_medicine_list;
						$mix_array->mix = [];
				}else if($value->midicine_type=='mix'){
					
						$mix_array->form = $mix_medicine_form;
						//$mix_array->group = $mix_medicine_groupId;
						
						
				}
				if(count($mix_medicine_list) >0){
					$mix_array->mix = $mix_medicine_list;
					if($value->midicine_type=='ontheflymix'){
                /* This foreach loop geting the ontheflymix mix medicine form*/						
							foreach ($mix_medicine_list as $key => $value1){
										$mix_medicine_form_list = DB::table('medicinegrouppotencies as mgp')->select('pg.form_name as form_name','mgpf.group_id as group_id','pg.form_code as form_code')
										->LeftJoin('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
										->LeftJoin("pricegrouprates as pg",function($join){
											$join->on("pg.pricegroup_id","=","mgpf.group_id")
												->on("pg.form_code","=","mgpf.form_code");
											})
										->where('pg.status', '1')
										->where('mgp.potency_id', $value1->potency_id)
										->groupBy('mgpf.form_id')
										->distinct()
										->get();
								
							   $mix_array->form = $mix_medicine_form_list;
						 }
					}
				}
			   array_push($single_array,  $mix_array);
			}
			$res['error'] = false;
		   return response($single_array, 200);
		}else{
			$res['error'] = true;
			$res['message'] ='datainsufficient';
			return response($res, 200);

		}
}	
/* 	public function importPatientHistory(Request $request){
		$dt =  Carbon::now('Asia/Kolkata');
		$template_array = [];
		$total_array = [];
		$mix_array = [];
		$main_array = [];
		$single_array = [];

		if((!empty($request->appointment_id) && count($request->appointment_id)>0) && (!empty($request->med_id) && count($request->med_id)>0)){
			$query = DB::table('prescribemedicine as pm')
			->LeftJoin('billing as b', 'b.id', '=', 'pm.billing_id')
			->LeftJoin('visit_status as vs', 'vs.billing_id', '=', 'pm.billing_id')
			->where('pm.status', '1')
			->where('b.status', '1')
			->where('vs.visit_status', '2')
			->whereIn('pm.appointment_id', $request->appointment_id)
			->whereIn('pm.medicine_id', $request->med_id)
			->where('pm.parent_id', '0')
			->orderBy('pm.medicine_serial_no','ASC')
			->groupBy('pm.medicine_name','pm.potency_name','pm.form_name')
			->distinct();
			if(!empty($request->potency) && count($request->potency)>0){
				$query->whereIn('pm.potency_id', $request->potency);
			}
			if(!empty($request->form) && count($request->potency)>0){
				$query->whereIn('pm.form_code', $request->form);
			}
			$prescribe_medicine_list = $query->get();
			foreach ($prescribe_medicine_list as $key => $value){
				if($value->midicine_type=='single' && !empty($value->medicine_id)){
					$single_medicine_list = DB::table('medicinegrouppotencies as mgp')->select('pg.form_name as form_name','mgpf.group_id as group_id','pg.form_code as form_code')
								->LeftJoin('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
								->LeftJoin("pricegrouprates as pg",function($join){
									$join->on("pg.pricegroup_id","=","mgpf.group_id")
										->on("pg.form_code","=","mgpf.form_code");
									})
								->where('pg.status', '1')
								->where('mgp.potency_id', $value->potency_id)
								->where('mgp.medicine_id', $value->medicine_id)
								->groupBy('mgpf.form_code')
								->distinct()
								->get();
							$main_array['single_medicine']= $prescribe_medicine_list[$key];
							$main_array['forms']= $single_medicine_list;
							array_push($single_array,  $main_array);
				}else if($value->midicine_type=='mix' || $value->midicine_type=='ontheflymix'){
						// Get prescribe medicine for mix medicine 
						$mix_medicine_list_array = DB::table('prescribemedicine as pm')->select('pm.*')
						->LeftJoin('billing as b', 'b.id', '=', 'pm.billing_id')
						->where('pm.status', '1')
						->where('b.status', '1')
						->whereIn('pm.appointment_id', $request->appointment_id)
						->whereIn('pm.medicine_id', $request->med_id)
						->get();

						 foreach ($mix_medicine_list_array as $key => $mix_value){
							 // This query get mix medicine list
							 $mix_medicine_list = DB::table('prescribemedicine as pm')
							->where('pm.status', '1')
							->where('pm.appointment_id', $mix_value->appointment_id)
							->where('pm.parent_id', $mix_value->id)
							->get();
							foreach ($mix_medicine_list as $key => $value1){
								$mix_medicine_form_list = DB::table('medicinegrouppotencies as mgp')->select('pg.form_name as fName','mgpf.group_id as gId','pg.form_code as fcode')
								->LeftJoin('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
								->LeftJoin("pricegrouprates as pg",function($join){
									$join->on("pg.pricegroup_id","=","mgpf.group_id")
										->on("pg.form_code","=","mgpf.form_code");
									})
								->where('pg.status', '1')
								->where('mgp.potency_id', $value1->potency_id)
								->groupBy('mgpf.form_id')
								->distinct()
								->get();
								$template_array[$value->medicine_name]['medicine'][$key]= $mix_medicine_list[$key];
								$template_array[$value->medicine_name]['serial_no'] = $value->medicine_serial_no;
								$template_array[$value->medicine_name]['mix_name'] = $value->medicine_name;
								$template_array[$value->medicine_name]['app_key'] = $value->appointment_id;
								$template_array[$value->medicine_name]['medicine_type'] = $value->midicine_type;
								$template_array[$value->medicine_name]['factor_value'] = $value->factor;
								$template_array[$value->medicine_name]['mix_id'] = $value->medicine_id;
								$template_array[$value->medicine_name]['instruction_id'] = $value->instruction_id;
								$template_array[$value->medicine_name]['instruction_other'] = $value->instruction_other_value;
								$template_array[$value->medicine_name]['instruction_name'] = $value->instruction_name;
								$template_array[$value->medicine_name]['form'][$key]= $mix_medicine_form_list;
								$template_array[$value->medicine_name]['form_code']= $value->form_code;
								$template_array[$value->medicine_name]['group_id']= $value->group_id;
								$template_array[$value->medicine_name]['form_name']= $value->form_name;
						  }

						 }
				}
			}
			$total_array['single'] = $single_array;
			$total_array['mix'] = $template_array;
			$res['error'] = false;
			return response($total_array, 200);
		}else{
			$res['error'] = true;
			$res['message'] ='datainsufficient';
			return response($res, 200);

		}
	} */
	/*This function is used for getting the pharmacy instruction for billing id,Rahul Khan 03 July 2019 */
	public function pharmacyinstruction($id='', Request $request){
		return Billing::find($id,['pharmacy_instruction']);
	}
	// public function getPrescribeMedicine($appointment_id='', $billing_id='', Request $request){
	// 	try{

	// 		$main_array = array();
	// 		$medicine_array = array();
	// 		$mix_price = array();
	// 		$medicine_total = array();
    //         if(isset($appointment_id) && isset($billing_id)){
	// 			$precribe_medicine_list = DB::table('billing as b')->LeftJoin('prescribemedicine as pm', 'pm.billing_id', '=', 'b.id')->where('b.status', '=', '1')->where('pm.parent_id', '=', '0')->where('pm.appointment_id', $appointment_id)->where('pm.billing_id', $billing_id)->orderBy('medicine_serial_no', 'ASC')->get();
	// 			foreach ($precribe_medicine_list as $key => $list){
	// 					$mix_medicine_list = Prescribemedicine::where('parent_id',$list->id)->get();
	// 					foreach ($mix_medicine_list as $key1 => $value){
	// 						array_push($mix_price, $value->medicine_amount);
							
	// 					}
	// 					$main_array['data']= $precribe_medicine_list[$key];
	// 					$main_array['mix']= $mix_medicine_list;
	// 					$main_array['pharmacy'] = $precribe_medicine_list[0]->pharmacy_instruction;
	// 					array_push($medicine_array,  $main_array);
	// 			}
	// 			array_push($medicine_total,$medicine_array);
	// 			return response()->json($medicine_total);
	// 		}else{
	// 				$res['error'] = true;
	// 				$res['message'] ='datainsufficient';
	// 				return response($res, 200);
		
	// 			}
    // 	}catch(\Illuminate\Database\QueryException $ex){

    //                 $res['status'] = false;
    //                 $res['message'] = $ex->getMessage();
    //                 return response($res, 500);

    //     }
	// }
	public function getPrescribeMedicine($appointment_id='', $billing_id='', Request $request){
		try{

			$main_array = array();
			$medicine_array = array();
			$mix_form = array();
			$medicine_total = array();
			$single_array = array();
            if(isset($appointment_id) && isset($billing_id)){
				$precribe_medicine_list = DB::table('billing as b')->LeftJoin('prescribemedicine as pm', 'pm.billing_id', '=', 'b.id')->where('b.status', '=', '1')->where('pm.parent_id', '=', '0')->where('pm.appointment_id', $appointment_id)->where('pm.billing_id', $billing_id)->get();
				foreach ($precribe_medicine_list as $key => $list){
						$single_medicine_form = DB::table('medicinegrouppotencies as mgp')->select('pg.form_name as form_name','mgpf.group_id as group_id','pg.form_code as form_code')
									->LeftJoin('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
									->LeftJoin("pricegrouprates as pg",function($join){
										$join->on("pg.pricegroup_id","=","mgpf.group_id")
											->on("pg.form_code","=","mgpf.form_code");
										})
									->where('pg.status', '1')
									->where('mgp.potency_id', $list->potency_id)
									->where('mgp.medicine_id', $list->medicine_id)
									->groupBy('mgpf.form_code')
									->distinct()
									->get();
								//$main_array['forms']= $single_medicine_form;
								//array_push($single_array,  $single_medicine_form[$key]);
						$mix_medicine_list = Prescribemedicine::where('parent_id',$list->id)->get();
						//print_r($mix_medicine_list);
						/* foreach ($mix_medicine_list as $key1 => $value1){
							$mix_medicine_form_list = DB::table('medicinegrouppotencies as mgp')->select('pg.form_name as fName','mgpf.group_id as gId','pg.form_code as fcode')
								->LeftJoin('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
								->LeftJoin("pricegrouprates as pg",function($join){
									$join->on("pg.pricegroup_id","=","mgpf.group_id")
										->on("pg.form_code","=","mgpf.form_code");
									})
								->where('pg.status', '1')
								->where('mgp.potency_id', $value1->potency_id)
								->where('mgp.medicine_id', $value1->medicine_id)
								->groupBy('mgpf.form_id')
								->distinct()
								->get();
								//$main_array['mixforms']= $single_medicine_form;
								array_push($mix_form, $mix_medicine_form_list);
						} */
						$main_array['data']= $precribe_medicine_list[$key];
						
						$main_array['single_form'] = $single_medicine_form;
						
				//This below object is working for getting the form object
					//	$form_mix = '';
						$form_mix_array = array();
						$form_mix = (object)array();
						$form_mix->form_id = 2;
						$form_mix->form_code = $precribe_medicine_list[$key]->form_code;
						$form_mix->name = $precribe_medicine_list[$key]->form_name;
						$form_mix->group = $precribe_medicine_list[$key]->group_id;
						//$form_mix = json_encode($form_mix);
						array_push($form_mix_array, $form_mix);
						//This below code is used for Getting mix available fomrs form mixmedicine module controller, Rahul khan 09_Sept_2019
						if($list->medicine_id > 0 && $list->midicine_type=='mix'){
							$main_array['mix_form'] = app('App\Modules\Mixmedicine\Http\Controllers\MedicinemixController')->getMixSelectForms($list->medicine_id, $request );
						}else{
							$main_array['mix_form'] = $form_mix_array;
						}
						//	$main_array['mix_form']= $mix_form;
						
						$main_array['mix']= $mix_medicine_list;
						$main_array['pharmacy'] = $precribe_medicine_list[0]->pharmacy_instruction;
						$main_array['reason'] = $precribe_medicine_list[0]->edit_reason;

						array_push($medicine_array,  $main_array);
				}
				array_push($medicine_total,$medicine_array);
				return response()->json($medicine_total);
			}else{
					$res['error'] = true;
					$res['message'] ='datainsufficient';
					return response($res, 200);
		
				}
    	}catch(\Illuminate\Database\QueryException $ex){

                    $res['status'] = false;
                    $res['message'] = $ex->getMessage();
                    return response($res, 500);

        }
	}
	//This function is used fro getting visit applied charges list
	public function getVisitCharges($appointment_id='', $billing_id='', Request $request){
		return billingPatientCharge::where('appointment_id', $appointment_id)->where('billing_id', $billing_id)->get();
	}//This function is used fro getting total paid amount for this visit,
	public function getVisitReceivedAmount($appointment_id='', $billing_id='', Request $request){
		//return Payment::where('appointment_id', $appointment_id)->get()->first();
		$count_row = Payment::where('appointment_id', $appointment_id)->get()->count();
		$recieved_amount= Payment::select('total_due_amount', 'recieved_amount', 'visit_due_amount', 'credit_amount', 'debit_amount', 'previous_bill_paid_amount', DB::raw("(SELECT Name FROM cl_users WHERE user_id = cl_payment.created_by) as biller_name"), 'recieved_amount', 'transaction_time', 'refund_flag')->where('appointment_id', $appointment_id)->where('billing_id', $billing_id)->get();
		
		$credit_amount= Payment::where('appointment_id', $appointment_id)->where('billing_id', $billing_id)->where('refund_flag', '0')->sum('recieved_amount');
		$debit_amount= Payment::where('appointment_id', $appointment_id)->where('billing_id', $billing_id)->where('refund_flag', '1')->sum('recieved_amount');
		$transaction_mode= Payment::select('transaction_mode')->where('appointment_id', $appointment_id)->orderBy('id','DESC')->first();
		//print_r($recieved_amount);exit;
		$total_received_amount = abs($credit_amount-$debit_amount);
		if($count_row > 0){
			$res['recieved_amount'] = $recieved_amount;
			$res['amount'] = number_format((float)$total_received_amount, 2, '.', '');
			$res['credit_amount'] = $credit_amount;
			$res['debit_amount'] = $debit_amount;
		}else{
			$res['recieved_amount'] = 0;
			$res['amount'] = 0;
		}
				$res['transaction_mode'] = $transaction_mode;
				return response($res, 200);
	}
	//This function is used for getting the visit applied on the fly discount
	public function getVisitDiscount($appointment_id='', $billing_id='', Request $request){
		$discounts = array();
		//array_push($discounts,  $main_array);
		$patient_discount = discount::select('discount_on_med','discount_reason','discount_after_med_cost','id',DB::raw("(SELECT Name FROM cl_users WHERE user_id = cl_patient_discount.created_by) as discount_apply_name"))->where('appointment_id', $appointment_id)->where('billing_id', $billing_id)->get()->first();
		//return count($patient_discount);
		if(!empty($patient_discount)){
			$discounts['discount_on_med'] = $patient_discount->discount_on_med;
			$discounts['discount_id'] = $patient_discount->id;
			$discounts['discount_after_med_cost'] = $patient_discount->discount_after_med_cost;
			$discounts['med_resson'] = $patient_discount->discount_reason;
			$discounts['discount_apply_name'] = $patient_discount->discount_apply_name;
		}else{
			//$discounts['discount_on_med'] = $patient_discount->discount_on_med;
			//$discounts['discount_after_med_cost'] = $patient_discount->discount_after_med_cost;
		}
		
		//array_push($discounts,  $patient_discount);
		$waive_discount =  Billing::select('waive_consultancy_fees','waive_type','consultancy_waived_reason', DB::raw("(SELECT Name FROM cl_users WHERE user_id = cl_billing.consultancy_waived_by) as consultacy_apply_name"))->where('appointment_id', $appointment_id)->where('id', $billing_id)->get()->first();
		$discounts['waive_consultancy_fees'] = $waive_discount->waive_consultancy_fees;
		$discounts['waive_type'] = $waive_discount->waive_type;
		$discounts['consultacy_reason'] = $waive_discount->consultancy_waived_reason;
		$discounts['consultacy_apply_name'] = $waive_discount->consultacy_apply_name;
		//$discount =array_push($discounts,  $waive_discount);
		///$discount = json_decode($discount);
		return $discounts;
	}

	/*This function is used for removing the on the fly discount Shubh Tiwari 18 July 2019 */
	public function discoutremove(Request $request){
			if(!empty($request->discount)){
				discount::where('id', $request->discount)->delete();
				$res['error'] = false;
				$res['message'] = 'discount_remove';
				return response($res, 200);
			}else{
				$res['error'] = true;
				$res['message'] ='datainsufficient';
				return response($res, 200);
	
			}
	} 

	/*This function is used for removing the consultancy waived Shubh Tiwari 18 July 2019 */
	public function consultanyremove(Request $request){
		$billing = new Billing();
		if(!empty($request->bill_id) && !empty($request->visit_id)){
			$item = $billing->findOrFail($request->bill_id);
				if($item){
					$billing->where('id', $request->bill_id)->where('appointment_id', $request->visit_id)->update(['waive_consultancy_fees'=>0.00,'waive_type'=>'Not Set','consultancy_waived_reason'=>null,'waive_percentage'=>0.00]);
				}
			$res['error'] = false;
			$res['message'] = 'cwaiveremove';
			return response($res, 200);
		}else{
			$res['error'] = true;
			$res['message'] ='datainsufficient';
			return response($res, 200);

		}
	}

   /*This function is used for get patient previous visit pending amount Shubh Tiwari 18 July 2019 */
	public function getPatientVisitPreviousPendingAmount($patient_id='', $visit_id='',  Request $request){
		try{
				$pending_array =[];
				$dt =  Carbon::now('Asia/Kolkata');
				if(isset($patient_id)){
					//This below code comment by shubh tiwari 16 jan 2020 beacause this code get last due amount of patient
					 $pendind_list =  DB::table('payment')->select('debit_amount','credit_amount','due_amount','transaction_time')->where('patient_id', $patient_id)->where('status', '1')->orderBy('id', 'DESC')->where('appointment_id','!=', $visit_id)->take(1)->first();
					 //$pendind_list =  DB::table('payment')->select('debit_amount','credit_amount','due_amount')->where('patient_id', $patient_id)->where('status', '1')->orderBy('id', 'DESC')->where('appointment_id', $visit_id)->take(1)->first();
					//$pendind_list =  DB::table('payment')->select('debit_amount','credit_amount')->where('patient_id', $patient_id)->where('status', '1')->orderBy('id', 'DESC')->first();
					if(!empty($pendind_list)){
						$balance = ($pendind_list->debit_amount-$pendind_list->credit_amount);
						$pending_array['due_amount'] =number_format((float)$balance, 2, '.', '');
						$pending_array['transaction_time'] = $pendind_list->transaction_time;
						$res['error'] = false;
						$res['data'] =$pending_array;
						return response($res, 200);
					}else{
						$res['error'] = false;
						$res['data'] =null;
						return response($res, 200);
					}
				}else{
					$res['error'] = false;
					$res['data'] =null;
					return response($res, 200);
				}
		}catch(\Illuminate\Database\QueryException $ex){
				$res['status'] = false;
				$res['message'] = $ex->getMessage();
				return response($res, 500);
			}
	  }
   /*This function is used for get patient after visit pending amount Shubh Tiwari 28 Jan 2020 */
	public function getPatientVisitAfterPendingAmount($appointment_id='', $billing_id='',  Request $request){
		   try{
				  return Payment::select('previous_due_amount')->where('appointment_id', $appointment_id)->where('billing_id','!=', $billing_id)->get();
				  
		   }catch(\Illuminate\Database\QueryException $ex){
				$res['status'] = false;
				$res['message'] = $ex->getMessage();
				return response($res, 500);
		  }		
	  }
	  
	   // Patient Pending Visit Detail Function
	 public function pendingVisitDetails(Request $request){
		if(!empty($request->patient_id) && !empty($request->visit_id)){
				$patient_id = $request->patient_id;
				$visit_id = $request->visit_id;
				$item = Payment::where('patient_id', $patient_id)->where('status', '1')->orderBy('creation_date','desc')->get();
				$res['error'] = false;
				$res['data'] = $item;
				return response($res, 200);
		}else{
			$res['error'] = true;
			$res['message'] ='datainsufficient';
			return response($res, 200);
		}
	}

	   /*This function is used for get patient previous visit pending amount Shubh Tiwari 18 July 2019 */
	   public function getPatientVisitComment($patient_id='', $visit_id='',  Request $request){
		try{
				$pending_array =[];
				$dt =  Carbon::now('Asia/Kolkata');
				if(isset($patient_id)){
					$pendind_list = Payment::select('debit_amount','credit_amount','remark','transaction_time','due_amount','transaction_status')->where('patient_id', $patient_id)->where('appointment_id', $visit_id)->where('status', '1')->orderBy('creation_date','desc')->first();
					// $pendind_list =  DB::table('payment')->select('debit_amount','credit_amount','remark','transaction_time','due_amount','transaction_status')->where('patient_id', $patient_id)->where('status', '1')->orderBy('id', 'DESC')->where('appointment_id','!=', $visit_id)->take(1)->first();
					if(!empty($pendind_list)){
						$balance = ($pendind_list->debit_amount-$pendind_list->credit_amount);
						$pending_array['visit_comment'] =$pendind_list->remark;
						$pending_array['visit_time'] =$pendind_list->transaction_time;
						$pending_array['visit_due_amount'] =number_format((float)$balance, 2, '.', '');
						$pending_array['visit_transaction_status'] =$pendind_list->transaction_status;
						$res['error'] = false;
						$res['data'] =$pending_array;
						return response($res, 200);
					}else{
						$res['error'] = false;
						$res['data'] =null;
						return response($res, 200);
					}
				}else{
					$res['error'] = false;
					$res['data'] =null;
					return response($res, 200);
				}
		}catch(\Illuminate\Database\QueryException $ex){
				$res['status'] = false;
				$res['message'] = $ex->getMessage();
				return response($res, 500);
			}
	  }

	//This below function is used for getting the appointment shift for appling the discounts
	public function getAppoinmentShift( $appointment_id='',  Request $request){
		try{
			//appointments
			return appointments::select('shift_id')->where('id', $appointment_id)->first();
		}catch(\Illuminate\Database\QueryException $ex){
				$res['status'] = false;
				$res['message'] = $ex->getMessage();
				return response($res, 500);
			}

		}
//This below function is used for getting the patient pharmacy instruction 
		public function getPharmacyHistory($patient_id='', $visit_id= '',  Request $request){
			try{
				//return Billing::select('appointment_id','pharmacy_instruction','creation_date')->where('patient_id', $patient_id)->get();
				// Billing::select('billing.appointment_id','billing.pharmacy_instruction','billing.creation_date', 'patient_discount.discount_reason','billing.consultancy_waived_reason',DB::raw("(SELECT Name FROM cl_users WHERE user_id = cl_billing.created_by) as biller_name"))->leftJoin('appointments', function($join){
				// 	$join->on('billing.appointment_id', '=', 'appointments.id');
				// })->leftJoin('patient_discount', function($join){
				// 	$join->on('billing.appointment_id', '=', 'patient_discount.appointment_id');
				// })->where('billing.patient_id', $patient_id)->where('billing.appointment_id', '!=', $visit_id)->orderBy('appointments.current_appointment_date', 'DESC')->get();
				return DB::table('billing as b')->select('b.appointment_id', 'b.pharmacy_instruction','b.creation_date','b.consultancy_waived_reason', 'pd.discount_reason', DB::raw("(SELECT Name FROM cl_users WHERE user_id = cl_b.created_by) as biller_name"))
                      ->LeftJoin("visit_status as vs", function($join){
			                  $join->on("vs.appointment_id", "=", "b.appointment_id");
							  $join->on("vs.billing_id", "=", "b.id");
			          })->LeftJoin("patient_discount as pd", function($join){
			                  $join->on("pd.appointment_id", "=", "b.appointment_id");
							  $join->on("pd.billing_id", "=", "b.id");
			          })->where('vs.patient_id' , $patient_id)
					  ->where('vs.appointment_id', '!=', $visit_id)
					  ->where('vs.visit_status' , '2')
					  ->orderBy('vs.appointment_id','DESC')
					  ->groupBy('vs.appointment_id')
					  ->distinct()
					  ->get();

			}catch(\Illuminate\Database\QueryException $ex){
					$res['status'] = false;
					$res['message'] = $ex->getMessage();
					return response($res, 500);
				}
	
			}
//This below function is used for getting payment transaction mode with price and reference no
	public function getVisitEachPaymentModeAmount($appointment_id='', $billing_id='', Request $request){
		try{
		 $getPaymentIdList= Payment::select('id')->where('appointment_id', $appointment_id)->where('billing_id', $billing_id)->orderBy('transaction_time', 'ASC')->get();
			foreach($getPaymentIdList as  $payid){
				$payment_mode_list = visitPaymentModes::select('mode_price','reference_no', DB::raw("(SELECT name FROM cl_payment_mode WHERE id = mode_id) as transaction_mode"))->where('payment_id', $payid->id)->get();
				$res['transaction_mode'] = $payment_mode_list;
			}
		     return response($res, 200);
		}catch(\Illuminate\Database\QueryException $ex){
			$res['status'] = false;
			$res['message'] = $ex->getMessage();
			return response($res, 500);
		}
	}		
//This below function is used for getting multiple transaction details using billing id, Shubh Tiwari 02 jan 2020
	public function getTransactionDetailByBillingId(Request $request){
		try{
		$main_array = array();
		 $getPaymentIdList= Payment::select('id')->where('appointment_id', $request->visit_id)->where('billing_id', $request->bill_id)->orderBy('transaction_time', 'ASC')->get();
			foreach($getPaymentIdList as  $payid){
				 $payment_mode_list = visitPaymentModes::select('mode_price','reference_no', DB::raw("(SELECT refund_flag FROM cl_payment WHERE id = payment_id) as refund_flag"), DB::raw("(SELECT transaction_time FROM cl_payment WHERE id = payment_id) as transaction_time"), DB::raw("(SELECT name FROM cl_payment_mode WHERE id = mode_id) as transaction_mode"))->where('payment_id', $payid->id)->get();
				//$res['transaction_mode'] = $payment_mode_list;
				array_push($main_array, $payment_mode_list);
			}
		     return response($main_array, 200);
		}catch(\Illuminate\Database\QueryException $ex){
			$res['status'] = false;
			$res['message'] = $ex->getMessage();
			return response($res, 500);
		}
	}
   //This below function is used for getting the visit billing list  Shubh Tiwari 04 feb 2020
   public function getVisitBillingList($appointment_id='', $billing_id='', Request $request){
	  			try{
				   return Billing::select('billing.id', 'billing.appointment_id','billing.patient_id','billing.creation_date',DB::raw("(SELECT Name FROM cl_users WHERE user_id = cl_billing.created_by) as biller_name"))->leftJoin('visit_status', function($join){
					$join->on('billing.id', '=', 'visit_status.billing_id');
				   })->where('billing.appointment_id', $appointment_id)->where('billing.id', '!=', $billing_id)->where('visit_status.visit_status', '=', 2)->groupBy('billing.id')->get();
				}catch(\Illuminate\Database\QueryException $ex){
						$res['status'] = false;
						$res['message'] = $ex->getMessage();
						return response($res, 500);
				}
   }
   
   // get patient Previous bill amount
  public function getPatientPreviousBillAmount($appointment_id='', Request $request){
	    try{
				    $credit_amount = DB::table('billing as b')->leftJoin('payment as p', function($join){
							$join->on('b.appointment_id', '=', 'p.appointment_id');
							$join->on('b.id', '=', 'p.billing_id');
						})->where('b.appointment_id', $appointment_id)->where('p.appointment_id', $appointment_id)->where('b.status', '1')->where('p.refund_flag', '0')->sum('p.recieved_amount');
				   $debit_amount = DB::table('billing as b')->leftJoin('payment as p', function($join){
									$join->on('b.appointment_id', '=', 'p.appointment_id');
									$join->on('b.id', '=', 'p.billing_id');
								})->where('b.appointment_id', $appointment_id)->where('p.appointment_id', $appointment_id)->where('b.status', '1')->where('p.refund_flag', '1')->sum('p.recieved_amount');
				   
				   
				   return $credit_amount-$debit_amount;
		   }catch(\Illuminate\Database\QueryException $ex){
						$res['status'] = false;
						$res['message'] = $ex->getMessage();
						return response($res, 500);
		  }
	 }
// get visit bill status
  public function getVisitBillStatus($appointment_id='', $billing_id='', Request $request){
	    try{
				   return $visit_list = DB::table('visit_status as v')->select('v.visit_status')->where('v.appointment_id', $appointment_id)->where('v.billing_id', $billing_id)->get();
		   }catch(\Illuminate\Database\QueryException $ex){
						$res['status'] = false;
						$res['message'] = $ex->getMessage();
						return response($res, 500);
		  }
	 }
// get patient Previous bill consultancy amount
  public function getPatientPreviousBillConsultancyAmount($appointment_id='', $billing_id='', Request $request){
	    try{
				   return $bill_list = DB::table('billing as b')->select('b.waive_consultancy_fees')->where('b.id', '!=', $billing_id)->where('b.appointment_id', $appointment_id)->where('b.status', '1')->orderBy('b.id', 'DESC')->get();
		   }catch(\Illuminate\Database\QueryException $ex){
						$res['status'] = false;
						$res['message'] = $ex->getMessage();
						return response($res, 500);
		  }
	 }
// get patient Previous bill Other Charge amount
  public function getPatientPreviousBillOtherChargeAmount($appointment_id='', $billing_id='', Request $request){
	    try{
				  return billingPatientCharge::where('appointment_id', $appointment_id)->where('billing_id','!=', $billing_id)->get();
		   }catch(\Illuminate\Database\QueryException $ex){
						$res['status'] = false;
						$res['message'] = $ex->getMessage();
						return response($res, 500);
		  }
	 }
	//This function is used for getting the visit applied on the fly previous discount
	public function getVisitPreviousDiscount($appointment_id='', $billing_id='', Request $request){
		$discounts = array();
		//array_push($discounts,  $main_array);
		$patient_discount = discount::select('discount_on_med','discount_reason','discount_after_med_cost','id',DB::raw("(SELECT Name FROM cl_users WHERE user_id = cl_patient_discount.created_by) as discount_apply_name"))->where('appointment_id', $appointment_id)->where('billing_id','!=', $billing_id)->get()->first();
		//return count($patient_discount);
		if(!empty($patient_discount)){
			$discounts['discount_on_med'] = $patient_discount->discount_on_med;
			$discounts['discount_id'] = $patient_discount->id;
			$discounts['discount_after_med_cost'] = $patient_discount->discount_after_med_cost;
			$discounts['med_resson'] = $patient_discount->discount_reason;
			$discounts['discount_apply_name'] = $patient_discount->discount_apply_name;
		}
		
		//array_push($discounts,  $patient_discount);
		$waive_discount =  Billing::select('waive_consultancy_fees','waive_type','consultancy_waived_reason', DB::raw("(SELECT Name FROM cl_users WHERE user_id = cl_billing.consultancy_waived_by) as consultacy_apply_name"))->where('appointment_id', $appointment_id)->where('id' , '!=', $billing_id)->get()->first();
		if(!empty($waive_discount)){
			$discounts['waive_consultancy_fees'] = $waive_discount->waive_consultancy_fees;
			$discounts['waive_type'] = $waive_discount->waive_type;
			$discounts['consultacy_reason'] = $waive_discount->consultancy_waived_reason;
			$discounts['consultacy_apply_name'] = $waive_discount->consultacy_apply_name;
		}
		return $discounts;
	}
	
/* This function chnage by shubh tiwari as on 05 March 2020 for showing visit data order by latest date*/	
 public function previousPatientHistory($appointment_id='', $patient_id='', $importvisitid='', Request $request){
		$dt =  Carbon::now('Asia/Kolkata');
		$main_array=[];
		$sub_array=[];
		$total_array=[];
		$medicine_array=[];
		if(isset($patient_id)){
			$offset = $request->has('page') ? $request->get('page') : 1;
            $limit = $request->has('limit') ? $request->get('limit') : 5;
		    $prescribe_visit_list = DB::table('billing as b')->select('vs.billing_id', 'vs.appointment_id','b.doctor_id','vs.creation_date')
			                                  ->LeftJoin("visit_status as vs", function($join){
									                  $join->on("vs.appointment_id", "=", "b.appointment_id");
													  $join->on("vs.billing_id", "=", "b.id");
									          })->where('vs.patient_id' , $patient_id)
											  ->where('vs.appointment_id', '!=', $appointment_id)
											  //->where('vs.appointment_id', '!=', $importvisitid)
											  ->where('vs.visit_status' , '2')
											  ->orderBy('vs.appointment_id','DESC')
											  ->groupBy('vs.appointment_id')
											  ->distinct()
											  ->take($limit)
											  ->get();
			    $list = DB::table('billing as b')->select('vs.billing_id', 'vs.appointment_id','b.doctor_id','vs.creation_date')
			                                  ->LeftJoin("visit_status as vs", function($join){
									                  $join->on("vs.appointment_id", "=", "b.appointment_id");
													  $join->on("vs.billing_id", "=", "b.id");
									          })->where('vs.patient_id' , $patient_id)
											   ->where('vs.appointment_id', '!=', $appointment_id)
											   //->where('vs.appointment_id', '!=', $importvisitid)
											  ->where('vs.visit_status' , '2')
											  ->orderBy('vs.appointment_id','DESC')
											  ->groupBy('vs.appointment_id')
											  ->distinct()
											  ->get();
				foreach($prescribe_visit_list as $key => $value){
									$prescribe_medicine_list = DB::table('prescribemedicine as pm')
									->where('pm.billing_id', $value->billing_id)
									->where('pm.appointment_id', $value->appointment_id)
									->where('pm.status', '1')
									->where('pm.parent_id', '0')
									->orderBy('pm.id','ASC')
									->groupBy('pm.medicine_name','pm.potency_name','pm.form_name','pm.appointment_id')
									->distinct()
									->get();
								 foreach ($prescribe_medicine_list as $key1 => $value2){
										$medicine_array[$key1] =$value2;
										$total_array[$value->creation_date][$key1] =$prescribe_medicine_list[$key1];
										$total_array[$value->creation_date]['date'] =$value->creation_date;
										$total_array[$value->creation_date]['billing'] =$value->billing_id;
										$total_array[$value->creation_date]['appointment'] =$value->appointment_id;
										$total_array[$value->creation_date]['doctor_name'] =users::select('label')->where('user_id', $value->doctor_id)->first();
								} 
							
						} 
					     $res['error'] = false;
						 $main_array['total'] = $list->count();
						 $main_array['count'] = $prescribe_visit_list->count();
						 $main_array['patient_id'] = $patient_id;
						   array_push($main_array,$total_array); 
						return response($main_array, 200);
			}else{
				$res['error'] = true;
				$res['message'] ='datainsufficient';
				return response($res, 200);
			}
   }
   
   // For consultancy update script
   public function completeexportHistory(Request $request){
	   
	   
		$billing = new Billing();
		$precribe_medicine_list = DB::table('billing as b')->select('b.id','b.appointment_id', 'dc.price')->LeftJoin('doctorcharges  as dc', 'dc.doctor_id', '=', 'b.doctor_id')->where('b.status', '=', '1')->whereNotNull('b.doctor_id')->where('dc.charge_code', 'LIKE', "%cns%")->get();
			foreach($precribe_medicine_list as $prescribe){
				$item = $billing->findOrFail($prescribe->id);
				if($item){
					$billing->where('id', $prescribe->id)->where('appointment_id', $prescribe->appointment_id)->update(['waive_consultancy_fees'=>$prescribe->price]);
				}
			}
		}
	// for instruction update script
	public function changeinstruction(Request $request){
		$Prescribemedicine = new Prescribemedicine();
		  $medicine_instruction_list = $Prescribemedicine::select('id','instruction_name')->where('instruction_id', '!=', 0)->get();
			foreach($medicine_instruction_list as $ins_list){
				$item = $Prescribemedicine->findOrFail($ins_list->id);
				if($item){
					$Prescribemedicine->where('id', $ins_list->id)->update(['instruction_other_value'=>$ins_list->instruction_name]);
				}
			}
		}
		//This below function is used for getting multiple transaction details using billing id, Shubh Tiwari 02 jan 2020
	public function getTransactionDetailByVisitId(Request $request){
		try{
		$main_array = array();
		 $getPaymentIdList= Payment::select('id')->where('appointment_id', $request->visit_id)->orderBy('transaction_time', 'ASC')->get();
			foreach($getPaymentIdList as  $payid){
				 $payment_mode_list = visitPaymentModes::select('mode_price','reference_no', DB::raw("(SELECT refund_flag FROM cl_payment WHERE id = payment_id) as refund_flag"), DB::raw("(SELECT transaction_time FROM cl_payment WHERE id = payment_id) as transaction_time"), DB::raw("(SELECT name FROM cl_payment_mode WHERE id = mode_id) as transaction_mode"))->where('payment_id', $payid->id)->get();
				//$res['transaction_mode'] = $payment_mode_list;
				array_push($main_array, $payment_mode_list);
			}
		     return response($main_array, 200);
		}catch(\Illuminate\Database\QueryException $ex){
			$res['status'] = false;
			$res['message'] = $ex->getMessage();
			return response($res, 500);
		}
	}
	
/* This function chnage by shubh tiwari as on 07 Dec 2020 for showing last visit data order by latest date*/	
 public function lastVisitPatientHistory($patient_id='', Request $request){
		$dt =  Carbon::now('Asia/Kolkata');
		$single_array=[];
		if(isset($patient_id)){
            $limit = $request->has('limit') ? $request->get('limit') : 1;
		    $prescribe_visit_list = DB::table('billing as b')->select('vs.billing_id', 'vs.appointment_id','b.doctor_id','vs.creation_date')
			                                  ->LeftJoin("visit_status as vs", function($join){
									                  $join->on("vs.appointment_id", "=", "b.appointment_id");
													  $join->on("vs.billing_id", "=", "b.id");
									          })->where('vs.patient_id' , $patient_id)
											  ->where('vs.visit_status' , '2')
											  ->orderBy('vs.appointment_id','DESC')
											  ->groupBy('vs.appointment_id')
											  ->distinct()
											  ->take($limit)
											  ->get();
			if($prescribe_visit_list->count()>0){					  
				foreach($prescribe_visit_list as $key => $value){
									$prescribe_medicine_list = DB::table('prescribemedicine as pm')
									->where('pm.billing_id', $value->billing_id)
									->where('pm.appointment_id', $value->appointment_id)
									->where('pm.status', '1')
									->where('pm.parent_id', '0')
									->orderBy('pm.id','ASC')
									->groupBy('pm.medicine_name','pm.potency_name','pm.form_name','pm.appointment_id')
									->distinct()
									->get();
								 foreach ($prescribe_medicine_list as $key1 => $value2){
										/* This below query $prescribe_medicine_list variable get the total medicine by billing id, appointment_id, and prescribemedicine table id */
												$prescribe_medicine_list = DB::table('prescribemedicine as pm')
												->where('pm.status', '1')
												->where('pm.appointment_id', $value2->appointment_id)
												->where('pm.billing_id', $value2->billing_id)
												->where('pm.id', $value2->id)
												->distinct()
												->get();
												foreach ($prescribe_medicine_list as $key => $value){
													$mix_array = [];
													 /* This below query $single_medicine_list variable get single medicine all form using potency id and medicine id*/
													$single_medicine_list = DB::table('medicinegrouppotencies as mgp')->select('pg.form_name as form_name','mgpf.group_id as group_id','pg.form_code as form_code')
													->LeftJoin('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
													->LeftJoin("pricegrouprates as pg",function($join){
														$join->on("pg.pricegroup_id","=","mgpf.group_id")
															->on("pg.form_code","=","mgpf.form_code");
														})
													->where('pg.status', '1')
													->where('mgp.potency_id', $value->potency_id)
													->where('mgp.medicine_id', $value->medicine_id)
													->groupBy('mgpf.form_code')
													->distinct()
													->get();
													
													 /* Assign iteration value to $max_array array  */
													$mix_array = $value;
													
													/* This variable $mix_medicine_list geting the child medicine of mix medicine*/
													$mix_medicine_list = Prescribemedicine::where('parent_id', $value->id)->get();
													
													$mix_medicine_form = DB::table('medicinemixvariant as mmv')->select('mg.group_id','pg.form_name as form_name','pg.form_code as form_code')
																				->LeftJoin('medicinegrouppotencies as mgp', 'mgp.potency_id', '=', 'mmv.mixPotencyId')
																				->LeftJoin('mixmedicineform as mf', 'mf.mixid', '=', 'mmv.medicinemixId')
																				->LeftJoin("pricegrouprates as pg",function($join){
																				$join->on("pg.form_code","=","mf.form_code");
																				})
																				//->LeftJoin('medicinegrouppotencies as mgp', 'mgp.medicine_id', '=', 'mmv.mixMedicineId')
																				->LeftJoin("medicinegroups as mg",function($join){
																				$join->on("mg.id","=","mgp.medicinegroup_id");
																				})->where('mmv.medicinemixId', $value->medicine_id)
																				->where('mmv.status', '1')
																				->where('mgp.status', '1')
																				->where('mg.status', '1')
																				->where('pg.status', '1')
																				->where('mf.status', '1')
																				->distinct()
																				->get();
																				
																				
													if($value->midicine_type=='single'){
															$mix_array->form = $single_medicine_list;
															$mix_array->mix = [];
													}else if($value->midicine_type=='mix'){
														
															$mix_array->form = $mix_medicine_form;
															//$mix_array->group = $mix_medicine_groupId;
															
															
													}
													if(count($mix_medicine_list) >0){
														$mix_array->mix = $mix_medicine_list;
														if($value->midicine_type=='ontheflymix'){
													/* This foreach loop geting the ontheflymix mix medicine form*/						
																foreach ($mix_medicine_list as $key => $value1){
																			$mix_medicine_form_list = DB::table('medicinegrouppotencies as mgp')->select('pg.form_name as form_name','mgpf.group_id as group_id','pg.form_code as form_code')
																			->LeftJoin('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
																			->LeftJoin("pricegrouprates as pg",function($join){
																				$join->on("pg.pricegroup_id","=","mgpf.group_id")
																					->on("pg.form_code","=","mgpf.form_code");
																				})
																			->where('pg.status', '1')
																			->where('mgp.potency_id', $value1->potency_id)
																			->groupBy('mgpf.form_id')
																			->distinct()
																			->get();
																	
																   $mix_array->form = $mix_medicine_form_list;
															 }
														}
													}
												   array_push($single_array,  $mix_array);
												}
								} 
								$res['error'] = false;
								return response($single_array, 200);
							
						} 
					}else{
						$res['error'] = true;
						$res['count'] =0;
						return response($res, 200);
					}
			}else{
				$res['error'] = true;
				$res['message'] ='datainsufficient';
				return response($res, 200);
			}
   }
   function patientAdvancePayment(Request $request){
		$payment = new Payment();
		$billing = new Billing();
		$visit = new Visit();
	
		//return $request->consultancy_status;
		$dt =  Carbon::now('Asia/Kolkata');
		$currentDate = $dt->toDateString();
			
			$billing->consultancy_waived_by = $request->user_id;
			$billing->patient_id  = $request->patient_id ;
			$billing->appointment_id  = $request->appointment_id ;
			$billing->doctor_id = $request->doctor_id;
			$billing->consultancy_waived_by = $request->user_id;
			//$billing->consultancy_waived_reason = '';
			$billing->waive_consultancy_fees = $request->total_due;
			//$billing->waive_type = $request->consultancy_status;
			//$billing->waive_percentage = $request->consultancy_percentage;
			
			$billing->save();
			$billing_id =  $billing->id;
			
			$affected = DB::table('appointments')->where('id', $request->appointment_id)->update(['advance_payment_received' => 1]);
			
		
		
		
			//$total_due = $request->total_due;
			$total_due = 120;
			$recieved_amount = $request->recieved_amount;
			$payment->total_due_amount = $request->total_due;
			$payment->recieved_amount = $request->recieved_amount;
			if($request->recieved_amount == $request->total_due){
				$due_amount = ($total_due - $recieved_amount);
				$payment->credit_amount = $due_amount;
				$payment->transaction_status = 'Credit';
			}else if($request->recieved_amount > $request->total_due){
				$due_amount = ($recieved_amount - $total_due);
				$payment->credit_amount = $due_amount;
				$payment->transaction_status = 'Credit';
			}else if($request->recieved_amount < $request->total_due){
				$due_amount = ($total_due - $recieved_amount);
				$payment->debit_amount = $due_amount;
				$payment->transaction_status = 'Debit';
			}
			$payment->visit_due_amount = $request->visit_due;
			$payment->previous_due_amount = $request->previous_due;
			$payment->remark = $request->note;
			$payment->billing_id = $billing_id;
			$payment->appointment_id = $request->appointment_id;
			$payment->patient_id = $request->patient_id;
			$payment->created_by =  $request->user_id;
			$payment->previous_bill_paid_amount =  0;
			//$payment->refund_flag = $request->refund;
			$payment->transaction_time = $dt;
			$payment->save();
			$last_payment_id =  $payment->id;
			// Insert visit payment mode data in visit_payment_modes Dec 30 Shubh Tiwari
			if(!empty($last_payment_id) ){
			foreach ($request->payment_mode_data as $key => $value){
						$visitPaymentModes = new visitPaymentModes();
						$visitPaymentModes->payment_id = $last_payment_id;
						$visitPaymentModes->mode_price = $request->payment_mode_data[$key]['mode_price'];
						$visitPaymentModes->mode_id = $request->payment_mode_data[$key]['payment_mode_id'];
						$visitPaymentModes->created_by =  $request->user_id;
						$visitPaymentModes->save();
						$last_visit_mode_id =  $visitPaymentModes->id;
						$visitPaymentModes->where('id', $last_visit_mode_id)->update(['reference_no'=>$request->reference_no_data[$key]['reference_no']]);
				}
			}

			$res['error'] = false;
			$res['actions'] = 'add';
			return response($res, 200);
		   
   }

   public function updateConsultancy(Request $request){
   		$doctor_charge_array = array();

   		$consultancy_list = Billing::where('status', '1')->select('doctor_id','id')->where('creation_date', '<=', '2021-03-31')->where('doctor_id', '!=', '')->get();

   		foreach ($consultancy_list as $key => $value) {

   			$doctor_chrg = DoctorCharges::select('price')->where('doctor_id', $value->doctor_id)->where('charge_code', '=',  'cns')->get();
    		   if(count($doctor_chrg)>0){

					array_push($doctor_charge_array,  $doctor_chrg[0]->price);
					//Billing::where('id', $value->id)->update(['consultancy_fees'=>$doctor_chrg[0]->price]);
				}
   		}
   			
   		$res ['count'] =count($doctor_charge_array);
   		$res ['doctor_charge_array'] =$doctor_charge_array;
   		return response($res, 200);
   }

   public function getConsultancy($doctor_id='', $billing_id='', Request $request){
   	 return Billing::select('consultancy_fees')->where('doctor_id', $doctor_id)->where('id', $billing_id)->get();
   }
}
