<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| This file is where you may define all of the routes that are handled
| by your module. Just tell Laravel the URIs it should respond
| to using a Closure or controller method. Build something great!
|
*/
global $app;

/*These below routes are working for Charges master related */
$app->get('/billing/clinicpatients', ['middleware'=>'cors', 'uses' =>'BillingController@getClinicPatients']);
$app->get('/billing/medicinepatient', ['middleware'=>'cors', 'uses' => 'BillingController@getMedicineQueuePatients']);
$app->get('/billing/prescribe/{id}', ['middleware'=>'cors', 'uses' => 'BillingController@getPrescribe']);
$app->get('/billing/prescribemedicinesearch', ['middleware'=>'cors', 'uses' => 'BillingController@getPrescribeMedicineSearch']);
$app->post('/billing/mixmedicine', ['middleware'=>'cors', 'uses' => 'BillingController@getMixMedicine']);
$app->post('/billing/templatemedicine', ['middleware'=>'cors', 'uses' => 'BillingController@getTemplateMedicine']);
$app->post('/billing/formlist', ['middleware'=>'cors', 'uses' => 'BillingController@getFormListDropdown']);
$app->post('/billing/prescribe', ['middleware'=>'cors', 'uses' => 'BillingController@createPrescribe']);

/*These below routes are working for Charges master related */
$app->get('/billing/charges', ['middleware'=>'cors', 'uses' =>'ChargeController@getCharges']);
$app->get('/billing/charge/{id}', ['middleware'=>'cors', 'uses' => 'ChargeController@getCharges']);
$app->post('/billing/charge/{id}', ['middleware'=>'cors', 'uses' => 'ChargeController@deleteCharge']);
$app->post('/billing/charge', ['middleware'=>'cors', 'uses' => 'ChargeController@addCharge']);
/*This below route is used for getting charges related to doctor */
$app->get('/billing/drcharges', ['middleware'=>'cors', 'uses' => 'ChargeController@getDrCharge']);
$app->get('/billing/drprintchargescode', ['middleware'=>'cors', 'uses' => 'ChargeController@getDrPrintCode']);

/*This below route is used for getting all the discounted percentage with charges */
$app->get('/billing/discounts/{id}', ['middleware'=>'cors', 'uses' => 'DiscountController@getDiscounts']);
$app->get('/billing/discount_catgories', ['middleware'=>'cors', 'uses' => 'DiscountController@getDiscountCategories']);

$app->post('/billing/prescribemedicineedit/{id}', ['middleware'=>'cors', 'uses' => 'BillingController@createPrescribe']);
$app->get('/billing/prescribedetail/{appointment_id}/{billing_id}', ['middleware'=>'cors', 'uses' => 'BillingController@getPrescribeMedicineDetails']);
/*These below routes are working for On the fly discount apply related */
$app->post('/billing/discountonthefly', ['middleware'=>'cors', 'uses' => 'BillingController@disCountOnTheFly']);
/*These below routes are working for patient previous pending details related */
$app->get('/billing/pending/{patient_id}', ['middleware'=>'cors', 'uses' => 'BillingController@getPatientPreviousPendingAmount']);
/*These below routes are working for On consultancy waive related */
$app->post('/billing/consultancywaive', ['middleware'=>'cors', 'uses' => 'BillingController@consultancyWaive']);
/*These below routes are working for On pending waive related */
$app->post('/billing/pendingdetails', ['middleware'=>'cors', 'uses' => 'BillingController@pendingDetails']);
/*These below routes are working for On patient payment related */
$app->post('/billing/payment', ['middleware'=>'cors', 'uses' => 'BillingController@patientPayment']);

/*These below routes are working for On patient History related */
$app->get('/billing/history/{patient_id}', ['middleware'=>'cors', 'uses' => 'BillingController@patientHistory']);

/*These below routes are working for edit prescibe medicine related */
$app->get('/billing/importhistory/{appointment_id}/{billing_id}', ['middleware'=>'cors', 'uses' => 'BillingController@getPrescribeMedicine']);

/*These below routes are working for On import patient History related */
$app->post('/billing/importhistory', ['middleware'=>'cors', 'uses' => 'BillingController@importPatientHistory']);

/*This below route is used for getting the pharmacy instruction for perticular billing id  */
$app->get('/billing/pharmacy_ins/{id}', ['middleware'=>'cors', 'uses' => 'BillingController@pharmacyinstruction']);


/*This below API is used for getting the all changes related to particular visit*/
$app->get('/billing/visitcharges/{appointment_id}/{billing_id}', ['middleware'=>'cors', 'uses' => 'BillingController@getVisitCharges']);

//This below function is used for getting the total paid amount of visit, Rahul Khan 16 July 2019
$app->get('/billing/visitreceivedamount/{appointment_id}/{billing_id}', ['middleware'=>'cors', 'uses' => 'BillingController@getVisitReceivedAmount']);

/*This below route is used for getting the Payment mode*/
$app->get('/billing/paymentmode', ['middleware'=>'cors', 'uses' => 'PaymentModeController@getRecord']);

/*This below route is used for getting the visit discount applied*/
$app->get('/billing/visitdiscount/{appointment_id}/{billing_id}', ['middleware'=>'cors', 'uses' => 'BillingController@getVisitDiscount']);

/*These below routes are working for On the fly discount remove related */
$app->post('/billing/discoutremove', ['middleware'=>'cors', 'uses' => 'BillingController@discoutremove']);

/*These below routes are working for consultancy remove related */
$app->post('/billing/consultanyremove', ['middleware'=>'cors', 'uses' => 'BillingController@consultanyremove']);

/*These below routes are working for patient previous visit pending details related */
$app->get('/billing/visitpending/{patient_id}/{visit_id}', ['middleware'=>'cors', 'uses' => 'BillingController@getPatientVisitPreviousPendingAmount']);

/*These below routes are working for patient after visit pending details related */
$app->get('/billing/visitafterpending/{appointment_id}/{billing_id}', ['middleware'=>'cors', 'uses' => 'BillingController@getPatientVisitAfterPendingAmount']);

/*These below routes are working for On pending visit details related */
$app->post('/billing/pendingvisitdetails', ['middleware'=>'cors', 'uses' => 'BillingController@pendingVisitDetails']);

/*These below routes are working for patient previous visit pending comment related */
$app->get('/billing/visitpendingcomment/{patient_id}/{visit_id}', ['middleware'=>'cors', 'uses' => 'BillingController@getPatientVisitComment']);

//This below route is used for getting the appointment shift
$app->get('/billing/shift_discount/{appointment_id}', ['middleware'=>'cors', 'uses' => 'BillingController@getAppoinmentShift']);

//This below route is used for getting the Patient Address Details
$app->get('/billing/patientdetails', ['middleware'=>'cors', 'uses' =>'BillingController@getPatientDetails']);

//This below route is used for getting the patient pharmacy instruction 
$app->get('/billing/getPharmacyHistory/{patient_id}/{visit_id}', ['middleware'=>'cors', 'uses' =>'BillingController@getPharmacyHistory']);
$app->get('/billing/getpatientdublicatedata', ['middleware'=>'cors', 'uses' =>'BillingController@getPatientDublicateData']);

//This below function is used for getting payment mode against billing id of each visit, Shubh Tiwari 31 Dec 2019
$app->get('/billing/visitpaymentmode/{appointment_id}/{billing_id}', ['middleware'=>'cors', 'uses' => 'BillingController@getVisitEachPaymentModeAmount']);

//This below function is used for getting all transaction details using billing id, Shubh Tiwari 02 jan 2020
$app->post('/billing/transationdetails', ['middleware'=>'cors', 'uses' => 'BillingController@getTransactionDetailByBillingId']);
//This below route is used for getting the visit billing list 
$app->get('/billing/getVisitBillingList/{appointment_id}/{billing_id}', ['middleware'=>'cors', 'uses' =>'BillingController@getVisitBillingList']);

/*These below routes are working for patient previous bill amount related */
$app->get('/billing/previousbillamt/{appointment_id}', ['middleware'=>'cors', 'uses' => 'BillingController@getPatientPreviousBillAmount']);

/*These below routes are working for patient previous bill amount related */
$app->get('/billing/visitstatus/{appointment_id}/{billing_id}', ['middleware'=>'cors', 'uses' => 'BillingController@getVisitBillStatus']);

/*These below routes are working for patient previous bill consultancy amount related */
$app->get('/billing/previousbillconsamt/{appointment_id}/{billing_id}', ['middleware'=>'cors', 'uses' => 'BillingController@getPatientPreviousBillConsultancyAmount']);

/*These below routes are working for patient previous bill Other charge amount related */
$app->get('/billing/previousbillothercharge/{appointment_id}/{billing_id}', ['middleware'=>'cors', 'uses' => 'BillingController@getPatientPreviousBillOtherChargeAmount']);

/*This below route is used for getting the visit previous discount applied*/
$app->get('/billing/visitpreviousdiscount/{appointment_id}/{billing_id}', ['middleware'=>'cors', 'uses' => 'BillingController@getVisitPreviousDiscount']);

/*These below routes are working for previous patient History on medicine edit page*/
$app->get('/billing/previoushistory/{appointment_id}/{patient_id}/{importvisitid}', ['middleware'=>'cors', 'uses' => 'BillingController@previousPatientHistory']);
$app->get('/billing/exportcompleted',['middleware'=>'cors', 'uses' => 'BillingController@completeexportHistory']);
//This below function is used for getting all transaction details using billing id, Shubh Tiwari 03 nov 2020
$app->post('/billing/totaltransationdetails', ['middleware'=>'cors', 'uses' => 'BillingController@getTransactionDetailByVisitId']);

