<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class AppointmentVitalStatistics extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
         Schema::create('appointment_vital_statistics',function(Blueprint $table)
        {
            $table->increments('id');
            $table->char('patient_id', 36);
            $table->integer('appointment_id')->unsigned();
            $table->string('height_unit', 4)->nullable();
            $table->float('height_inches')->nullable();
            $table->string('body_temp_unit', 3)->nullable();
            $table->float('body_temp_celsius')->nullable();
            $table->integer('pulse_bpm')->nullable();
            $table->string('blood_type', 3)->nullable();
            $table->string('weight_unit', 5)->nullable();
            $table->float('weight_kgs')->nullable();
            $table->float('bmi')->nullable();
            $table->integer('blood_pressure_systolic')->nullable();
            $table->integer('blood_pressure_diastolic')->nullable();
			$table->integer('created_by');
			$table->timestamp('created_at');
			$table->timestamp('modified_at');
			$table->integer('modified_by');
        });
    }
    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::drop('appointment_vital_statistics');
    }
}
