<?php
namespace App\Modules\Icpattend\Http\Controllers;
use Illuminate\Http\Request;
use App\Http\Requests;
use App\Modules\Icpattend\Models\Icp;
use App\Http\Controllers\Controller;
use Carbon\Carbon;
use GuzzleHttp\Client;
//This imported library is required for Using database directly in lumen
use Illuminate\Support\Facades\DB;

class IcpController extends Controller
{
    public function addVitalStatistics(Request $request){
	    	parse_str($request->formdata, $formdata);//This will convert the string to array
	    	//dd($formdata);
	    	//This condition is used to check the appointment_id exist in requesting parameter or not, Shubhnarayan Tiwari, 02 May 2021
			if(array_key_exists("appointment_id",$formdata) ){
				$appointment_id = $formdata['appointment_id'];
			}
			if(array_key_exists("patient_id",$formdata) ){
				$patient_id = $formdata['patient_id'];
			}
		/*This condition is used for converting height unit into inches */	
			 	if($formdata['height_unit'] =='feet') {

				 		if($formdata['height_unit'] =='feet' && !empty($formdata['height_inches']) && !empty($formdata['height_inches1'])){
				 			// convert feet to inches
				 			$feet_and_inches = $formdata['height_inches'].'.'.$formdata['height_inches1'];
				 			$inches = $feet_and_inches * 12;
				            $inches_value = number_format((float)$inches, 2, '.', '');

				 		}else if($formdata['height_unit'] =='feet' && !empty($formdata['height_inches'])){

				 			$inches = $formdata['height_inches'] * 12;
				            $inches_value = number_format((float)$inches, 2, '.', '');

				 		}else{

				 			$inches_value = null;
				 		}
			     }elseif ($formdata['height_unit'] =='inch') {
		     			if($formdata['height_unit'] =='inch' && !empty($formdata['height_inches'])){
				 			$inches = $formdata['height_inches'];
		         			$inches_value = number_format((float)$inches, 2, '.', '');
				 		}else{
				 			$inches_value = null;
				 		}
			     }elseif ($formdata['height_unit'] =='cm') {
				     	if($formdata['height_unit'] =='cm' && !empty($formdata['height_inches'])){
					 			$inches = isset($formdata['height_inches']) / 2.54;
			         			$inches_value =  number_format((float)$inches, 2, '.', '');
					 	}else{
					 			$inches_value = null;
					 	 }
			     	 
			     }elseif ($formdata['height_unit'] =='m') {
			     	if($formdata['height_unit'] =='m' && !empty($formdata['height_inches'])){
					 			$inches = $formdata['height_inches'] * 39.37;
			         			$inches_value = number_format((float)$inches, 2, '.', '');
					 	}else{
					 			$inches_value = null;
					 	}
			       }
		/*This condition is used for converting Fahrenheit into Celsius */
			if($formdata['body_temp_unit']=='°F') {
			      if($formdata['body_temp_unit'] =='°F' && !empty($formdata['body_temp_celsius'])){
				 			$body_temp_celsius =(intval($formdata['body_temp_celsius'])-32)*5/9;
			                $body_temp_celsius_value = number_format((float)$body_temp_celsius, 2, '.', '');
				 	}else{
				 			$body_temp_celsius_value = null;
				 	}
			         
			  }elseif ($formdata['body_temp_unit']=='°C') {
			  	 if($formdata['body_temp_unit'] =='°C' && !empty($formdata['body_temp_celsius'])){
				 			$body_temp_celsius_value = intval($formdata['body_temp_celsius']);
				 	}else{
				 			$body_temp_celsius_value = null;
				 	}
			  }
		/*This condition is used for converting Pound into Kilometer */
			if($formdata['weight_unit']=='kg') {
			      if($formdata['weight_unit'] =='kg' && !empty($formdata['weight_kgs'])){
			      			$weight_kgs_value = intval($formdata['weight_kgs']);
				 	}else{
				 			$weight_kgs_value = null;
				 	}
			         
			  }elseif ($formdata['weight_unit']=='pound') {
			  	 if($formdata['weight_unit'] =='pound' && !empty($formdata['weight_kgs'])){
			  	 			$weight_kgs =intval($formdata['weight_kgs'])/2.205;
			                $weight_kgs_value = number_format((float)$weight_kgs, 2, '.', '');
				 	}else{
				 			$weight_kgs_value = null;
				 	}
			  }

			  $pulse_bpm = $formdata['pulse_bpm'];
			  $blood_type = $formdata['blood_type'];
			  $bmi = $formdata['bmi'];
			  $blood_pressure_systolic = $formdata['blood_pressure_systolic'];
			  $blood_pressure_diastolic = $formdata['blood_pressure_diastolic'];

			  $dt =  Carbon::now();
			  $currentDate = $dt->toDateTimeString();
			try{
				$Icp = new Icp();
				$Icp->appointment_id = $appointment_id;
				$Icp->patient_id = $patient_id;
				$Icp->height_unit = $formdata['height_unit'];
				$Icp->height_inches = $inches_value;
				$Icp->body_temp_unit = $formdata['body_temp_unit'];
				$Icp->body_temp_celsius = $body_temp_celsius_value;
				$Icp->pulse_bpm = $pulse_bpm;
				$Icp->blood_type = $blood_type;
				$Icp->weight_unit = $formdata['weight_unit'];
				$Icp->weight_kgs = $weight_kgs_value;
				$Icp->bmi = $bmi;
				$Icp->blood_pressure_systolic = $blood_pressure_systolic;
				$Icp->blood_pressure_diastolic = $blood_pressure_diastolic;
				$Icp->created_by = $request->user_id;
				$Icp->created_at = $currentDate;
				//updating the vital statistic data to database
        		if($formdata['vital_id'] > 0){
            	 try{
		                $item = $Icp->findOrFail($formdata['vital_id']);
			                if($item){
			                    $modification_date =  Carbon::now('Asia/Kolkata');
			                    $Icp->where('id', $formdata['vital_id'])->update(['appointment_id'=>$Icp->appointment_id,'patient_id'=>$Icp->patient_id, 'height_unit'=>$Icp->height_unit,'height_inches'=>$Icp->height_inches,'body_temp_unit'=>$Icp->body_temp_unit,'body_temp_celsius'=>$Icp->body_temp_celsius,'pulse_bpm'=>$Icp->pulse_bpm,'blood_type'=>$Icp->blood_type,'weight_unit'=>$Icp->weight_unit,'weight_kgs'=>$Icp->weight_kgs,'bmi'=>$Icp->bmi,'blood_pressure_systolic'=>$Icp->blood_pressure_systolic,'blood_pressure_diastolic'=>$Icp->blood_pressure_diastolic,'modified_by'=>$request->user_id, 'modified_at'=>$modification_date]);
								$res['error'] = false;
			                    $res['actions'] = 'update';
			                    $res['patient_id'] = $Icp->patient_id;
			                    $res['appointment_id'] = $Icp->appointment_id;
			                    $res['message'] = 'Vital statistic data has been updated successfully';
			                    return response($res, 200);
		            		}
		              }catch(\Illuminate\Database\QueryException $ex){
		                    $res['status'] = false;
		                    $res['message'] = $ex->getMessage();
		                    return response($res, 500);
		              }
	            	}else{
		           		//saving vital statistic data to database
			            $Icp->save();
			            $res['error'] = false;
			            $res['actions'] = 'add';
			            $res['patient_id'] = $Icp->patient_id;
			            $res['appointment_id'] = $Icp->appointment_id;
			            $res['message'] = 'Vital statistic data has been added successfully';
						return response($res, 200);
	         	  	}

				}catch (\Illuminate\Database\QueryException $ex) {
		            $res['status'] = false;
		            $res['message'] = $ex->getMessage();
					return response($res, 500);
		        }
    }
    public function getVitalList($id='', $patient_id='', Request $request){
    	try{

	    	 if(isset($patient_id)){
	    		$vital_list =  Icp::where('patient_id', $patient_id)->orderBy('appointment_id', 'asc')->take(5)->get();

	    		$last_visit =  Icp::select('id','appointment_id', 'patient_id', 'created_by', 'modified_by', DB::raw("(SELECT label FROM cl_users WHERE user_id = cl_appointment_vital_statistics.created_by) as username"),'blood_type')->where('appointment_id', $id)->orderBy('id', 'desc')->first();
				$res['error'] = false;
				$res['data'] =$vital_list;
				$res['visit_data'] =$last_visit;
				return response($res, 200);
	         }else{
				$res['error'] = false;
				$res['data'] =null;
				return response($res, 200);
			}
         }catch(\Illuminate\Database\QueryException $ex){
			$res['status'] = false;
			$res['message'] = $ex->getMessage();
			return response($res, 500);
		}
    }

    public function getPatientInfo($id='', Request $request){
	    $Core_Api_root = env('CORE_API_ROOT', true);
		try{
				$client = new Client();
				$res = $client->request('GET', $Core_Api_root.'appointments/patientinfo', [
					'query' => ['id' => $id]
				]);

				if ($res->getStatusCode() == 200){ 
				    // 200 OK
					$response_data = $res->getBody()->getContents();
				}
				return $response_data;
		}catch(\Illuminate\Database\QueryException $ex){
						$res['status'] = false;
						$res['message'] = $ex->getMessage();
						return response($res, 500);
		};


	}
}
