<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class Instructions extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('instructions', function (Blueprint $table) {
            $table->increments('id');
            $table->text('instruction_name');
            $table->integer('created_by');
            $table->timestamp('creation_date_on')->useCurrent();
            $table->integer('modified_by');
            $table->timestamp('modification_date')->default('0000-00-00 00:00:00')->useCurrent();
            $table->enum('status', ['0', '1', '2','3'])->default(1);
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('instructions');
    }
}
