<?php
namespace App\Modules\Medicine\Http\Controllers;
use Illuminate\Http\Request;
use App\Http\Requests;
use App\Http\Controllers\Controller;
use Illuminate\Validation\ValidationException;
use Illuminate\Support\Facades\Validator;
use App\Modules\Medicine\Models\Medicine;
use App\Modules\Medicine\Models\MedicineGroupPotency;
use App\Modules\Medicine\Models\MedicineGroupPotencyForm;
use App\Modules\Medicine\Models\Medicinegroup;
use App\Modules\Medicine\Models\pricegroup;
use App\Modules\Medicine\Models\potency; //import potency model 
use App\Modules\Medicine\Models\potencygroup; //import potencygroup model 
use App\Modules\Medicine\Models\pricegrouprate;
use Carbon\Carbon;
use Illuminate\Support\Facades\DB;
class MedicineSingleController extends Controller
{
    public function create($id='',Request $request){

				$validator = Validator::make($request->all(), [
					'name' => 'required',
					//'pricegroup' => 'required',
					'status' => 'required'
				]);
				//if validation fails
				if ($validator->fails()) {
					return array(
						'error' => true,
						'message' => $validator->errors()
					);
				}
	try{
		$medicine = new Medicine();
		$medicine->name = $request->name;
		$medicine->status = $request->status;
		
		//this below conditional block is used for update records in database 
		$modification_date =  Carbon::now();
		   if(!empty($request->id) && !empty($request->potencygroup) && count($request->potencygroup)>0){
					try{
						return $medicineExists = medicine::where('name', '=', $request->name)->first();
						if($medicineExists === null){
									Medicinegroup::where('medicine_id', $request->id)->delete();
									MedicineGroupPotency::where('medicine_id', $request->id)->delete();
									MedicineGroupPotencyForm::where('medicine_id', $request->id)->delete();
									foreach($request->potencygroup as $key=>$array_list){
										if((!empty($request->potencygroup[$key]['group_id'])) && (count($request->potencygroup[$key]['group_id']) > 0) && (!empty($request->potencygroup[$key]['potencydata'])) && ( count($request->potencygroup[$key]['potencydata']) > 0 )) {
												//for medicinegroup table data insert 
													$group_data = $request->potencygroup[$key]['group_id']['group_value'];
													if(!empty($request->id) && !empty($group_data)){
														$medicine_group= Medicinegroup::create(['group_id' => $group_data, 'medicine_id'=>$request->id]);
														$medicinegroup_id = $medicine_group->id;
																//for medicinegrouppotency table data insert 
																foreach($request->potencygroup[$key]['potencydata'] as $pkey=>$potency){
																	$potency_data = $request->potencygroup[$key]['potencydata'][$pkey]['potency'];
																	$form_data = $request->potencygroup[$key]['potencydata'][$pkey]['form'];
																
																	if(!empty($medicinegroup_id) && !empty($potency_data) && !empty($form_data) && !empty($form_data)){

																		$medicine_potency = MedicineGroupPotency::create(['potency_id' => $potency_data, 'medicine_id'=>$request->id, 'medicinegroup_id'=>$medicinegroup_id]);
																		// last inserted id of medicinegrouppotency table row
																			$medicinegrouppotency_id = $medicine_potency->id;	
																			
																					//for medicinegrouppotencyform table data insert 
																			foreach($request->potencygroup[$key]['potencydata'][$pkey]['form'] as $afkey=>$form_data_array){
																					if(!empty($medicinegrouppotency_id) && !empty($form_data_array)){
																							$form_id = $form_data_array['form'];
																							$form_gid = $form_data_array['gid'];
																							$form_fcode = $form_data_array['fcode'];
																							MedicineGroupPotencyForm::create(['form_id' => $form_id, 'group_id'=>$form_gid, 'form_code'=>$form_fcode, 'medicine_id'=>$request->id, 'medicinegrouppotency_id'=>$medicinegrouppotency_id]);
																					}
																			}
																	}
																}
													}
										}
										// else{
										// 	$res['error'] = 'nopotencyingroup';
										//   return response($res, 200);
										// }

								}
							//for Update Medicine data
							$item = $medicine->findOrFail($request->id);
							if($item){
								$medicine->where('id', $request->id)->update(['name'=>$medicine->name, 'status'=>$medicine->status, 'modification_date'=>$modification_date]);
								$res['error'] = false;
								$res['actions'] = 'update';
								return response($res, 200);
							}
						   }else{
								$res['error'] = 'samemedicine';
								return response($res, 200);
							  }
							
						}catch(\Illuminate\Database\QueryException $ex){
							$res['status'] = false;
							$res['message'] = $ex->getMessage();
							return response($res, 500);
						} 	
					}else{
						$medicineExists = medicine::where('name', '=', $request->name)->first();
						if($medicineExists === null){
							if(!empty($request->potencygroup) && count($request->potencygroup)>0)
								{
									foreach($request->potencygroup as $key=>$array_list){
										$medicine->save();
										// last inserted id of medicine table row
										$medicine_id =  $medicine->id;
										$group_data = $request->potencygroup[$key]['group_id']['group_value'];
										//return $request->potencygroup[$key]['potencydata'];
									//	$potencydatacount =  count($request->potencygroup[$key]['potencydata']);
										//Removed this statement from below if condition "!empty($request->potencygroup[$key]['potencydata'])" 
										if((!empty($medicine_id)) && (!empty($group_data)) && (!empty($request->potencygroup[$key]['potencydata'])) && (count($request->potencygroup[$key]['potencydata']) > 0)){
											//if(!empty($medicine_id) && !empty($group_data)){
												//for medicinegroup table data insert 
														$medicine_group= Medicinegroup::create(['group_id' => $group_data, 'medicine_id'=>$medicine_id]);
														$medicinegroup_id = $medicine_group->id;
																//for medicinegrouppotency table data insert 
																foreach($request->potencygroup[$key]['potencydata'] as $pkey=>$potency){
																	$potency_data = $request->potencygroup[$key]['potencydata'][$pkey]['potency'];
																	$form_data = $request->potencygroup[$key]['potencydata'][$pkey]['form'];
																
																	if(!empty($medicinegroup_id) && !empty($potency_data) && !empty($form_data)){

																		$medicine_potency = MedicineGroupPotency::create(['potency_id' => $potency_data, 'medicine_id'=>$medicine_id, 'medicinegroup_id'=>$medicinegroup_id]);
																		// last inserted id of medicinegrouppotency table row
																			$medicinegrouppotency_id = $medicine_potency->id;	
																			
																					//for medicinegrouppotencyform table data insert 
																			foreach($request->potencygroup[$key]['potencydata'][$pkey]['form'] as $afkey=>$form_data_array){
																					if(!empty($medicinegrouppotency_id) && !empty($form_data_array)){
																							$form_id = $form_data_array['form'];
																							$form_gid = $form_data_array['gid'];
																							$form_fcode = $form_data_array['fcode'];
																							MedicineGroupPotencyForm::create(['form_id' => $form_id, 'group_id'=>$form_gid, 'form_code'=>$form_fcode, 'medicine_id'=>$medicine_id, 'medicinegrouppotency_id'=>$medicinegrouppotency_id]);
																					}
																			}

																	}
																}
													}else{
													$res['error'] = 'nopotencyingroup';
													return response($res, 200);
										     }
											}
										$res['error'] = false;
										$res['actions'] = 'add';
										return response($res, 200);
									}else{
											$res['error'] = 'nogrouppotency';
											return response($res, 200);
									}
								}else{
										$res['error'] = 'samemedicine';
										return response($res, 200);
								}
					}
			
			}catch(\Illuminate\Database\QueryException $ex){
				$res['status'] = false;
				$res['message'] = $ex->getMessage();
				return response($res, 500);
			} 	
	}
    public function getRecords($id='',Request $request){
        /*This below condition is used for distinguish edit form request, In this case we get details of perticular medicine */
        if($id > 0){
			
					return Medicine::find($id);
        }
        /*This below condition is used for distinguish search form request, */
        if($request->has('search')){
            return Medicine::where('name', 'LIKE', '%' . $request->search . '%')->where('status','!=', '0')->paginate(10);
        }
        /*This below condition is used for distinguish getting all data list form request, */
        if($request->has('datalist')){
            return Medicine::where('status','!=', '0')->get();
        }
        return Medicine::where('status','!=', '0')->get();
		}
		  //  Delete Record for particular medicine id
		public function deleteRecords(Request $request)
			{
					$Medicine = Medicine::findOrFail($request->medicine_id);
					try{
							if($Medicine){
 
											$Medicine->where('id', $request->medicine_id)->update(['status'=>'0']);
											$res['error'] = false;
											return response($res, 200);
							}else{
											$res['error'] = true;
											return response($res, 401);
							}
					}catch(\Illuminate\Database\QueryException $ex){
							$res['status'] = false;
							$res['message'] = $ex->getMessage();
							return response($res, 500);
					}
			}
// get potency by price group id 
  public function getPotencyAndFormByPriceGroup(Request $request){

		$main_array = array();
		//$pricegroup_array = array();
		//$ptency_array = array();
		//$potency_array = array();
    if(!empty($request->pricegroup) && count($request->pricegroup) > 0){

		$pricegroup_name_list = pricegroup::select('id','name')->where('status', '1')->whereIn('id', $request->pricegroup)->distinct()->get();

        if(!empty($pricegroup_name_list) && count($pricegroup_name_list)>0){

        	foreach($pricegroup_name_list as $price_list){

					//$pricegroup_array['price_group'] = $price_list;
					
				 //$form_name_list = pricegrouprate::select('form_name','id')->where('status', '1')->where('pricegroup_id', $price_list->id)->distinct()->get();


				 $form_name_list = DB::table('pricegrouprates')->select('forms.id','forms.name','forms.form_code')
				 ->join('forms', 'forms.form_code', '=', 'pricegrouprates.form_code')
				 ->where('forms.status', '1')->where('pricegrouprates.pricegroup_id', '=', $price_list->id)->distinct()
				 ->get();

					//$pricegroup_array['form'] = $form_name_list;

									$pricegroup_list = potencygroup::select('potency_id')->where('status', '1')->where('pricegroup_id', $price_list->id)->distinct()->get();
									
                 foreach($pricegroup_list as $pp){

										$ptency_name_list = potency::select('name', 'id','dilution')->where('status', '1')->where('id', $pp->potency_id)->distinct()->get();

										//array_push($ptency_array, $ptency_name_list);
										$potency_array['potency'][] = $ptency_name_list;
				}
				$potency_array['form'][] = $form_name_list;
        $pricegroup_array = array("group_name"=>$price_list->name,
				"group_id"=>$price_list->id,$potency_array);
					$potency_array = array();
				  array_push($main_array, $pricegroup_array);

				}	
			}
		
		
    }
  return $main_array;
}

// extract group id for particular medicine id 
public function getPriceGroupByMedicineId($id){
		  $group_array = array();
	    $medicine_group_list = Medicine::find($id)->getMedicineMultipleGroup;
			foreach($medicine_group_list as $group){
				array_push($group_array, $group->group_id);
			}
			return $group_array;
	}

	// get selected potency and form by price group id 
public function getSelectedPotencyForm(Request $request){
		$main_array = array();
		$pricegroup_array = array();
		
    if(!empty($request->pricegroup) && count($request->pricegroup) > 0 && $request->medicine_id){
		$pricegroup_list = Medicinegroup::select('id','group_id')->where('medicine_id', $request->medicine_id)->whereIn('group_id', $request->pricegroup)->get();
        if(!empty($pricegroup_list) && count($pricegroup_list)>0){
        	foreach($pricegroup_list as $group){
					$pricegroup_array['group'] = $group;
					$potency_list = MedicineGroupPotency::select('potency_id','id')->where('medicinegroup_id', $group->id)->get();
					
						foreach ($potency_list as $key => $value) {
							//$medicin_group_potency_id = $pricegroup_array['potency'][$key]['id'];
							$medicin_group_potency_id = $potency_list[$key]['id'];
							$form_list = MedicineGroupPotencyForm::select('form_id')->where('medicinegrouppotency_id', $medicin_group_potency_id)->distinct()->get();
							//$pricegroup_array['form'] = $form_list;
							//In this below line we have added the forms data in potency date set
							$potency_list[$key]['form'] = $form_list;
						}
						$pricegroup_array['group']['potency'] = $potency_list;
				    array_push($main_array, $pricegroup_array);
			}	
		}
	}
	return $main_array;
}


	// get selected potency and form by price group id 
	public function getSelectedPotencyFormPost(Request $request){
		$main_array = array();
		$pricegroup_array = array();
		
    if(!empty($request->pricegroup) && count($request->pricegroup) > 0 && $request->medicine_id){
		$pricegroup_list = Medicinegroup::select('id','group_id')->where('medicine_id', $request->medicine_id)->whereIn('group_id', $request->pricegroup)->get();
        if(!empty($pricegroup_list) && count($pricegroup_list)>0){
        	foreach($pricegroup_list as $group){
					$pricegroup_array['group'] = $group;
					$potency_list = MedicineGroupPotency::select('potency_id','id')->where('medicinegroup_id', $group->id)->get();
					
						foreach ($potency_list as $key => $value) {
							//$medicin_group_potency_id = $pricegroup_array['potency'][$key]['id'];
							$medicin_group_potency_id = $potency_list[$key]['id'];
							$form_list = MedicineGroupPotencyForm::select('form_id')->where('medicinegrouppotency_id', $medicin_group_potency_id)->distinct()->get();
							//$pricegroup_array['form'] = $form_list;
							//In this below line we have added the forms data in potency date set
							$potency_list[$key]['form'] = $form_list;
						}
						$pricegroup_array['group']['potency'] = $potency_list;
				    array_push($main_array, $pricegroup_array);
			}	
		}
	}
	return $main_array;
}

	public function singlemedicinedetails(Request $request){
							$main_array = array();
							$medicine_array = array();
						if(!empty($request->medicine_id)){
							$pricegroup_list = DB::table('medicines as m')->select('p.name as potencyname','p.dilution as dName', 'pg.name as pricegroup_name', 'mg.group_id as gid','m.name as medicineName', 'm.id as medicineId','mgp.id as mgpid')
								->join('medicinegroups as mg', 'mg.medicine_id', '=', 'm.id')
								->join('pricegroups as pg', 'pg.id', '=', 'mg.group_id')
								->join('medicinegrouppotencies as mgp', 'mgp.medicinegroup_id', '=', 'mg.id')
								->join('potencies as p', 'p.id', '=', 'mgp.potency_id')
								->where('m.id', '=', $request->medicine_id)
								->where('pg.status', '=', '1')
								->where('m.status', '=', '1')
								->where('mgp.status', '=', '1')
								//->orWhere('m.status', '=', '2')
								->where('p.status', '=', '1')
								->where('mg.medicine_id', '=', $request->medicine_id)
								->get();


								// $pricegroup_list = DB::table('medicines as m')->select('p.name as potencyname','p.dilution as dName', 'pg.name as pricegroup_name','m.name as medicineName', 'm.id as medicineId','mgp.id as mgpid','mgp.medicinegroup_id as pricegroupId')
								// ->LeftJoin('medicinegrouppotencies as mgp', 'mgp.medicine_id', '=', 'm.id')
								// ->LeftJoin('potencies as p', 'p.id', '=', 'mgp.potency_id')
								// ->LeftJoin('pricegroups as pg', 'pg.id', '=', 'mgp.medicinegroup_id')
								// ->where('m.id', '=', $request->medicine_id)
								// ->where('pg.status', '=', '1')
								// ->where('m.status', '=', '1')
								// ->where('p.status', '=', '1')
								// ->get();
								// foreach($pricegroup_list as $key=>$plist){
								// 	$mix_medicine_form_list = DB::table('medicinegrouppotencies as mgp')->select('pg.form_name as fname','pg.form_code as fcode','pg.rate as frate')
								// 	->LeftJoin('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
								// 	->LeftJoin('pricegrouprates as pg', 'pg.form_code', '=', 'mgpf.form_code')
								// 	->where('pg.status', '=', '1')
								// 	->where('mgpf.status', '=', '1')
								// 	->where('mgp.medicine_id', '=', $plist->medicineId)
								// 	->where('pg.pricegroup_id', '=', $plist->pricegroupId)
								// 	/->where('mgpf.medicinegrouppotency_id', '=', $plist->mgpid)
								// ->get();
								// $main_array['medicine']= $pricegroup_list[$key];
								// $pricegroup_list[$key]= $mix_medicine_form_list;
								// array_push($medicine_array,  $main_array);
								// }
								return response()->json($pricegroup_list);
				}
				
		}

}
