<?php
namespace App\Modules\Medicine\Http\Controllers;
use Illuminate\Http\Request;
use App\Http\Requests;
use App\Http\Controllers\Controller;
use Illuminate\Validation\ValidationException;
use Illuminate\Support\Facades\Validator;
use App\Modules\Medicine\Models\form; 
use App\Modules\Medicine\Models\pricegroup; //import pricegroup model 
use App\Modules\Medicine\Models\pricegrouprate; //import pricegroup model 
use Carbon\Carbon;
use Illuminate\Support\Facades\DB;



class PricegroupController extends Controller
{
   public function create($id='',Request $request){
		$validator = Validator::make($request->all(), [
			'name' => 'required',
			'ounce' => 'numeric|nullable|regex:/^\d+(\.\d{1,2})?$/',
			'globule' => 'numeric|nullable|regex:/^\d+(\.\d{1,2})?$/',
			'powder' => 'numeric|nullable|regex:/^\d+(\.\d{1,2})?$/',
			'liquid' => 'numeric|nullable|regex:/^\d+(\.\d{1,2})?$/',
		]);

		//if validation fails
		if ($validator->fails()) {
			return array(
				'error' => true,
				'message' => $validator->errors()
			);
		}
		
		$pricegroup = new pricegroup();
		$pricegrouprate = new pricegrouprate();
		$pricegroup->name = $request['name'];
		$pricegroup->description = $request['description'];
		$pricegroup->status = $request['status'];
		//$pricegrouprate->ounce = $request['ounce'];
		//$pricegrouprate->globule = $request['globule'];
		//$pricegrouprate->powder = $request['powder'];
		//$pricegrouprate->liquid = $request['liquid'];
		//return $request;
		//this below conditional block is used for update records in database 
		if((isset($request->id)) && ($request->id > 0)) {
			$id = $request->id;
		   // return $id;
			$item = $pricegroup->findOrFail($id)->where('status','!=',0);
			if($item){
				$modification_date =  Carbon::now('Asia/Kolkata');
				$pricegroup->where('id', $id)->update(['name'=>$pricegroup->name,'description'=>$pricegroup->description,'status'=> $pricegroup->status,'modification_date'=>$modification_date]);
				$pricegrouprate->where('pricegroup_id', $id)->delete();

				if($request->ounce > 0 ){
					$pricegrouprate->create(['form_code'=>'O', 'form_name'=>'Ounce', 'pricegroup_id'=>$id, 'rate'=>$request['ounce'] ]);
				}
				if($request->globule > 0 ){
					$pricegrouprate->create(['form_code'=>'G', 'form_name'=>'Globule', 'pricegroup_id'=>$id, 'rate'=>$request['globule'] ]);
				}
				if($request->powder > 0 ){
					$pricegrouprate->create(['form_code'=>'P', 'form_name'=>'Powder', 'pricegroup_id'=>$id, 'rate'=>$request['powder'] ]);
				}
				if($request->liquid > 0 ){
					$pricegrouprate->create(['form_code'=>'L', 'form_name'=>'Liquid', 'pricegroup_id'=>$id, 'rate'=> $request['liquid'] ]);
				}
				return array('error' => false, 'pricegroup' => 'Price Group updated successfully');
			}
		}else{
			$pricegroup->save();
			$pricegroup_id =  $pricegroup->id;
			
			if($request->ounce > 0 ){
				$pricegrouprate->create(['form_code'=>'O', 'form_name'=>'Ounce', 'pricegroup_id'=>$pricegroup_id, 'rate'=>$request['ounce'] ]);
			}
			if($request->globule > 0 ){
				$pricegrouprate->create(['form_code'=>'G', 'form_name'=>'Globule', 'pricegroup_id'=>$pricegroup_id, 'rate'=>$request['globule'] ]);
			}
			if($request->powder > 0 ){
				$pricegrouprate->create(['form_code'=>'P', 'form_name'=>'Powder', 'pricegroup_id'=>$pricegroup_id, 'rate'=>$request['powder'] ]);
			}
			if($request->liquid > 0 ){
				$pricegrouprate->create(['form_code'=>'L', 'form_name'=>'Liquid', 'pricegroup_id'=>$pricegroup_id, 'rate'=> $request['liquid'] ]);
			}
			return array('error' => false, 'pricegroup' => 'Price Group added successfully');
		}
	}
    public function getRecords($id='',Request $request){
        //return $request->search;
        $pricegroup = new pricegroup();
        /*This below condition is used for distinguish edit form request, In this case we get details of perticular price group */
        if($id > 0){
			
			$priceRate =  $pricegroup->find($id)->getPriceRate;

			$formName = array();
			foreach($priceRate as $rate){
				//return $rate;
				$form_detail = form::where('form_code', $rate->form_code)->where('status','!=',0)->first();
				/*This Below line of code is added for  */
				//$priceGroup =  $pricegroup->find($id);
				//return $priceGroup;
				//return $form_detail;
				$formName[$rate->form_code] = $form_detail->name;
				$formName[$rate->form_code.'_'.'rate'] = $rate->rate;
				
				//$formName['status'] = $priceGroup->status;
				//$formName['name'] = $priceGroup->name;
				//$formName['description'] = $priceGroup->description;
				//$rate['form_name'] = $form_detail->name;
				 //$formName['form_name'] = $form_detail->name;
				//$formName['test'] = $form_detail['name'];
				//$priceRate[$form_detail->form_code] = $form_detail->name;
				//array_push($formName, array('form_name'=>$form_detail->name));
			}
				$priceGroup =  $pricegroup->find($id);
				$formName['status'] = $priceGroup->status;
				$formName['name'] = $priceGroup->name;
				$formName['description'] = $priceGroup->description;
		
			return $formName;
        }
        /*This below condition is used for distinguish search form request, */
        if($request->has('search')){
            return $pricegroup->where('name', 'LIKE', '%' . $request->search . '%')->where('status','!=',0)->paginate(10);
        }
        /*This below condition is used for distinguish getting all data list form request, */
        if($request->has('datalist')){
			//In this below we have changed the condition of status for fetching only active records,Rahul Khan, 24 July 2019
			return $pricegroup->where('status', '1')->get();
          //  return $pricegroup->where('status','!=',0)->get();
        }
        //   return array('error' => false, 'data' => 'Price Group Updated successfully');
        return $pricegroup->where('status','!=',0)->paginate(10);
    }

    public function deleteRecords($id=''){
        // return  $id;
      $pricegroup = new pricegroup();
      $pricegroup->where('id', $id)->update(['status'=>0]);
      return array('error' => false, 'pricegroup' => 'Price Group Deleted successfully');
      //;
  }
}
