<?php
namespace App\Modules\Medicinetemplate\Http\Controllers;
use Illuminate\Http\Request;
use App\Http\Requests;
use App\Http\Controllers\Controller;
use Illuminate\Validation\ValidationException;
use Illuminate\Support\Facades\Validator;
use App\Modules\Medicinetemplate\Models\Medicinetemplate;
use App\Modules\Medicinetemplate\Models\Medicinetemplatevariant;
use Carbon\Carbon;
use Illuminate\Support\Facades\DB;
use App\Traits\CommonFunction;
use Illuminate\Validation\Rule;
class MedicinetemplateController extends Controller
{   
    use CommonFunction;
    // This function is used to search single and mix medicine
    public function action(Request $request) 
    {
	   $query = $request->get('query');
		$queryArray = explode(" ",$query);
		$searchString = implode("%", $queryArray);
        if(!empty($query)){
                    $a = DB::table('medicines as m')->select(DB::raw("CAST(cl_p.name AS UNSIGNED) as numeric_potency"),'p.name as potencyname','m.name as medicineName','p.dilution as dilution','mgp.potency_id as potenId','mgp.medicine_id as medId', DB::raw("'single' as datatype"))
                    ->join('medicinegroups as mg', 'mg.medicine_id', '=', 'm.id')
                    ->join('medicinegrouppotencies as mgp', 'mgp.medicinegroup_id', '=', 'mg.id')
                    ->join('potencies as p', 'p.id', '=', 'mgp.potency_id')
                    ->where('m.status','=', '1')
                    ->where('p.status','=', '1')
					->where(DB::raw("CONCAT(cl_m.name,' ', cl_p.name, ' ', cl_p.dilution)"), 'LIKE', $searchString.'%')
					->orderBy('medicineName', 'ASC')
					->orderByRaw('numeric_potency', 'ASC')
					->orderBy('potencyname', 'ASC')
					->orderBy('dilution', 'ASC')
                    ->get();
					
                    $b = DB::table('medicinemix as mm')->select('mm.medicineMixName as medicineName','mmv.medicinemixtureName as potencyname','mmv.medicinemixId as medId','mmv.mixPotencyId as potenId', DB::raw("'mix' as datatype"))
                    ->join('medicinemixvariant as mmv', 'mmv.medicinemixId', '=', 'mm.id')
                    ->join('potencies as p', 'p.id', '=', 'mmv.mixPotencyId')
                    ->where('mm.status','=', '1')
                    ->where('p.status','=', '1')
                    ->where('mmv.status','=', '1')
					->where('mm.medicineMixName', 'LIKE', '%'.$searchString.'%')
					->orderBy('medicineName', 'ASC')
					->groupBy('mmv.medicinemixId')
					->get();
                    $medicinesearch_list = $a->merge($b);
                    $count = count($medicinesearch_list);
                    $output ='';
                    $singleDataTemplate = '';
					$mixDataTemplate = '';
                    $templateDataTemplate = '';
                    
                    $output.='<ul class="medicine-list">';
					$i =0;
                    if($count>0){
                        foreach ($medicinesearch_list as $data_list)
                        {
                           /* if($data_list->datatype=='single'){
                                $singleDataTemplate.= '<li class="formdata text-capitalize"  data-type="'.$data_list->datatype.'" data-med="'.$data_list->medId.'" data-poten="'.$data_list->potenId.'">'.$data_list->medicineName.','.' '.$data_list->potencyname.' ('.$data_list->dilution.') </li>';
                            }else if($data_list->datatype=='mix'){
                                $mixDataTemplate.= '<li class="formdata" data-poten="" data-type="'.$data_list->datatype.'" data-med="'.$data_list->medId.'">'.$data_list->medicineName.'</li>';
                            }*/
							if($data_list->datatype=='single'){
								//In This below line of code we have added the dilution span for displaying in suggestion list, Rahul Khan, 16 Aug 2019
								$singleDataTemplate.= '<li> <button class="formdata text-capitalize btn-default" data-order="cw_'.$i.'" data-potencyname="'.$data_list->potencyname.'" data-dilution="'.$data_list->dilution.'" data-type="'.$data_list->datatype.'" data-med="'.$data_list->medId.'" data-poten="'.$data_list->potenId.'">'.$data_list->medicineName.','.' '.$data_list->potencyname.' ('.$data_list->dilution.') </button> </li>';
							}else if($data_list->datatype=='mix'){
								$mixDataTemplate.= '<li > <button class="formdata btn-default" data-order="cw_'.$i.'" data-type="'.$data_list->datatype.'" data-med="'.$data_list->medId.'">'.$data_list->medicineName.' </button></li>';
							}
                        $i++;
                        }
                    }else{
                        $output.= '<li>No medicine found </li>';
                    }
                    if($singleDataTemplate!=''){
						$output.= '<li class="header">Single</li>'.$singleDataTemplate;
					}
					if($mixDataTemplate!=''){
						$output.= '<li class="header">Mix</li>'.$mixDataTemplate;
					}
                    $output.= '</ul>';
                    
          return Response($output);

      }
    }

    // formlist function is used for medicine and potency name show 
    public function getFormListDropdown($id='', Request $request){
    if($id>0){
        $formdropdown_list = DB::table('medicinetemplate as mt')->select('mtv.medicine_type as mtype','mtv.mixMedicineId as mxId','mtv.tempPotencyId as mpId')
        ->join('medicinetemplatevariant as mtv', 'mtv.medicinetempId', '=', 'mt.id')->where('mt.id', $id)->get();
        foreach($formdropdown_list as $form_details){
            if($form_details->mtype=='single'){
            $form_list = DB::table('medicinegrouppotencies as mgp')->select('pg.form_code as fcode','mgpf.group_id as gId','pg.form_name as fname')
            ->join('medicinegrouppotencyforms as mgpf', 'mgpf.medicinegrouppotency_id', '=', 'mgp.id')
            ->LeftJoin("pricegrouprates as pg",function($join){
                $join->on("pg.pricegroup_id","=","mgpf.group_id")
                    ->on("pg.form_code","=","mgpf.form_code");
                })
            //->join('forms as f', 'f.id', '=', 'mgpf.form_id')
            ->where('mgp.potency_id', $form_details->mpId)
            ->where('mgp.medicine_id', $form_details->mxId)
            ->where('pg.status','=','1')
            ->where('mgp.status','=','1')
            ->where('mgpf.status','=','1')
            ->distinct()
            ->get();
            return response()->json($form_list);
        //   echo '<pre>';
        //  print_r($formdropdown_list);
          }
        }
    }
    if(!empty($request->potency) && count($request->medicine)>0){
        $formdropdown_list = DB::table('medicinegrouppotencies')->select('forms.name as fName','forms.id as fId')
        ->join('medicinegrouppotencyforms', 'medicinegrouppotencyforms.medicinegrouppotency_id', '=', 'medicinegrouppotencies.id')
        ->join('forms', 'forms.id', '=', 'medicinegrouppotencyforms.form_id')
        // ->where('medicinegrouppotencies.medicine_id', $request->medicine)
        ->where('medicinegrouppotencies.potency_id', $request->potency)
        ->distinct()
        ->get();
        return response()->json($formdropdown_list);
        // echo '<pre>';
        // print_r($formdropdown_list);
    }

    } 

    public function create(Request $request){
        $id = 0;
        if($request->id > 0 ){
           $id = $request->id;
        }
    $validator = Validator::make($request->all(), [
        'medicineTempName' => [
            'required',
            Rule::unique('medicinetemplate')->where(function ($query) use($id) {
                $query->where('status','!=','0')->where('id','!=',$id);
            })
        ],
        'pharmacy_instruction' => 'required',
        'status' => 'required'
    ]);
    //if validation fails
    if ($validator->fails()) {
        return array(
        'error' => true,
        'message' => $validator->errors()
        );
    }
    try{

    $medicinetemplate = new Medicinetemplate();
    $medicinetemplate->medicineTempName = $request->medicineTempName;
    $medicinetemplate->pharmacy_instruction = $request->pharmacy_instruction;
    $medicinetemplate->status = $request->status;

    //this below conditional block is used for update records in database 
    $modification_date =  Carbon::now('Asia/Kolkata');
    if((isset($request->id)) && ($request->id > 0) && ($request->template_mixture_name)  && ($request->template_mixture_form_id) && ($request->template_mixture_instruction_id)){
        try{
        if(!empty($request->template_mixture_name) && count($request->template_mixture_name)>=2 && count($request->template_mixture_instruction_id)>=2){
           
            Medicinetemplatevariant::where('medicinetempId', $request->id)->delete();
            foreach($request->template_mixture_name as $key=>$value){
                //last inserted id of medicine template table row
                  $medtemp_id = $request->id;
                  //make a object Medicinetemplatevariant as template_variant
                  $template_variant = new Medicinetemplatevariant();
                  $template_variant->medicinetempId =$medtemp_id;
                  $template_variant->templatemixNo =$request->template_mixture_no[$key];
                  $template_variant->medicineTempMixtureName =$request->template_mixture_name[$key];
                //  $template_variant->tempPotencyId = $request->mixture_potency_form_id[$key];
                  //This below condition is added to resolve Template mix save with mix, Rahul khan, 06 Nov 2019
                if(isset($request->mixture_potency_form_id[$key])){
                    $template_variant->tempPotencyId = $request->mixture_potency_form_id[$key];
                }
                  $template_variant->mixMedicineId =$request->mixture_medicine_id[$key];
                  $template_variant->medicine_type =$request->data_type[$key];
                  if(is_numeric($request->template_mixture_instruction_id[$key])){
                      $template_variant->instructionId = $request->template_mixture_instruction_id[$key];
                      $instruction_id = $request->template_mixture_instruction_id[$key];
                      // get instruction name
                      $ins_name = $this->getInstructions($instruction_id);
                      $template_variant->instruction_name = $ins_name->instruction_name;
                  }else{
                      $template_variant->instruction_other_value =$request->template_mixture_instruction_id[$key];
                  }
                      $list_array = explode('-', $request->template_mixture_form_id[$key]);
                      $form_id = $list_array[0];
                      $form_code = $list_array[1];
                      $form_name = $list_array[2];
                      $template_variant->medicineTempFormName = $form_name;
                      $template_variant->medicineTempFormCode =$form_code;
                      $template_variant->medicineTempFormId =  $form_id;
                    //insert template medicine variant data      
                    $template_variant->save();
                }
                //for template Medicine data
                $item = $medicinetemplate->findOrFail($request->id);
                    if($item){
                    $medicinetemplate->where('id', $request->id)->update(['medicineTempName'=>$medicinetemplate->medicineTempName, 'pharmacy_instruction'=>$medicinetemplate->pharmacy_instruction, 'status'=>$medicinetemplate->status, 'modification_date'=>$modification_date]);
                    $res['error'] = false;
                    $res['actions'] = 'update';
                    return response($res, 200);
                    }

            }else{
                $res['error'] = 'atleasttwomedicine';
                return response($res, 200);
            }
        }catch(\Illuminate\Database\QueryException $ex){
            $res['status'] = false;
            $res['message'] = $ex->getMessage();
            return response($res, 500);
        } 	
        }else{

            if(!empty($request->template_mixture_name) && count($request->template_mixture_name)>=2 && !empty($request->template_mixture_instruction_id) && count($request->template_mixture_instruction_id)>=2 )
            {
                 //insert template medicine data
                $medicinetemplate->save();
               
                foreach($request->template_mixture_name as $key=>$value){
                          //last inserted id of medicine template table row
                            $medtemp_id =  $medicinetemplate->id;
                            //make a object Medicinetemplatevariant as template_variant
                            $template_variant = new Medicinetemplatevariant();
                            $template_variant->medicinetempId =$medtemp_id;
                            $template_variant->templatemixNo =$request->template_mixture_no[$key];
                            $template_variant->medicineTempMixtureName =$request->template_mixture_name[$key];
                           // $template_variant->tempPotencyId = $request->mixture_potency_form_id[$key];
                        //This below condition is added to resolve Template mix save with mix, Rahul khan, 06 Nov 2019
                            if(isset($request->mixture_potency_form_id[$key])){
                                $template_variant->tempPotencyId = $request->mixture_potency_form_id[$key];
                            }
                           
                            $template_variant->mixMedicineId =$request->mixture_medicine_id[$key];
                            $template_variant->medicine_type =$request->data_type[$key];
                            if(is_numeric($request->template_mixture_instruction_id[$key])){
                                $template_variant->instructionId = $request->template_mixture_instruction_id[$key];
                                $instruction_id = $request->template_mixture_instruction_id[$key];
                                // get instruction name
                                $ins_name = $this->getInstructions($instruction_id);
                                $template_variant->instruction_name = $ins_name->instruction_name;
                            }else{
                                $template_variant->instruction_other_value =$request->template_mixture_instruction_id[$key];
                            }
                                $list_array = explode('-', $request->template_mixture_form_id[$key]);
                                $form_id = $list_array[0];
                                $form_code = $list_array[1];
                                $form_name = $list_array[2];
                                $template_variant->medicineTempFormName = $form_name;
                                $template_variant->medicineTempFormCode =$form_code;
                                $template_variant->medicineTempFormId =  $form_id;
                    //insert template medicine variant data      
                   $template_variant->save();
                }
                $res['error'] = false;
                $res['actions'] = 'add';
                return response($res, 200);
            }else{
                $res['error'] = 'atleasttwomedicine';
                return response($res, 200);
            }
        }

        }catch(\Illuminate\Database\QueryException $ex){
        $res['status'] = false;
        $res['message'] = $ex->getMessage();
        return response($res, 500);
        } 	
    }  
 
    public function getRecords($id='',Request $request){
    /*This below condition is used for distinguish edit form request, In this case we get details of perticular medicine */
    if($id > 0){

        return Medicinetemplate::find($id);
    }
    return Medicinetemplate::where('status','!=', '0')->orderBy('id', 'DESC')->get();
    }

    //  Delete Record for particular Medicinemix id
    public function deleteRecords(Request $request)
    {
        $medicinetemplate = Medicinetemplate::findOrFail($request->template_id);
        try{
            if($medicinetemplate){

                    $medicinetemplate->where('id', $request->template_id)->update(['status'=>'0']);
                    $res['error'] = false;
                    return response($res, 200);
            }else{
                    $res['error'] = true;
                    return response($res, 401);
            }
        }catch(\Illuminate\Database\QueryException $ex){
            $res['status'] = false;
            $res['message'] = $ex->getMessage();
            return response($res, 500);
        }
    }

    public function mixmedicinedetails($id='', Request $request){
    if($id>0){
        $templatedetails_list = DB::table('medicinetemplate as mt')->select('mtv.instruction_name as iName', 'mtv.instruction_other_value as oName','mtv.medicine_type as datatype','mtv.tempPotencyId as pId','mtv.mixMedicineId as mId','mtv.medicineTempFormName as form_name','mtv.instructionId as insId','mtv.templatemixNo as mNumber','mt.medicineTempName as mName', 'mt.pharmacy_instruction as piName', 'mtv.medicineTempMixtureName as mixName','pg.form_code as fcode','mtv.medicineTempFormId as gId','pg.form_name as fname')
        ->LeftJoin('medicinetemplatevariant as mtv', 'mtv.medicinetempId', '=', 'mt.id')
        ->LeftJoin("pricegrouprates as pg",function($join){
            $join->on("pg.pricegroup_id","=","mtv.medicineTempFormId")
                ->on("pg.form_code","=","mtv.medicineTempFormCode");
            })
        ->where('mt.id', '=', $id)
       // ->where('mt.status', '=', '1')
		->where('mt.status', '!=', '0')
        ->where('mtv.status', '=', '1')
        ->where('pg.status','=','1')
        ->orderBy('mtv.id', 'ASC')
        ->get();
        return response()->json($templatedetails_list);
    }else{
        if(!empty($request->template_id)){
            $templatedetails_list = DB::table('medicinetemplate as mt')->select('p.name as medicine_group_name','mtv.instruction_name as iName', 'mtv.instruction_other_value as oName','mtv.medicine_type as datatype','mtv.tempPotencyId as pId','mtv.mixMedicineId as mId','mt.medicineTempName as mName', 'mt.pharmacy_instruction as piName', 'mtv.medicineTempMixtureName as mixName','pg.form_code as fcode','mtv.medicineTempFormId as gId','pg.form_name as fname','pg.rate as form_rate')
            ->LeftJoin('medicinetemplatevariant as mtv', 'mtv.medicinetempId', '=', 'mt.id')
            ->LeftJoin("pricegrouprates as pg",function($join){
                $join->on("pg.pricegroup_id","=","mtv.medicineTempFormId")
                    ->on("pg.form_code","=","mtv.medicineTempFormCode");
                })
            ->LeftJoin('pricegroups as p', 'p.id', '=', 'mtv.medicineTempFormId')
            ->where('mt.id', '=', $request->template_id)
            ->where('pg.status','=','1')
            ->where('mtv.status','=','1')
            ->where('mt.status', '!=', '0')
            ->get();
            return response()->json($templatedetails_list);
            // echo '<pre>';
            // print_r($templatedetails_list);
            
        }
    }
    }
}
