<?php

namespace App\Modules\Prints\Http\Controllers;
use Illuminate\Http\Request;
use App\Http\Requests;
use Illuminate\Support\Facades\Validator;
use Illuminate\Validation\ValidationException;
use App\Http\Controllers\Controller;
use App\Modules\Prints\Models\prints;
use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\DB;
use App\Modules\User\Models\DoctorPrints;

class printController extends Controller
{
	//This below function is used for getting the Getting the all Prescription Type print format
	public function getPrescriptionPrint(Request $request){
		try{
				return prints::select('title','id')->where('status', '!=', '0')->where('print_code','PRS')->orderBy('title', 'ASC')->paginate(10);
		}catch(\Illuminate\Database\QueryException $ex){
			$res['status'] = false;
			$res['message'] = $ex->getMessage();
			return response($res, 500);

		}
	}
	
	//This below function is used for getting the Getting the all Receipt Type print format
	public function getReceiptPrint(Request $request){
		try{
				return prints::select('title','id')->where('status', '!=', '0')->where('print_code','RCP')->orderBy('title', 'ASC')->paginate(10);
		}catch(\Illuminate\Database\QueryException $ex){
			$res['status'] = false;
			$res['message'] = $ex->getMessage();
			return response($res, 500);
		}
	}
	
	//This below function is used for getting the Getting the Particular print format
	public function getPrintformat($id ='',$type ='',Request $request){
		try{
			if($id > 0){
				$printContent = prints::find($id);
			}else{
				 $printContent = prints::where('print_code', $type)->where('default', 1)->first();
			}
			$printContent->content = base64_decode($printContent->content);
			$printContent->footer_content = base64_decode($printContent->footer_content);
			return $printContent;
		}catch(\Illuminate\Database\QueryException $ex){
			$res['status'] = false;
			$res['message'] = $ex->getMessage();
			return response($res, 500);
		}
	}
	//This below function is used for getting the Getting the doctor prescription print format
	public function getDoctorPrsFormat($id ='',Request $request){
		try{
			$print_id = 0;
			$prescriptionFormat = DoctorPrints::select('print_id')->where('user_id', $id)->where('print_type','PRS')->first();
			if($prescriptionFormat){
				$print_id = $prescriptionFormat->print_id;
			}
				return	$this->getPrintformat($print_id,'PRS',$request);
		}catch(\Illuminate\Database\QueryException $ex){
			$res['status'] = false;
			$res['message'] = $ex->getMessage();
			return response($res, 500);
		}
	}
	//This below function is used for getting the Getting the doctor receipt print format
	public function getDoctorRcpFormat($id ='',Request $request){
		try{
			$print_id = 0;
			$prescriptionFormat = DoctorPrints::select('print_id')->where('user_id', $id)->where('print_type','RCP')->first();
			if($prescriptionFormat){
				$print_id = $prescriptionFormat->print_id;
			}
				return	$this->getPrintformat($print_id,'RCP',$request);
		}catch(\Illuminate\Database\QueryException $ex){
			$res['status'] = false;
			$res['message'] = $ex->getMessage();
			return response($res, 500);
		}
	}
	
}

