<?php
namespace App\Modules\Reports\Http\Controllers;
use Illuminate\Http\Request;
use App\Http\Requests;
use App\Http\Controllers\Controller;
use Illuminate\Validation\ValidationException;
use Illuminate\Support\Facades\Validator;
use Carbon\Carbon;
use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\IOFactory;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;
use Illuminate\Support\Facades\DB;
use App\Modules\Billing\Models\Payment;
use App\Modules\Billing\Models\visitPaymentModes;
use GuzzleHttp\Client; 

class ReportController extends Controller
{
  /* For search if a mode id has been added into $mode_price, returns the key (index) */
	public function mode_exists($modename, $array) {
			$result = -1;
			for($i=0; $i<sizeof($array); $i++) {
				if ($array[$i]['mode_id'] == $modename) {
					$result = $i;
					break;
				}
			}
			return $result;
		 }
    public function transactionHistory(Request $request){
			$amt= array();
			$refund_amount_array= array();
			$Core_Api_root = env('CORE_API_ROOT', true);
			//$Core_Api_root = "http://18.139.252.80:4300/";
			$client = new Client();
			$from_date = $request->from_export_date;
			$to_date = $request->to_export_date;
			$from_new_date = date_create($from_date);
			$formdate= date_format($from_new_date, "d-M-Y");
			$to_new_date = date_create($to_date);
			$todate= date_format($to_new_date, "d-M-Y");
			$file_name= $formdate.'-'.$todate;

				/*****************************Transactional report details********************************/
				$res_transaction_completed = $client->request('GET', $Core_Api_root.'appointments/transactionaldetails',[
					'query' => ['from_date' => $request->from_export_date, 'to_date'=>$request->to_export_date]
				]);
				if ($res_transaction_completed->getStatusCode() == 200){ 
					// 200 OK
					$result_transaction_completed = $res_transaction_completed->getBody()->getContents();
				}

				 $result_transaction_completed = json_decode($result_transaction_completed);
				
				 // echo '<pre>';
				 // print_r($result_transaction_completed);
				 // echo '</pre>';

			/*************************************************************************/
			    $objPHPExcel = new Spreadsheet();
				$objPHPExcel->setActiveSheetIndex(0);
				$i = 1;
				$objPHPExcel->getActiveSheet()->SetCellValue('A'.$i, 'S.No.');
				$objPHPExcel->getActiveSheet()->SetCellValue('B'.$i, 'Patient ID');
				$objPHPExcel->getActiveSheet()->SetCellValue('C'.$i, 'Patient Name');
				$objPHPExcel->getActiveSheet()->SetCellValue('D'.$i, 'Transaction Date');
				$objPHPExcel->getActiveSheet()->SetCellValue('E'.$i, 'Transaction Time');
				$objPHPExcel->getActiveSheet()->SetCellValue('F'.$i, 'Shift');
				$objPHPExcel->getActiveSheet()->SetCellValue('G'.$i, 'Location');
				$objPHPExcel->getActiveSheet()->SetCellValue('H'.$i, 'Amount Received');
				$objPHPExcel->getActiveSheet()->SetCellValue('I'.$i, 'Amount Refunded');
				$objPHPExcel->getActiveSheet()->SetCellValue('J'.$i, 'Mode of Payment');
				$objPHPExcel->getActiveSheet()->getStyle('A1:O1')->getFont()->setBold(true);
				$objPHPExcel->getActiveSheet()->getStyle('A1:O1')->getFont()->setSize(16);
				$objPHPExcel->getActiveSheet()->freezePane('A2');
				
				foreach($result_transaction_completed->data as $key=>$rs_completed){
					 $i++;

					if($rs_completed->OldRegistrationNo){
						$registerationNo = $rs_completed->OldRegistrationNo;
					} else{
						$registerationNo =  'NP';
					}
					if($rs_completed->shift_id==1){
						$login_shift = 'M';
					} else{
						$login_shift =  'E';
					}

					if($rs_completed->refund_flag==1){

						//$refund_amount = '-'.$rs_completed->mode_price;
						$refund_amount = $rs_completed->mode_price;
						$mode_amount = 0;

					}else{

						$refund_amount = 0;
						$mode_amount = $rs_completed->mode_price;
					}

					$transaction_date = date("d-M-Y",strtotime($rs_completed->transaction_date));
					$transaction_time = date("H:i:s",strtotime($rs_completed->transaction_date));

					if($rs_completed->middle_name!=''){

						$patient_name = ucwords($rs_completed->first_name)." ".ucwords($rs_completed->middle_name)." ".ucwords($rs_completed->last_name);
					}else{
						$patient_name = ucwords($rs_completed->first_name)." ".ucwords($rs_completed->last_name);
					}
					$objPHPExcel->getActiveSheet()->SetCellValue('A'.$i, (int)($i - 1));
					$objPHPExcel->getActiveSheet()->SetCellValue('B'.$i, $registerationNo);
					$objPHPExcel->getActiveSheet()->SetCellValue('C'.$i, $patient_name);
					$objPHPExcel->getActiveSheet()->SetCellValue('D'.$i, $transaction_date);
					$objPHPExcel->getActiveSheet()->SetCellValue('E'.$i, $transaction_time);
					$objPHPExcel->getActiveSheet()->SetCellValue('F'.$i, $login_shift);
					$objPHPExcel->getActiveSheet()->SetCellValue('G'.$i, $rs_completed->branch);
					$objPHPExcel->getActiveSheet()->SetCellValue('H'.$i, $mode_amount);
					$objPHPExcel->getActiveSheet()->SetCellValue('I'.$i, $refund_amount);
					$objPHPExcel->getActiveSheet()->SetCellValue('J'.$i, $rs_completed->transaction_mode);
				}
					$objPHPExcel->getActiveSheet()->setTitle("Transactional Detials");
					header('Content-Type: application/vnd.ms-excel');
					header('Content-Disposition: attachment;filename="Transactional_Reports_'.$file_name.'.xlsx"');
					header('Cache-Control: max-age=0');
				    $writer = new Xlsx($objPHPExcel);
				    $writer->save('php://output');
		}
}
