<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateDoctorPrintsTable extends Migration
{
	/**
	 * Run the migrations.
	 *
	 * @return void
	 */
	public function up()
	{
		Schema::create('doctor_prints', function(Blueprint $table)
		{
			$table->increments('id');
			$table->integer('user_id')->unsigned();
			$table->integer('print_id')->unsigned();
			$table->string('print_type',16);
			$table->foreign('user_id')->references('user_id')->on('users');
			$table->foreign('print_id')->references('id')->on('prints');
			$table->enum('status', ['0', '1', '2'])->default(1);
			$table->integer('modified_by');
			$table->timestamp('modification_date');
			$table->integer('created_by');
			$table->timestamp('creation_date');
		});
	}

	/**
	 * Reverse the migrations.
	 *
	 * @return void
	 */
	public function down()
	{
		Schema::dropIfExists('doctor_prints');
	}
}
