<?php
use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;
class VisitStatus extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('visit_status', function(Blueprint $table)
        {
            $table->increments('id');
            $table->char('patient_id', 36);
            $table->integer('appointment_id')->unsigned();
            $table->integer('billing_id')->unsigned();
            $table->integer('visit_status')->unsigned();
            $table->integer('created_by');
            $table->timestamp('creation_date');
            $table->integer('modified_by');
            $table->timestamp('modification_date');
            $table->foreign('billing_id')->references('id')->on('billing')->onDelete('cascade');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::drop('visit_status');
    }
}
