<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateClUsersTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('cl_users', function (Blueprint $table) {
            $table->increments('id');
            $table->char('user_id', 36)->unique();
            $table->string('Name', 250);
            $table->string('username', 100);
            $table->binary('password');
            $table->integer('user_type');
            $table->string('email', 50);
            $table->string('mobile_no', 15);
            $table->integer('branch_id');
            $table->string('label', 10);
            $table->integer('ordering');
            $table->integer('created_by');
            $table->timestamp('creation_date');
            $table->integer('modified_by');
            $table->timestamp('modification_date');
            $table->enum('status', ['0', '1', '2']);
            $table->rememberToken();
            $table->index(['user_type'], 'user_type');
            $table->index(['branch_id'], 'branch_id');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('cl_users');
    }
}
