<?php

/*
|--------------------------------------------------------------------------
| Application Routes
|--------------------------------------------------------------------------
|
| Here is where you can register all of the routes for an application.
| It is a breeze. Simply tell Lumen the URIs it should respond to
| and give it the Closure to call when that URI is requested.
|
*/

$app->get('/', function () use ($app) {
    return $app->version();
});


/***
 * The first parameter 'createuser' it is the url address
 * So to call this we will use the URL as BASE URL + createuser
 *
 * The second parameter is UserController@create
 * it means we are calling create function which is inside UserController
 *
 * Using the same for all routes
 ***/

$app->post('/login', ['middleware'=>'cors', 'uses'=>'UserController@login']);

$app->post('/createuser', ['middleware'=>'cors', 'uses'=>'UserController@create']);

$app->group(['middleware'=>'cors','prefix' => '/settings'], function ($app) {
        $app->post('/masters/pricegroup/add','PricegroupController@create');
        $app->get('/masters/pricegroup/get','PricegroupController@getRecords');
        $app->get('/masters/pricegroup/get','PricegroupController@getRecords');
        $app->get('/masters/pricegroup/get/{id}','PricegroupController@getRecords');
        $app->post('/masters/pricegroup/delete/{id}','PricegroupController@deleteRecords');

  });

